/**
 * 
 *
 * Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
 */
 
/**
 * UMD load definition that supports AMD, CommonJS and browser globals.
 * https://github.com/umdjs/umd/blob/992cc0d071b7ebcd7feaad2a5349bdbeab09a0fe/commonjsStrict.js
 */
(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['exports'], factory);
  } else if (typeof exports === 'object') {
    // CommonJS
    factory(exports);
  } else {
    // Browser globals
    factory(root.javascriptClient = {});
  }
}(this, function (exports) {
 
 'use strict';
 

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinPath = class {

    /**
     * Constructs a XJoinPath from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['edges'] !== 'undefined') {
            this.edges = new exports.Org.Apache.Lens.Api.Metastore.XJoinEdges(o['edges']);
        }
    }

    /**
     * possible object is
       * XJoinEdges 
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinEdges
     */
    getEdges() {
        return this.edges;
    }

    /**
     * possible object is
       * XJoinEdges 
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinEdges edges
     */
    setEdges(edges) {
        this.edges = edges;
    }

    /**
     * Returns a JSON object for this XJoinPath
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.edges !== 'undefined') {
            json['edges'] = this.edges.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XFlattenedColumns = class {

    /**
     * Constructs a XFlattenedColumns from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.flattenedColumn = [];
        if (o['flattenedColumn']) {
            o['flattenedColumn'].forEach(function(x, i){
                self.flattenedColumn[i] = new exports.Org.Apache.Lens.Api.Metastore.XFlattenedColumn(x);
            });
        }
    }

    /**
     * Gets the value of the flattenedColumn property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the flattenedColumn property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getFlattenedColumn().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XFlattenedColumn
     *
     * @return Org.Apache.Lens.Api.Metastore.XFlattenedColumn[]
     */
    getFlattenedColumn() {
        return this.flattenedColumn;
    }

    /**
     * Gets the value of the flattenedColumn property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the flattenedColumn property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getFlattenedColumn().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XFlattenedColumn
     *
     * @param Org.Apache.Lens.Api.Metastore.XFlattenedColumn[] flattenedColumn
     */
    setFlattenedColumn(flattenedColumn) {
        this.flattenedColumn = flattenedColumn;
    }

    /**
     * Returns a JSON object for this XFlattenedColumns
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.flattenedColumn) {
            json['flattenedColumn'] = [];
            this.flattenedColumn.forEach(function(x, i){
                json['flattenedColumn'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimensionTable = class {

    /**
     * Constructs a XDimensionTable from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['columns'] !== 'undefined') {
            this.columns = new exports.Org.Apache.Lens.Api.Metastore.XColumns(o['columns']);
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['storageTables'] !== 'undefined') {
            this.storageTables = new exports.Org.Apache.Lens.Api.Metastore.XStorageTables(o['storageTables']);
        }
        if (typeof o['dimensionName'] !== 'undefined') {
            this.dimensionName = o['dimensionName'];
        }
        if (typeof o['tableName'] !== 'undefined') {
            this.tableName = o['tableName'];
        }
        if (typeof o['weight'] !== 'undefined') {
            this.weight = o['weight'];
        }
    }

    /**
     * possible object is
       * XColumns 
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumns
     */
    getColumns() {
        return this.columns;
    }

    /**
     * possible object is
       * XColumns 
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumns columns
     */
    setColumns(columns) {
        this.columns = columns;
    }
    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * possible object is
       * XStorageTables 
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTables
     */
    getStorageTables() {
        return this.storageTables;
    }

    /**
     * possible object is
       * XStorageTables 
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTables storageTables
     */
    setStorageTables(storageTables) {
        this.storageTables = storageTables;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDimensionName() {
        return this.dimensionName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string dimensionName
     */
    setDimensionName(dimensionName) {
        this.dimensionName = dimensionName;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getTableName() {
        return this.tableName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string tableName
     */
    setTableName(tableName) {
        this.tableName = tableName;
    }
    /**
     * Gets the value of the weight property.
     *
     * @return double
     */
    getWeight() {
        return this.weight;
    }

    /**
     * Gets the value of the weight property.
     *
     * @param double weight
     */
    setWeight(weight) {
        this.weight = weight;
    }

    /**
     * Returns a JSON object for this XDimensionTable
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.columns !== 'undefined') {
            json['columns'] = this.columns.toJSON();
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.storageTables !== 'undefined') {
            json['storageTables'] = this.storageTables.toJSON();
        }
        if (typeof this.dimensionName !== 'undefined') {
            json['dimensionName'] = this.dimensionName;
        }
        if (typeof this.tableName !== 'undefined') {
            json['tableName'] = this.tableName;
        }
        if (typeof this.weight !== 'undefined') {
            json['weight'] = this.weight;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc = class {

    /**
     * Constructs a XStorageTableDesc from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['partCols'] !== 'undefined') {
            this.partCols = new exports.Org.Apache.Lens.Api.Metastore.XColumns(o['partCols']);
        }
        if (typeof o['tableParameters'] !== 'undefined') {
            this.tableParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['tableParameters']);
        }
        if (typeof o['serdeParameters'] !== 'undefined') {
            this.serdeParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['serdeParameters']);
        }
        this.bucketCols = [];
        if (o['bucketCols']) {
            o['bucketCols'].forEach(function(x, i){
                self.bucketCols[i] = x;
            });
        }
        this.sortCols = [];
        if (o['sortCols']) {
            o['sortCols'].forEach(function(x, i){
                self.sortCols[i] = x;
            });
        }
        this.sortColOrder = [];
        if (o['sortColOrder']) {
            o['sortColOrder'].forEach(function(x, i){
                self.sortColOrder[i] = x;
            });
        }
        this.skewedInfo = [];
        if (o['skewedInfo']) {
            o['skewedInfo'].forEach(function(x, i){
                self.skewedInfo[i] = new exports.Org.Apache.Lens.Api.Metastore.XSkewedInfo(x);
            });
        }
        this.timePartCols = [];
        if (o['timePartCols']) {
            o['timePartCols'].forEach(function(x, i){
                self.timePartCols[i] = x;
            });
        }
        if (typeof o['external'] !== 'undefined') {
            this.external = o['external'];
        }
        if (typeof o['tableLocation'] !== 'undefined') {
            this.tableLocation = o['tableLocation'];
        }
        if (typeof o['inputFormat'] !== 'undefined') {
            this.inputFormat = o['inputFormat'];
        }
        if (typeof o['outputFormat'] !== 'undefined') {
            this.outputFormat = o['outputFormat'];
        }
        if (typeof o['fieldDelimiter'] !== 'undefined') {
            this.fieldDelimiter = o['fieldDelimiter'];
        }
        if (typeof o['escapeChar'] !== 'undefined') {
            this.escapeChar = o['escapeChar'];
        }
        if (typeof o['collectionDelimiter'] !== 'undefined') {
            this.collectionDelimiter = o['collectionDelimiter'];
        }
        if (typeof o['lineDelimiter'] !== 'undefined') {
            this.lineDelimiter = o['lineDelimiter'];
        }
        if (typeof o['mapKeyDelimiter'] !== 'undefined') {
            this.mapKeyDelimiter = o['mapKeyDelimiter'];
        }
        if (typeof o['serdeClassName'] !== 'undefined') {
            this.serdeClassName = o['serdeClassName'];
        }
        if (typeof o['storageHandlerName'] !== 'undefined') {
            this.storageHandlerName = o['storageHandlerName'];
        }
        if (typeof o['numBuckets'] !== 'undefined') {
            this.numBuckets = o['numBuckets'];
        }
        if (typeof o['compressed'] !== 'undefined') {
            this.compressed = o['compressed'];
        }
    }

    /**
     * possible object is
       * XColumns 
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumns
     */
    getPartCols() {
        return this.partCols;
    }

    /**
     * possible object is
       * XColumns 
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumns partCols
     */
    setPartCols(partCols) {
        this.partCols = partCols;
    }
    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getTableParameters() {
        return this.tableParameters;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties tableParameters
     */
    setTableParameters(tableParameters) {
        this.tableParameters = tableParameters;
    }
    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getSerdeParameters() {
        return this.serdeParameters;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties serdeParameters
     */
    setSerdeParameters(serdeParameters) {
        this.serdeParameters = serdeParameters;
    }
    /**
     * Gets the value of the bucketCols property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the bucketCols property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getBucketCols().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @return string[]
     */
    getBucketCols() {
        return this.bucketCols;
    }

    /**
     * Gets the value of the bucketCols property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the bucketCols property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getBucketCols().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @param string[] bucketCols
     */
    setBucketCols(bucketCols) {
        this.bucketCols = bucketCols;
    }
    /**
     * Gets the value of the sortCols property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the sortCols property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSortCols().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @return string[]
     */
    getSortCols() {
        return this.sortCols;
    }

    /**
     * Gets the value of the sortCols property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the sortCols property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSortCols().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @param string[] sortCols
     */
    setSortCols(sortCols) {
        this.sortCols = sortCols;
    }
    /**
     * Gets the value of the sortColOrder property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the sortColOrder property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSortColOrder().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * Integer
     *
     * @return integer[]
     */
    getSortColOrder() {
        return this.sortColOrder;
    }

    /**
     * Gets the value of the sortColOrder property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the sortColOrder property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSortColOrder().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * Integer
     *
     * @param integer[] sortColOrder
     */
    setSortColOrder(sortColOrder) {
        this.sortColOrder = sortColOrder;
    }
    /**
     * Gets the value of the skewedInfo property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the skewedInfo property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSkewedInfo().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSkewedInfo
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewedInfo[]
     */
    getSkewedInfo() {
        return this.skewedInfo;
    }

    /**
     * Gets the value of the skewedInfo property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the skewedInfo property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSkewedInfo().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSkewedInfo
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewedInfo[] skewedInfo
     */
    setSkewedInfo(skewedInfo) {
        this.skewedInfo = skewedInfo;
    }
    /**
     * Gets the value of the timePartCols property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the timePartCols property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getTimePartCols().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @return string[]
     */
    getTimePartCols() {
        return this.timePartCols;
    }

    /**
     * Gets the value of the timePartCols property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the timePartCols property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getTimePartCols().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @param string[] timePartCols
     */
    setTimePartCols(timePartCols) {
        this.timePartCols = timePartCols;
    }
    /**
     * Gets the value of the external property.
     *
     * @return boolean
     */
    getExternal() {
        return this.external;
    }

    /**
     * Gets the value of the external property.
     *
     * @param boolean external
     */
    setExternal(external) {
        this.external = external;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getTableLocation() {
        return this.tableLocation;
    }

    /**
     * possible object is
       * String 
     *
     * @param string tableLocation
     */
    setTableLocation(tableLocation) {
        this.tableLocation = tableLocation;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getInputFormat() {
        return this.inputFormat;
    }

    /**
     * possible object is
       * String 
     *
     * @param string inputFormat
     */
    setInputFormat(inputFormat) {
        this.inputFormat = inputFormat;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getOutputFormat() {
        return this.outputFormat;
    }

    /**
     * possible object is
       * String 
     *
     * @param string outputFormat
     */
    setOutputFormat(outputFormat) {
        this.outputFormat = outputFormat;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getFieldDelimiter() {
        return this.fieldDelimiter;
    }

    /**
     * possible object is
       * String 
     *
     * @param string fieldDelimiter
     */
    setFieldDelimiter(fieldDelimiter) {
        this.fieldDelimiter = fieldDelimiter;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getEscapeChar() {
        return this.escapeChar;
    }

    /**
     * possible object is
       * String 
     *
     * @param string escapeChar
     */
    setEscapeChar(escapeChar) {
        this.escapeChar = escapeChar;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getCollectionDelimiter() {
        return this.collectionDelimiter;
    }

    /**
     * possible object is
       * String 
     *
     * @param string collectionDelimiter
     */
    setCollectionDelimiter(collectionDelimiter) {
        this.collectionDelimiter = collectionDelimiter;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getLineDelimiter() {
        return this.lineDelimiter;
    }

    /**
     * possible object is
       * String 
     *
     * @param string lineDelimiter
     */
    setLineDelimiter(lineDelimiter) {
        this.lineDelimiter = lineDelimiter;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getMapKeyDelimiter() {
        return this.mapKeyDelimiter;
    }

    /**
     * possible object is
       * String 
     *
     * @param string mapKeyDelimiter
     */
    setMapKeyDelimiter(mapKeyDelimiter) {
        this.mapKeyDelimiter = mapKeyDelimiter;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getSerdeClassName() {
        return this.serdeClassName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string serdeClassName
     */
    setSerdeClassName(serdeClassName) {
        this.serdeClassName = serdeClassName;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getStorageHandlerName() {
        return this.storageHandlerName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string storageHandlerName
     */
    setStorageHandlerName(storageHandlerName) {
        this.storageHandlerName = storageHandlerName;
    }
    /**
     * possible object is
       * Integer 
     *
     * @return integer
     */
    getNumBuckets() {
        return this.numBuckets;
    }

    /**
     * possible object is
       * Integer 
     *
     * @param integer numBuckets
     */
    setNumBuckets(numBuckets) {
        this.numBuckets = numBuckets;
    }
    /**
     * possible object is
       * Boolean 
     *
     * @return boolean
     */
    getCompressed() {
        return this.compressed;
    }

    /**
     * possible object is
       * Boolean 
     *
     * @param boolean compressed
     */
    setCompressed(compressed) {
        this.compressed = compressed;
    }

    /**
     * Returns a JSON object for this XStorageTableDesc
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.partCols !== 'undefined') {
            json['partCols'] = this.partCols.toJSON();
        }
        if (typeof this.tableParameters !== 'undefined') {
            json['tableParameters'] = this.tableParameters.toJSON();
        }
        if (typeof this.serdeParameters !== 'undefined') {
            json['serdeParameters'] = this.serdeParameters.toJSON();
        }
        if (this.bucketCols) {
            json['bucketCols'] = [];
            this.bucketCols.forEach(function(x, i){
                json['bucketCols'][i] = x;
            });
        }
        if (this.sortCols) {
            json['sortCols'] = [];
            this.sortCols.forEach(function(x, i){
                json['sortCols'][i] = x;
            });
        }
        if (this.sortColOrder) {
            json['sortColOrder'] = [];
            this.sortColOrder.forEach(function(x, i){
                json['sortColOrder'][i] = x;
            });
        }
        if (this.skewedInfo) {
            json['skewedInfo'] = [];
            this.skewedInfo.forEach(function(x, i){
                json['skewedInfo'][i] = x.toJSON();
            });
        }
        if (this.timePartCols) {
            json['timePartCols'] = [];
            this.timePartCols.forEach(function(x, i){
                json['timePartCols'][i] = x;
            });
        }
        if (typeof this.external !== 'undefined') {
            json['external'] = this.external;
        }
        if (typeof this.tableLocation !== 'undefined') {
            json['tableLocation'] = this.tableLocation;
        }
        if (typeof this.inputFormat !== 'undefined') {
            json['inputFormat'] = this.inputFormat;
        }
        if (typeof this.outputFormat !== 'undefined') {
            json['outputFormat'] = this.outputFormat;
        }
        if (typeof this.fieldDelimiter !== 'undefined') {
            json['fieldDelimiter'] = this.fieldDelimiter;
        }
        if (typeof this.escapeChar !== 'undefined') {
            json['escapeChar'] = this.escapeChar;
        }
        if (typeof this.collectionDelimiter !== 'undefined') {
            json['collectionDelimiter'] = this.collectionDelimiter;
        }
        if (typeof this.lineDelimiter !== 'undefined') {
            json['lineDelimiter'] = this.lineDelimiter;
        }
        if (typeof this.mapKeyDelimiter !== 'undefined') {
            json['mapKeyDelimiter'] = this.mapKeyDelimiter;
        }
        if (typeof this.serdeClassName !== 'undefined') {
            json['serdeClassName'] = this.serdeClassName;
        }
        if (typeof this.storageHandlerName !== 'undefined') {
            json['storageHandlerName'] = this.storageHandlerName;
        }
        if (typeof this.numBuckets !== 'undefined') {
            json['numBuckets'] = this.numBuckets;
        }
        if (typeof this.compressed !== 'undefined') {
            json['compressed'] = this.compressed;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XExprSpec = class {

    /**
     * Constructs a XExprSpec from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['expr'] !== 'undefined') {
            this.expr = o['expr'];
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getExpr() {
        return this.expr;
    }

    /**
     * possible object is
       * String 
     *
     * @param string expr
     */
    setExpr(expr) {
        this.expr = expr;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }

    /**
     * Returns a JSON object for this XExprSpec
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.expr !== 'undefined') {
            json['expr'] = this.expr;
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XProperty = class {

    /**
     * Constructs a XProperty from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getValue() {
        return this.value;
    }

    /**
     * possible object is
       * String 
     *
     * @param string value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XProperty
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartition = class {

    /**
     * Constructs a XPartition from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['nonTimePartitionSpec'] !== 'undefined') {
            this.nonTimePartitionSpec = new exports.Org.Apache.Lens.Api.Metastore.XPartSpec(o['nonTimePartitionSpec']);
        }
        if (typeof o['timePartitionSpec'] !== 'undefined') {
            this.timePartitionSpec = new exports.Org.Apache.Lens.Api.Metastore.XTimePartSpec(o['timePartitionSpec']);
        }
        if (typeof o['fullPartitionSpec'] !== 'undefined') {
            this.fullPartitionSpec = new exports.Org.Apache.Lens.Api.Metastore.XPartSpec(o['fullPartitionSpec']);
        }
        if (typeof o['partitionParameters'] !== 'undefined') {
            this.partitionParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['partitionParameters']);
        }
        if (typeof o['serdeParameters'] !== 'undefined') {
            this.serdeParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['serdeParameters']);
        }
        if (typeof o['factOrDimensionTableName'] !== 'undefined') {
            this.factOrDimensionTableName = o['factOrDimensionTableName'];
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['location'] !== 'undefined') {
            this.location = o['location'];
        }
        if (typeof o['inputFormat'] !== 'undefined') {
            this.inputFormat = o['inputFormat'];
        }
        if (typeof o['outputFormat'] !== 'undefined') {
            this.outputFormat = o['outputFormat'];
        }
        if (typeof o['serdeClassname'] !== 'undefined') {
            this.serdeClassname = o['serdeClassname'];
        }
        if (typeof o['updatePeriod'] !== 'undefined') {
            this.updatePeriod = o['updatePeriod'];
        }
    }

    /**
     * possible object is
       * XPartSpec 
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartSpec
     */
    getNonTimePartitionSpec() {
        return this.nonTimePartitionSpec;
    }

    /**
     * possible object is
       * XPartSpec 
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartSpec nonTimePartitionSpec
     */
    setNonTimePartitionSpec(nonTimePartitionSpec) {
        this.nonTimePartitionSpec = nonTimePartitionSpec;
    }
    /**
     * possible object is
       * XTimePartSpec 
     *
     * @return Org.Apache.Lens.Api.Metastore.XTimePartSpec
     */
    getTimePartitionSpec() {
        return this.timePartitionSpec;
    }

    /**
     * possible object is
       * XTimePartSpec 
     *
     * @param Org.Apache.Lens.Api.Metastore.XTimePartSpec timePartitionSpec
     */
    setTimePartitionSpec(timePartitionSpec) {
        this.timePartitionSpec = timePartitionSpec;
    }
    /**
     * possible object is
       * XPartSpec 
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartSpec
     */
    getFullPartitionSpec() {
        return this.fullPartitionSpec;
    }

    /**
     * possible object is
       * XPartSpec 
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartSpec fullPartitionSpec
     */
    setFullPartitionSpec(fullPartitionSpec) {
        this.fullPartitionSpec = fullPartitionSpec;
    }
    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getPartitionParameters() {
        return this.partitionParameters;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties partitionParameters
     */
    setPartitionParameters(partitionParameters) {
        this.partitionParameters = partitionParameters;
    }
    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getSerdeParameters() {
        return this.serdeParameters;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties serdeParameters
     */
    setSerdeParameters(serdeParameters) {
        this.serdeParameters = serdeParameters;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getFactOrDimensionTableName() {
        return this.factOrDimensionTableName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string factOrDimensionTableName
     */
    setFactOrDimensionTableName(factOrDimensionTableName) {
        this.factOrDimensionTableName = factOrDimensionTableName;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getLocation() {
        return this.location;
    }

    /**
     * possible object is
       * String 
     *
     * @param string location
     */
    setLocation(location) {
        this.location = location;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getInputFormat() {
        return this.inputFormat;
    }

    /**
     * possible object is
       * String 
     *
     * @param string inputFormat
     */
    setInputFormat(inputFormat) {
        this.inputFormat = inputFormat;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getOutputFormat() {
        return this.outputFormat;
    }

    /**
     * possible object is
       * String 
     *
     * @param string outputFormat
     */
    setOutputFormat(outputFormat) {
        this.outputFormat = outputFormat;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getSerdeClassname() {
        return this.serdeClassname;
    }

    /**
     * possible object is
       * String 
     *
     * @param string serdeClassname
     */
    setSerdeClassname(serdeClassname) {
        this.serdeClassname = serdeClassname;
    }
    /**
     * possible object is
       * XUpdatePeriod 
     *
     * @return string
     */
    getUpdatePeriod() {
        return this.updatePeriod;
    }

    /**
     * possible object is
       * XUpdatePeriod 
     *
     * @param string updatePeriod
     */
    setUpdatePeriod(updatePeriod) {
        this.updatePeriod = updatePeriod;
    }

    /**
     * Returns a JSON object for this XPartition
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.nonTimePartitionSpec !== 'undefined') {
            json['nonTimePartitionSpec'] = this.nonTimePartitionSpec.toJSON();
        }
        if (typeof this.timePartitionSpec !== 'undefined') {
            json['timePartitionSpec'] = this.timePartitionSpec.toJSON();
        }
        if (typeof this.fullPartitionSpec !== 'undefined') {
            json['fullPartitionSpec'] = this.fullPartitionSpec.toJSON();
        }
        if (typeof this.partitionParameters !== 'undefined') {
            json['partitionParameters'] = this.partitionParameters.toJSON();
        }
        if (typeof this.serdeParameters !== 'undefined') {
            json['serdeParameters'] = this.serdeParameters.toJSON();
        }
        if (typeof this.factOrDimensionTableName !== 'undefined') {
            json['factOrDimensionTableName'] = this.factOrDimensionTableName;
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.location !== 'undefined') {
            json['location'] = this.location;
        }
        if (typeof this.inputFormat !== 'undefined') {
            json['inputFormat'] = this.inputFormat;
        }
        if (typeof this.outputFormat !== 'undefined') {
            json['outputFormat'] = this.outputFormat;
        }
        if (typeof this.serdeClassname !== 'undefined') {
            json['serdeClassname'] = this.serdeClassname;
        }
        if (typeof this.updatePeriod !== 'undefined') {
            json['updatePeriod'] = this.updatePeriod;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XChainColumn = class {

    /**
     * Constructs a XChainColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['chainName'] !== 'undefined') {
            this.chainName = o['chainName'];
        }
        if (typeof o['refCol'] !== 'undefined') {
            this.refCol = o['refCol'];
        }
        if (typeof o['destTable'] !== 'undefined') {
            this.destTable = o['destTable'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getChainName() {
        return this.chainName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string chainName
     */
    setChainName(chainName) {
        this.chainName = chainName;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getRefCol() {
        return this.refCol;
    }

    /**
     * possible object is
       * String 
     *
     * @param string refCol
     */
    setRefCol(refCol) {
        this.refCol = refCol;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDestTable() {
        return this.destTable;
    }

    /**
     * possible object is
       * String 
     *
     * @param string destTable
     */
    setDestTable(destTable) {
        this.destTable = destTable;
    }

    /**
     * Returns a JSON object for this XChainColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.chainName !== 'undefined') {
            json['chainName'] = this.chainName;
        }
        if (typeof this.refCol !== 'undefined') {
            json['refCol'] = this.refCol;
        }
        if (typeof this.destTable !== 'undefined') {
            json['destTable'] = this.destTable;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimension = class {

    /**
     * Constructs a XDimension from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['attributes'] !== 'undefined') {
            this.attributes = new exports.Org.Apache.Lens.Api.Metastore.XDimAttributes(o['attributes']);
        }
        if (typeof o['expressions'] !== 'undefined') {
            this.expressions = new exports.Org.Apache.Lens.Api.Metastore.XExpressions(o['expressions']);
        }
        if (typeof o['joinChains'] !== 'undefined') {
            this.joinChains = new exports.Org.Apache.Lens.Api.Metastore.XJoinChains(o['joinChains']);
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
    }

    /**
     * possible object is
       * XDimAttributes 
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttributes
     */
    getAttributes() {
        return this.attributes;
    }

    /**
     * possible object is
       * XDimAttributes 
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttributes attributes
     */
    setAttributes(attributes) {
        this.attributes = attributes;
    }
    /**
     * possible object is
       * XExpressions 
     *
     * @return Org.Apache.Lens.Api.Metastore.XExpressions
     */
    getExpressions() {
        return this.expressions;
    }

    /**
     * possible object is
       * XExpressions 
     *
     * @param Org.Apache.Lens.Api.Metastore.XExpressions expressions
     */
    setExpressions(expressions) {
        this.expressions = expressions;
    }
    /**
     * possible object is
       * XJoinChains 
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinChains
     */
    getJoinChains() {
        return this.joinChains;
    }

    /**
     * possible object is
       * XJoinChains 
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinChains joinChains
     */
    setJoinChains(joinChains) {
        this.joinChains = joinChains;
    }
    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * possible object is
       * String 
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }

    /**
     * Returns a JSON object for this XDimension
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.attributes !== 'undefined') {
            json['attributes'] = this.attributes.toJSON();
        }
        if (typeof this.expressions !== 'undefined') {
            json['expressions'] = this.expressions.toJSON();
        }
        if (typeof this.joinChains !== 'undefined') {
            json['joinChains'] = this.joinChains.toJSON();
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.FieldNameAndValue = class {

    /**
     * Constructs a FieldNameAndValue from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this FieldNameAndValue
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XExecution = class {

    /**
     * Constructs a XExecution from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['session'] !== 'undefined') {
            this.session = new exports.Org.Apache.Lens.Api.Scheduler.XSessionType(o['session']);
        }
        if (typeof o['query'] !== 'undefined') {
            this.query = new exports.Org.Apache.Lens.Api.Scheduler.XJobQuery(o['query']);
        }
    }

    /**
     * possible object is
       * XSessionType 
     *
     * @return Org.Apache.Lens.Api.Scheduler.XSessionType
     */
    getSession() {
        return this.session;
    }

    /**
     * possible object is
       * XSessionType 
     *
     * @param Org.Apache.Lens.Api.Scheduler.XSessionType session
     */
    setSession(session) {
        this.session = session;
    }
    /**
     * possible object is
       * XJobQuery 
     *
     * @return Org.Apache.Lens.Api.Scheduler.XJobQuery
     */
    getQuery() {
        return this.query;
    }

    /**
     * possible object is
       * XJobQuery 
     *
     * @param Org.Apache.Lens.Api.Scheduler.XJobQuery query
     */
    setQuery(query) {
        this.query = query;
    }

    /**
     * Returns a JSON object for this XExecution
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.session !== 'undefined') {
            json['session'] = this.session.toJSON();
        }
        if (typeof this.query !== 'undefined') {
            json['query'] = this.query.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInfo = class {

    /**
     * Constructs a SchedulerJobInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle(o['id']);
        }
        if (typeof o['job'] !== 'undefined') {
            this.job = new exports.Org.Apache.Lens.Api.Scheduler.XJob(o['job']);
        }
        if (typeof o['userName'] !== 'undefined') {
            this.userName = o['userName'];
        }
        if (typeof o['jobState'] !== 'undefined') {
            this.jobState = o['jobState'];
        }
        if (typeof o['createdOn'] !== 'undefined') {
            this.createdOn = o['createdOn'];
        }
        if (typeof o['modifiedOn'] !== 'undefined') {
            this.modifiedOn = o['modifiedOn'];
        }
    }

    /**
     * ID for the current job.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle
     */
    getId() {
        return this.id;
    }

    /**
     * ID for the current job.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * Definition of the job scheduled.
     *
     * @return Org.Apache.Lens.Api.Scheduler.XJob
     */
    getJob() {
        return this.job;
    }

    /**
     * Definition of the job scheduled.
     *
     * @param Org.Apache.Lens.Api.Scheduler.XJob job
     */
    setJob(job) {
        this.job = job;
    }
    /**
     * name of the user who scheduled this job.
     *
     * @return string
     */
    getUserName() {
        return this.userName;
    }

    /**
     * name of the user who scheduled this job.
     *
     * @param string userName
     */
    setUserName(userName) {
        this.userName = userName;
    }
    /**
     * current status of this job
     *
     * @return string
     */
    getJobState() {
        return this.jobState;
    }

    /**
     * current status of this job
     *
     * @param string jobState
     */
    setJobState(jobState) {
        this.jobState = jobState;
    }
    /**
     * time when this job was submitted.
     *
     * @return integer
     */
    getCreatedOn() {
        return this.createdOn;
    }

    /**
     * time when this job was submitted.
     *
     * @param integer createdOn
     */
    setCreatedOn(createdOn) {
        this.createdOn = createdOn;
    }
    /**
     * last modified time for this job
     *
     * @return integer
     */
    getModifiedOn() {
        return this.modifiedOn;
    }

    /**
     * last modified time for this job
     *
     * @param integer modifiedOn
     */
    setModifiedOn(modifiedOn) {
        this.modifiedOn = modifiedOn;
    }

    /**
     * Returns a JSON object for this SchedulerJobInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id.toJSON();
        }
        if (typeof this.job !== 'undefined') {
            json['job'] = this.job.toJSON();
        }
        if (typeof this.userName !== 'undefined') {
            json['userName'] = this.userName;
        }
        if (typeof this.jobState !== 'undefined') {
            json['jobState'] = this.jobState;
        }
        if (typeof this.createdOn !== 'undefined') {
            json['createdOn'] = this.createdOn;
        }
        if (typeof this.modifiedOn !== 'undefined') {
            json['modifiedOn'] = this.modifiedOn;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XSessionType = class {

    /**
     * Constructs a XSessionType from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['db'] !== 'undefined') {
            this.db = o['db'];
        }
        this.conf = [];
        if (o['conf']) {
            o['conf'].forEach(function(x, i){
                self.conf[i] = new exports.Org.Apache.Lens.Api.Scheduler.MapType(x);
            });
        }
        this.resourcePath = [];
        if (o['resourcePath']) {
            o['resourcePath'].forEach(function(x, i){
                self.resourcePath[i] = new exports.Org.Apache.Lens.Api.Scheduler.ResourcePath(x);
            });
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDb() {
        return this.db;
    }

    /**
     * possible object is
       * String 
     *
     * @param string db
     */
    setDb(db) {
        this.db = db;
    }
    /**
     * Gets the value of the conf property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the conf property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getConf().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * MapType
     *
     * @return Org.Apache.Lens.Api.Scheduler.MapType[]
     */
    getConf() {
        return this.conf;
    }

    /**
     * Gets the value of the conf property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the conf property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getConf().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * MapType
     *
     * @param Org.Apache.Lens.Api.Scheduler.MapType[] conf
     */
    setConf(conf) {
        this.conf = conf;
    }
    /**
     * Gets the value of the resourcePath property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the resourcePath property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getResourcePath().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * ResourcePath
     *
     * @return Org.Apache.Lens.Api.Scheduler.ResourcePath[]
     */
    getResourcePath() {
        return this.resourcePath;
    }

    /**
     * Gets the value of the resourcePath property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the resourcePath property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getResourcePath().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * ResourcePath
     *
     * @param Org.Apache.Lens.Api.Scheduler.ResourcePath[] resourcePath
     */
    setResourcePath(resourcePath) {
        this.resourcePath = resourcePath;
    }

    /**
     * Returns a JSON object for this XSessionType
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.db !== 'undefined') {
            json['db'] = this.db;
        }
        if (this.conf) {
            json['conf'] = [];
            this.conf.forEach(function(x, i){
                json['conf'][i] = x.toJSON();
            });
        }
        if (this.resourcePath) {
            json['resourcePath'] = [];
            this.resourcePath.forEach(function(x, i){
                json['resourcePath'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinEdge = class {

    /**
     * Constructs a XJoinEdge from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['from'] !== 'undefined') {
            this.from = new exports.Org.Apache.Lens.Api.Metastore.XTableReference(o['from']);
        }
        if (typeof o['to'] !== 'undefined') {
            this.to = new exports.Org.Apache.Lens.Api.Metastore.XTableReference(o['to']);
        }
    }

    /**
     * possible object is
       * XTableReference 
     *
     * @return Org.Apache.Lens.Api.Metastore.XTableReference
     */
    getFrom() {
        return this.from;
    }

    /**
     * possible object is
       * XTableReference 
     *
     * @param Org.Apache.Lens.Api.Metastore.XTableReference from
     */
    setFrom(from) {
        this.from = from;
    }
    /**
     * possible object is
       * XTableReference 
     *
     * @return Org.Apache.Lens.Api.Metastore.XTableReference
     */
    getTo() {
        return this.to;
    }

    /**
     * possible object is
       * XTableReference 
     *
     * @param Org.Apache.Lens.Api.Metastore.XTableReference to
     */
    setTo(to) {
        this.to = to;
    }

    /**
     * Returns a JSON object for this XJoinEdge
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.from !== 'undefined') {
            json['from'] = this.from.toJSON();
        }
        if (typeof this.to !== 'undefined') {
            json['to'] = this.to.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.ToXMLString = class {

    /**
     * Constructs a ToXMLString from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
    }


    /**
     * Returns a JSON object for this ToXMLString
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Result');
exports.Org.Apache.Lens.Api.Result.LensAPIResult<DATA extends Object> = class {

    /**
     * Constructs a LensAPIResult<DATA extends Object> from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['httpStatusCode'] !== 'undefined') {
            this.httpStatusCode = new exports.javax.ws.rs.core.StatusType(o['httpStatusCode']);
        }
        if (typeof o['successResult'] !== 'undefined') {
            this.successResult = o['successResult'];
        }
        if (typeof o['errorResult'] !== 'undefined') {
            this.errorResult = o['errorResult'];
        }
        if (typeof o['errorCode'] !== 'undefined') {
            this.errorCode = o['errorCode'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['data'] !== 'undefined') {
            this.data = o['data'];
        }
        if (typeof o['lensErrorTO'] !== 'undefined') {
            this.lensErrorTO = new exports.Org.Apache.Lens.Api.Result.LensErrorTO(o['lensErrorTO']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return javax.ws.rs.core.StatusType
     */
    getHttpStatusCode() {
        return this.httpStatusCode;
    }

    /**
     * (no documentation provided)
     *
     * @param javax.ws.rs.core.StatusType httpStatusCode
     */
    setHttpStatusCode(httpStatusCode) {
        this.httpStatusCode = httpStatusCode;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    getSuccessResult() {
        return this.successResult;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean successResult
     */
    setSuccessResult(successResult) {
        this.successResult = successResult;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    getErrorResult() {
        return this.errorResult;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean errorResult
     */
    setErrorResult(errorResult) {
        this.errorResult = errorResult;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getErrorCode() {
        return this.errorCode;
    }

    /**
     * (no documentation provided)
     *
     * @param integer errorCode
     */
    setErrorCode(errorCode) {
        this.errorCode = errorCode;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * (no documentation provided)
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    getData() {
        return this.data;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed data
     */
    setData(data) {
        this.data = data;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Result.LensErrorTO
     */
    getLensErrorTO() {
        return this.lensErrorTO;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Result.LensErrorTO lensErrorTO
     */
    setLensErrorTO(lensErrorTO) {
        this.lensErrorTO = lensErrorTO;
    }

    /**
     * Returns a JSON object for this LensAPIResult<DATA extends Object>
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.httpStatusCode !== 'undefined') {
            json['httpStatusCode'] = this.httpStatusCode.toJSON();
        }
        if (typeof this.successResult !== 'undefined') {
            json['successResult'] = this.successResult;
        }
        if (typeof this.errorResult !== 'undefined') {
            json['errorResult'] = this.errorResult;
        }
        if (typeof this.errorCode !== 'undefined') {
            json['errorCode'] = this.errorCode;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.data !== 'undefined') {
            json['data'] = this.data;
        }
        if (typeof this.lensErrorTO !== 'undefined') {
            json['lensErrorTO'] = this.lensErrorTO.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.FailedAttempt = class {

    /**
     * Constructs a FailedAttempt from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['driverName'] !== 'undefined') {
            this.driverName = o['driverName'];
        }
        if (typeof o['progress'] !== 'undefined') {
            this.progress = o['progress'];
        }
        if (typeof o['progressMessage'] !== 'undefined') {
            this.progressMessage = o['progressMessage'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['driverStartTime'] !== 'undefined') {
            this.driverStartTime = o['driverStartTime'];
        }
        if (typeof o['driverFinishTime'] !== 'undefined') {
            this.driverFinishTime = o['driverFinishTime'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDriverName() {
        return this.driverName;
    }

    /**
     * (no documentation provided)
     *
     * @param string driverName
     */
    setDriverName(driverName) {
        this.driverName = driverName;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    getProgress() {
        return this.progress;
    }

    /**
     * (no documentation provided)
     *
     * @param double progress
     */
    setProgress(progress) {
        this.progress = progress;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getProgressMessage() {
        return this.progressMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string progressMessage
     */
    setProgressMessage(progressMessage) {
        this.progressMessage = progressMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getDriverStartTime() {
        return this.driverStartTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer driverStartTime
     */
    setDriverStartTime(driverStartTime) {
        this.driverStartTime = driverStartTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getDriverFinishTime() {
        return this.driverFinishTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer driverFinishTime
     */
    setDriverFinishTime(driverFinishTime) {
        this.driverFinishTime = driverFinishTime;
    }

    /**
     * Returns a JSON object for this FailedAttempt
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.driverName !== 'undefined') {
            json['driverName'] = this.driverName;
        }
        if (typeof this.progress !== 'undefined') {
            json['progress'] = this.progress;
        }
        if (typeof this.progressMessage !== 'undefined') {
            json['progressMessage'] = this.progressMessage;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.driverStartTime !== 'undefined') {
            json['driverStartTime'] = this.driverStartTime;
        }
        if (typeof this.driverFinishTime !== 'undefined') {
            json['driverFinishTime'] = this.driverFinishTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ParameterParserResponse = class {

    /**
     * Constructs a ParameterParserResponse from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['valid'] !== 'undefined') {
            this.valid = o['valid'];
        }
        if (typeof o['message'] !== 'undefined') {
            this.message = o['message'];
        }
        this.parameters = [];
        if (o['parameters']) {
            o['parameters'].forEach(function(x, i){
                self.parameters[i] = new exports.Org.Apache.Lens.Api.Query.Save.Parameter(x);
            });
        }
    }

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @return boolean
     */
    getValid() {
        return this.valid;
    }

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @param boolean valid
     */
    setValid(valid) {
        this.valid = valid;
    }
    /**
     * The message
     *
     * @return string
     */
    getMessage() {
        return this.message;
    }

    /**
     * The message
     *
     * @param string message
     */
    setMessage(message) {
        this.message = message;
    }
    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @return Org.Apache.Lens.Api.Query.Save.Parameter[]
     */
    getParameters() {
        return this.parameters;
    }

    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @param Org.Apache.Lens.Api.Query.Save.Parameter[] parameters
     */
    setParameters(parameters) {
        this.parameters = parameters;
    }

    /**
     * Returns a JSON object for this ParameterParserResponse
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.valid !== 'undefined') {
            json['valid'] = this.valid;
        }
        if (typeof this.message !== 'undefined') {
            json['message'] = this.message;
        }
        if (this.parameters) {
            json['parameters'] = [];
            this.parameters.forEach(function(x, i){
                json['parameters'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XColumn = class {

    /**
     * Constructs a XColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
        if (typeof o['comment'] !== 'undefined') {
            this.comment = o['comment'];
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * possible object is
       * String 
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getComment() {
        return this.comment;
    }

    /**
     * possible object is
       * String 
     *
     * @param string comment
     */
    setComment(comment) {
        this.comment = comment;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * possible object is
       * String 
     *
     * @param string startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * possible object is
       * String 
     *
     * @param string endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }

    /**
     * Returns a JSON object for this XColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        if (typeof this.comment !== 'undefined') {
            json['comment'] = this.comment;
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSkewedValueLocation = class {

    /**
     * Constructs a XSkewedValueLocation from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['value'] !== 'undefined') {
            this.value = new exports.Org.Apache.Lens.Api.Metastore.XSkewColList(o['value']);
        }
        if (typeof o['location'] !== 'undefined') {
            this.location = o['location'];
        }
    }

    /**
     * possible object is
       * XSkewColList 
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewColList
     */
    getValue() {
        return this.value;
    }

    /**
     * possible object is
       * XSkewColList 
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewColList value
     */
    setValue(value) {
        this.value = value;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getLocation() {
        return this.location;
    }

    /**
     * possible object is
       * String 
     *
     * @param string location
     */
    setLocation(location) {
        this.location = location;
    }

    /**
     * Returns a JSON object for this XSkewedValueLocation
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value.toJSON();
        }
        if (typeof this.location !== 'undefined') {
            json['location'] = this.location;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XFact = class {

    /**
     * Constructs a XFact from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
        if (typeof o['cubeName'] !== 'undefined') {
            this.cubeName = o['cubeName'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * possible object is
       * String 
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getCubeName() {
        return this.cubeName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string cubeName
     */
    setCubeName(cubeName) {
        this.cubeName = cubeName;
    }

    /**
     * Returns a JSON object for this XFact
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        if (typeof this.cubeName !== 'undefined') {
            json['cubeName'] = this.cubeName;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobStats = class {

    /**
     * Constructs a SchedulerJobStats from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
    }


    /**
     * Returns a JSON object for this SchedulerJobStats
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XNativeTable = class {

    /**
     * Constructs a XNativeTable from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['columns'] !== 'undefined') {
            this.columns = new exports.Org.Apache.Lens.Api.Metastore.XColumns(o['columns']);
        }
        if (typeof o['storageDescriptor'] !== 'undefined') {
            this.storageDescriptor = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc(o['storageDescriptor']);
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['dbname'] !== 'undefined') {
            this.dbname = o['dbname'];
        }
        if (typeof o['owner'] !== 'undefined') {
            this.owner = o['owner'];
        }
        if (typeof o['tableType'] !== 'undefined') {
            this.tableType = o['tableType'];
        }
        if (typeof o['createtime'] !== 'undefined') {
            this.createtime = o['createtime'];
        }
        if (typeof o['lastAccessTime'] !== 'undefined') {
            this.lastAccessTime = o['lastAccessTime'];
        }
    }

    /**
     * possible object is
       * XColumns 
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumns
     */
    getColumns() {
        return this.columns;
    }

    /**
     * possible object is
       * XColumns 
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumns columns
     */
    setColumns(columns) {
        this.columns = columns;
    }
    /**
     * possible object is
       * XStorageTableDesc 
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableDesc
     */
    getStorageDescriptor() {
        return this.storageDescriptor;
    }

    /**
     * possible object is
       * XStorageTableDesc 
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableDesc storageDescriptor
     */
    setStorageDescriptor(storageDescriptor) {
        this.storageDescriptor = storageDescriptor;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDbname() {
        return this.dbname;
    }

    /**
     * possible object is
       * String 
     *
     * @param string dbname
     */
    setDbname(dbname) {
        this.dbname = dbname;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getOwner() {
        return this.owner;
    }

    /**
     * possible object is
       * String 
     *
     * @param string owner
     */
    setOwner(owner) {
        this.owner = owner;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getTableType() {
        return this.tableType;
    }

    /**
     * possible object is
       * String 
     *
     * @param string tableType
     */
    setTableType(tableType) {
        this.tableType = tableType;
    }
    /**
     * Gets the value of the createtime property.
     *
     * @return integer
     */
    getCreatetime() {
        return this.createtime;
    }

    /**
     * Gets the value of the createtime property.
     *
     * @param integer createtime
     */
    setCreatetime(createtime) {
        this.createtime = createtime;
    }
    /**
     * Gets the value of the lastAccessTime property.
     *
     * @return integer
     */
    getLastAccessTime() {
        return this.lastAccessTime;
    }

    /**
     * Gets the value of the lastAccessTime property.
     *
     * @param integer lastAccessTime
     */
    setLastAccessTime(lastAccessTime) {
        this.lastAccessTime = lastAccessTime;
    }

    /**
     * Returns a JSON object for this XNativeTable
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.columns !== 'undefined') {
            json['columns'] = this.columns.toJSON();
        }
        if (typeof this.storageDescriptor !== 'undefined') {
            json['storageDescriptor'] = this.storageDescriptor.toJSON();
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.dbname !== 'undefined') {
            json['dbname'] = this.dbname;
        }
        if (typeof this.owner !== 'undefined') {
            json['owner'] = this.owner;
        }
        if (typeof this.tableType !== 'undefined') {
            json['tableType'] = this.tableType;
        }
        if (typeof this.createtime !== 'undefined') {
            json['createtime'] = this.createtime;
        }
        if (typeof this.lastAccessTime !== 'undefined') {
            json['lastAccessTime'] = this.lastAccessTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorageTables = class {

    /**
     * Constructs a XStorageTables from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.storageTable = [];
        if (o['storageTable']) {
            o['storageTable'].forEach(function(x, i){
                self.storageTable[i] = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableElement(x);
            });
        }
    }

    /**
     * Gets the value of the storageTable property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the storageTable property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getStorageTable().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XStorageTableElement
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableElement[]
     */
    getStorageTable() {
        return this.storageTable;
    }

    /**
     * Gets the value of the storageTable property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the storageTable property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getStorageTable().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XStorageTableElement
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableElement[] storageTable
     */
    setStorageTable(storageTable) {
        this.storageTable = storageTable;
    }

    /**
     * Returns a JSON object for this XStorageTables
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.storageTable) {
            json['storageTable'] = [];
            this.storageTable.forEach(function(x, i){
                json['storageTable'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XTimePartSpec = class {

    /**
     * Constructs a XTimePartSpec from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.partSpecElement = [];
        if (o['partSpecElement']) {
            o['partSpecElement'].forEach(function(x, i){
                self.partSpecElement[i] = new exports.Org.Apache.Lens.Api.Metastore.XTimePartSpecElement(x);
            });
        }
    }

    /**
     * Gets the value of the partSpecElement property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the partSpecElement property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPartSpecElement().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XTimePartSpecElement
     *
     * @return Org.Apache.Lens.Api.Metastore.XTimePartSpecElement[]
     */
    getPartSpecElement() {
        return this.partSpecElement;
    }

    /**
     * Gets the value of the partSpecElement property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the partSpecElement property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPartSpecElement().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XTimePartSpecElement
     *
     * @param Org.Apache.Lens.Api.Metastore.XTimePartSpecElement[] partSpecElement
     */
    setPartSpecElement(partSpecElement) {
        this.partSpecElement = partSpecElement;
    }

    /**
     * Returns a JSON object for this XTimePartSpec
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.partSpecElement) {
            json['partSpecElement'] = [];
            this.partSpecElement.forEach(function(x, i){
                json['partSpecElement'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorage = class {

    /**
     * Constructs a XStorage from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['classname'] !== 'undefined') {
            this.classname = o['classname'];
        }
    }

    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getClassname() {
        return this.classname;
    }

    /**
     * possible object is
       * String 
     *
     * @param string classname
     */
    setClassname(classname) {
        this.classname = classname;
    }

    /**
     * Returns a JSON object for this XStorage
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.classname !== 'undefined') {
            json['classname'] = this.classname;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle = class {

    /**
     * Constructs a SchedulerJobHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handleIdString'] !== 'undefined') {
            this.handleIdString = o['handleIdString'];
        }
        if (typeof o['handleId'] !== 'undefined') {
            this.handleId = o['handleId'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getHandleIdString() {
        return this.handleIdString;
    }

    /**
     * (no documentation provided)
     *
     * @param string handleIdString
     */
    setHandleIdString(handleIdString) {
        this.handleIdString = handleIdString;
    }
    /**
     * The handle id.
     *
     * @return string
     */
    getHandleId() {
        return this.handleId;
    }

    /**
     * The handle id.
     *
     * @param string handleId
     */
    setHandleId(handleId) {
        this.handleId = handleId;
    }

    /**
     * Returns a JSON object for this SchedulerJobHandle
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handleIdString !== 'undefined') {
            json['handleIdString'] = this.handleIdString;
        }
        if (typeof this.handleId !== 'undefined') {
            json['handleId'] = this.handleId;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSkewColList = class {

    /**
     * Constructs a XSkewColList from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.elements = [];
        if (o['elements']) {
            o['elements'].forEach(function(x, i){
                self.elements[i] = x;
            });
        }
    }

    /**
     * Gets the value of the elements property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the elements property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getElements().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @return string[]
     */
    getElements() {
        return this.elements;
    }

    /**
     * Gets the value of the elements property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the elements property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getElements().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @param string[] elements
     */
    setElements(elements) {
        this.elements = elements;
    }

    /**
     * Returns a JSON object for this XSkewColList
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.elements) {
            json['elements'] = [];
            this.elements.forEach(function(x, i){
                json['elements'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSegments = class {

    /**
     * Constructs a XSegments from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.segment = [];
        if (o['segment']) {
            o['segment'].forEach(function(x, i){
                self.segment[i] = new exports.Org.Apache.Lens.Api.Metastore.XSegment(x);
            });
        }
    }

    /**
     * Gets the value of the segment property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the segment property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSegment().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSegment
     *
     * @return Org.Apache.Lens.Api.Metastore.XSegment[]
     */
    getSegment() {
        return this.segment;
    }

    /**
     * Gets the value of the segment property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the segment property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getSegment().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSegment
     *
     * @param Org.Apache.Lens.Api.Metastore.XSegment[] segment
     */
    setSegment(segment) {
        this.segment = segment;
    }

    /**
     * Returns a JSON object for this XSegments
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.segment) {
            json['segment'] = [];
            this.segment.forEach(function(x, i){
                json['segment'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XTimePartSpecElement = class {

    /**
     * Constructs a XTimePartSpecElement from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * possible object is
       * String 
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getValue() {
        return this.value;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XTimePartSpecElement
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.MapType = class {

    /**
     * Constructs a MapType from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * possible object is
       * String 
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getValue() {
        return this.value;
    }

    /**
     * possible object is
       * String 
     *
     * @param string value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this MapType
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Result');
exports.Org.Apache.Lens.Api.Result.LensErrorTO<PAYLOAD extends Object> = class {

    /**
     * Constructs a LensErrorTO<PAYLOAD extends Object> from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['payload'] !== 'undefined') {
            this.payload = o['payload'];
        }
        this.childErrors = [];
        if (o['childErrors']) {
            o['childErrors'].forEach(function(x, i){
                self.childErrors[i] = new exports.Org.Apache.Lens.Api.Result.LensErrorTO(x);
            });
        }
        if (typeof o['message'] !== 'undefined') {
            this.message = o['message'];
        }
        if (typeof o['code'] !== 'undefined') {
            this.code = o['code'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    getPayload() {
        return this.payload;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed payload
     */
    setPayload(payload) {
        this.payload = payload;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Result.LensErrorTO[]
     */
    getChildErrors() {
        return this.childErrors;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Result.LensErrorTO[] childErrors
     */
    setChildErrors(childErrors) {
        this.childErrors = childErrors;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getMessage() {
        return this.message;
    }

    /**
     * (no documentation provided)
     *
     * @param string message
     */
    setMessage(message) {
        this.message = message;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getCode() {
        return this.code;
    }

    /**
     * (no documentation provided)
     *
     * @param integer code
     */
    setCode(code) {
        this.code = code;
    }

    /**
     * Returns a JSON object for this LensErrorTO<PAYLOAD extends Object>
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.payload !== 'undefined') {
            json['payload'] = this.payload;
        }
        if (this.childErrors) {
            json['childErrors'] = [];
            this.childErrors.forEach(function(x, i){
                json['childErrors'][i] = x.toJSON();
            });
        }
        if (typeof this.message !== 'undefined') {
            json['message'] = this.message;
        }
        if (typeof this.code !== 'undefined') {
            json['code'] = this.code;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XFlattenedColumn = class {

    /**
     * Constructs a XFlattenedColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['measure'] !== 'undefined') {
            this.measure = new exports.Org.Apache.Lens.Api.Metastore.XMeasure(o['measure']);
        }
        if (typeof o['expression'] !== 'undefined') {
            this.expression = new exports.Org.Apache.Lens.Api.Metastore.XExprColumn(o['expression']);
        }
        if (typeof o['dimAttribute'] !== 'undefined') {
            this.dimAttribute = new exports.Org.Apache.Lens.Api.Metastore.XDimAttribute(o['dimAttribute']);
        }
        if (typeof o['tableName'] !== 'undefined') {
            this.tableName = o['tableName'];
        }
        if (typeof o['chainName'] !== 'undefined') {
            this.chainName = o['chainName'];
        }
    }

    /**
     * possible object is
       * XMeasure 
     *
     * @return Org.Apache.Lens.Api.Metastore.XMeasure
     */
    getMeasure() {
        return this.measure;
    }

    /**
     * possible object is
       * XMeasure 
     *
     * @param Org.Apache.Lens.Api.Metastore.XMeasure measure
     */
    setMeasure(measure) {
        this.measure = measure;
    }
    /**
     * possible object is
       * XExprColumn 
     *
     * @return Org.Apache.Lens.Api.Metastore.XExprColumn
     */
    getExpression() {
        return this.expression;
    }

    /**
     * possible object is
       * XExprColumn 
     *
     * @param Org.Apache.Lens.Api.Metastore.XExprColumn expression
     */
    setExpression(expression) {
        this.expression = expression;
    }
    /**
     * possible object is
       * XDimAttribute 
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttribute
     */
    getDimAttribute() {
        return this.dimAttribute;
    }

    /**
     * possible object is
       * XDimAttribute 
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttribute dimAttribute
     */
    setDimAttribute(dimAttribute) {
        this.dimAttribute = dimAttribute;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getTableName() {
        return this.tableName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string tableName
     */
    setTableName(tableName) {
        this.tableName = tableName;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getChainName() {
        return this.chainName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string chainName
     */
    setChainName(chainName) {
        this.chainName = chainName;
    }

    /**
     * Returns a JSON object for this XFlattenedColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.measure !== 'undefined') {
            json['measure'] = this.measure.toJSON();
        }
        if (typeof this.expression !== 'undefined') {
            json['expression'] = this.expression.toJSON();
        }
        if (typeof this.dimAttribute !== 'undefined') {
            json['dimAttribute'] = this.dimAttribute.toJSON();
        }
        if (typeof this.tableName !== 'undefined') {
            json['tableName'] = this.tableName;
        }
        if (typeof this.chainName !== 'undefined') {
            json['chainName'] = this.chainName;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun = class {

    /**
     * Constructs a SchedulerJobInstanceRun from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handle'] !== 'undefined') {
            this.handle = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle(o['handle']);
        }
        if (typeof o['runId'] !== 'undefined') {
            this.runId = o['runId'];
        }
        if (typeof o['sessionHandle'] !== 'undefined') {
            this.sessionHandle = new exports.Org.Apache.Lens.Api.LensSessionHandle(o['sessionHandle']);
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
        if (typeof o['resultPath'] !== 'undefined') {
            this.resultPath = o['resultPath'];
        }
        if (typeof o['queryHandle'] !== 'undefined') {
            this.queryHandle = new exports.Org.Apache.Lens.Api.Query.QueryHandle(o['queryHandle']);
        }
        if (typeof o['instanceState'] !== 'undefined') {
            this.instanceState = o['instanceState'];
        }
    }

    /**
     * the handle
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle
     */
    getHandle() {
        return this.handle;
    }

    /**
     * the handle
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle handle
     */
    setHandle(handle) {
        this.handle = handle;
    }
    /**
     * the runId
     *
     * @return integer
     */
    getRunId() {
        return this.runId;
    }

    /**
     * the runId
     *
     * @param integer runId
     */
    setRunId(runId) {
        this.runId = runId;
    }
    /**
     * session handle for this instance run.
     *
     * @return Org.Apache.Lens.Api.LensSessionHandle
     */
    getSessionHandle() {
        return this.sessionHandle;
    }

    /**
     * session handle for this instance run.
     *
     * @param Org.Apache.Lens.Api.LensSessionHandle sessionHandle
     */
    setSessionHandle(sessionHandle) {
        this.sessionHandle = sessionHandle;
    }
    /**
     * actual start time of this instance run .
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * actual start time of this instance run .
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * actual finish time of this instance run.
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * actual finish time of this instance run.
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }
    /**
     * result path of this instance run.
     *
     * @return string
     */
    getResultPath() {
        return this.resultPath;
    }

    /**
     * result path of this instance run.
     *
     * @param string resultPath
     */
    setResultPath(resultPath) {
        this.resultPath = resultPath;
    }
    /**
     * queryHandle of this instance run.
     *
     * @return Org.Apache.Lens.Api.Query.QueryHandle
     */
    getQueryHandle() {
        return this.queryHandle;
    }

    /**
     * queryHandle of this instance run.
     *
     * @param Org.Apache.Lens.Api.Query.QueryHandle queryHandle
     */
    setQueryHandle(queryHandle) {
        this.queryHandle = queryHandle;
    }
    /**
     * status of this instance.
     *
     * @return string
     */
    getInstanceState() {
        return this.instanceState;
    }

    /**
     * status of this instance.
     *
     * @param string instanceState
     */
    setInstanceState(instanceState) {
        this.instanceState = instanceState;
    }

    /**
     * Returns a JSON object for this SchedulerJobInstanceRun
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handle !== 'undefined') {
            json['handle'] = this.handle.toJSON();
        }
        if (typeof this.runId !== 'undefined') {
            json['runId'] = this.runId;
        }
        if (typeof this.sessionHandle !== 'undefined') {
            json['sessionHandle'] = this.sessionHandle.toJSON();
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        if (typeof this.resultPath !== 'undefined') {
            json['resultPath'] = this.resultPath;
        }
        if (typeof this.queryHandle !== 'undefined') {
            json['queryHandle'] = this.queryHandle.toJSON();
        }
        if (typeof this.instanceState !== 'undefined') {
            json['instanceState'] = this.instanceState;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XField = class {

    /**
     * Constructs a XField from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['tags'] !== 'undefined') {
            this.tags = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['tags']);
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['displayString'] !== 'undefined') {
            this.displayString = o['displayString'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
    }

    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getTags() {
        return this.tags;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties tags
     */
    setTags(tags) {
        this.tags = tags;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDisplayString() {
        return this.displayString;
    }

    /**
     * possible object is
       * String 
     *
     * @param string displayString
     */
    setDisplayString(displayString) {
        this.displayString = displayString;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * possible object is
       * String 
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }

    /**
     * Returns a JSON object for this XField
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.tags !== 'undefined') {
            json['tags'] = this.tags.toJSON();
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.displayString !== 'undefined') {
            json['displayString'] = this.displayString;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle = class {

    /**
     * Constructs a SchedulerJobInstanceHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handleIdString'] !== 'undefined') {
            this.handleIdString = o['handleIdString'];
        }
        if (typeof o['handleId'] !== 'undefined') {
            this.handleId = o['handleId'];
        }
    }

    /**
     * handleId as a string.
     *
     * @return string
     */
    getHandleIdString() {
        return this.handleIdString;
    }

    /**
     * handleId as a string.
     *
     * @param string handleIdString
     */
    setHandleIdString(handleIdString) {
        this.handleIdString = handleIdString;
    }
    /**
     * The handle id.
     *
     * @return string
     */
    getHandleId() {
        return this.handleId;
    }

    /**
     * The handle id.
     *
     * @param string handleId
     */
    setHandleId(handleId) {
        this.handleId = handleId;
    }

    /**
     * Returns a JSON object for this SchedulerJobInstanceHandle
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handleIdString !== 'undefined') {
            json['handleIdString'] = this.handleIdString;
        }
        if (typeof this.handleId !== 'undefined') {
            json['handleId'] = this.handleId;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSegment = class {

    /**
     * Constructs a XSegment from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['segmentParameters'] !== 'undefined') {
            this.segmentParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['segmentParameters']);
        }
        if (typeof o['cubeName'] !== 'undefined') {
            this.cubeName = o['cubeName'];
        }
    }

    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getSegmentParameters() {
        return this.segmentParameters;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties segmentParameters
     */
    setSegmentParameters(segmentParameters) {
        this.segmentParameters = segmentParameters;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getCubeName() {
        return this.cubeName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string cubeName
     */
    setCubeName(cubeName) {
        this.cubeName = cubeName;
    }

    /**
     * Returns a JSON object for this XSegment
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.segmentParameters !== 'undefined') {
            json['segmentParameters'] = this.segmentParameters.toJSON();
        }
        if (typeof this.cubeName !== 'undefined') {
            json['cubeName'] = this.cubeName;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ResourceModifiedResponse = class {

    /**
     * Constructs a ResourceModifiedResponse from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['resource'] !== 'undefined') {
            this.resource = o['resource'];
        }
        if (typeof o['status'] !== 'undefined') {
            this.status = o['status'];
        }
    }

    /**
     * ID of the affected resource
     *
     * @return integer
     */
    getId() {
        return this.id;
    }

    /**
     * ID of the affected resource
     *
     * @param integer id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * The resource type
     *
     * @return string
     */
    getResource() {
        return this.resource;
    }

    /**
     * The resource type
     *
     * @param string resource
     */
    setResource(resource) {
        this.resource = resource;
    }
    /**
     * The action performed on the reource
     *
     * @return string
     */
    getStatus() {
        return this.status;
    }

    /**
     * The action performed on the reource
     *
     * @param string status
     */
    setStatus(status) {
        this.status = status;
    }

    /**
     * Returns a JSON object for this ResourceModifiedResponse
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.resource !== 'undefined') {
            json['resource'] = this.resource;
        }
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XCube = class {

    /**
     * Constructs a XCube from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
    }

    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * possible object is
       * String 
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }

    /**
     * Returns a JSON object for this XCube
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XTableReference = class {

    /**
     * Constructs a XTableReference from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['table'] !== 'undefined') {
            this.table = o['table'];
        }
        if (typeof o['column'] !== 'undefined') {
            this.column = o['column'];
        }
        if (typeof o['mapsToMany'] !== 'undefined') {
            this.mapsToMany = o['mapsToMany'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getTable() {
        return this.table;
    }

    /**
     * possible object is
       * String 
     *
     * @param string table
     */
    setTable(table) {
        this.table = table;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getColumn() {
        return this.column;
    }

    /**
     * possible object is
       * String 
     *
     * @param string column
     */
    setColumn(column) {
        this.column = column;
    }
    /**
     * possible object is
       * Boolean 
     *
     * @return boolean
     */
    getMapsToMany() {
        return this.mapsToMany;
    }

    /**
     * possible object is
       * Boolean 
     *
     * @param boolean mapsToMany
     */
    setMapsToMany(mapsToMany) {
        this.mapsToMany = mapsToMany;
    }

    /**
     * Returns a JSON object for this XTableReference
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.table !== 'undefined') {
            json['table'] = this.table;
        }
        if (typeof this.column !== 'undefined') {
            json['column'] = this.column;
        }
        if (typeof this.mapsToMany !== 'undefined') {
            json['mapsToMany'] = this.mapsToMany;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceInfo = class {

    /**
     * Constructs a SchedulerJobInstanceInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle(o['id']);
        }
        if (typeof o['jobId'] !== 'undefined') {
            this.jobId = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle(o['jobId']);
        }
        if (typeof o['scheduleTime'] !== 'undefined') {
            this.scheduleTime = o['scheduleTime'];
        }
        this.instanceRunList = [];
        if (o['instanceRunList']) {
            o['instanceRunList'].forEach(function(x, i){
                self.instanceRunList[i] = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun(x);
            });
        }
    }

    /**
     * unique id for this instance of scheduler job.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle
     */
    getId() {
        return this.id;
    }

    /**
     * unique id for this instance of scheduler job.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle
     */
    getJobId() {
        return this.jobId;
    }

    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle jobId
     */
    setJobId(jobId) {
        this.jobId = jobId;
    }
    /**
     * scheduled time of this instance.
     *
     * @return integer
     */
    getScheduleTime() {
        return this.scheduleTime;
    }

    /**
     * scheduled time of this instance.
     *
     * @param integer scheduleTime
     */
    setScheduleTime(scheduleTime) {
        this.scheduleTime = scheduleTime;
    }
    /**
     * A list of instance-run for this instance.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun[]
     */
    getInstanceRunList() {
        return this.instanceRunList;
    }

    /**
     * A list of instance-run for this instance.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun[] instanceRunList
     */
    setInstanceRunList(instanceRunList) {
        this.instanceRunList = instanceRunList;
    }

    /**
     * Returns a JSON object for this SchedulerJobInstanceInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id.toJSON();
        }
        if (typeof this.jobId !== 'undefined') {
            json['jobId'] = this.jobId.toJSON();
        }
        if (typeof this.scheduleTime !== 'undefined') {
            json['scheduleTime'] = this.scheduleTime;
        }
        if (this.instanceRunList) {
            json['instanceRunList'] = [];
            this.instanceRunList.forEach(function(x, i){
                json['instanceRunList'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XJob = class {

    /**
     * Constructs a XJob from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['execution'] !== 'undefined') {
            this.execution = new exports.Org.Apache.Lens.Api.Scheduler.XExecution(o['execution']);
        }
        if (typeof o['trigger'] !== 'undefined') {
            this.trigger = new exports.Org.Apache.Lens.Api.Scheduler.XTrigger(o['trigger']);
        }
        this.jobConf = [];
        if (o['jobConf']) {
            o['jobConf'].forEach(function(x, i){
                self.jobConf[i] = new exports.Org.Apache.Lens.Api.Scheduler.MapType(x);
            });
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * XExecution 
     *
     * @return Org.Apache.Lens.Api.Scheduler.XExecution
     */
    getExecution() {
        return this.execution;
    }

    /**
     * possible object is
       * XExecution 
     *
     * @param Org.Apache.Lens.Api.Scheduler.XExecution execution
     */
    setExecution(execution) {
        this.execution = execution;
    }
    /**
     * possible object is
       * XTrigger 
     *
     * @return Org.Apache.Lens.Api.Scheduler.XTrigger
     */
    getTrigger() {
        return this.trigger;
    }

    /**
     * possible object is
       * XTrigger 
     *
     * @param Org.Apache.Lens.Api.Scheduler.XTrigger trigger
     */
    setTrigger(trigger) {
        this.trigger = trigger;
    }
    /**
     * Gets the value of the jobConf property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the jobConf property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getJobConf().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * MapType
     *
     * @return Org.Apache.Lens.Api.Scheduler.MapType[]
     */
    getJobConf() {
        return this.jobConf;
    }

    /**
     * Gets the value of the jobConf property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the jobConf property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getJobConf().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * MapType
     *
     * @param Org.Apache.Lens.Api.Scheduler.MapType[] jobConf
     */
    setJobConf(jobConf) {
        this.jobConf = jobConf;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }

    /**
     * Returns a JSON object for this XJob
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.execution !== 'undefined') {
            json['execution'] = this.execution.toJSON();
        }
        if (typeof this.trigger !== 'undefined') {
            json['trigger'] = this.trigger.toJSON();
        }
        if (this.jobConf) {
            json['jobConf'] = [];
            this.jobConf.forEach(function(x, i){
                json['jobConf'][i] = x.toJSON();
            });
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XJobQuery = class {

    /**
     * Constructs a XJobQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['query'] !== 'undefined') {
            this.query = o['query'];
        }
        this.conf = [];
        if (o['conf']) {
            o['conf'].forEach(function(x, i){
                self.conf[i] = new exports.Org.Apache.Lens.Api.Scheduler.MapType(x);
            });
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getQuery() {
        return this.query;
    }

    /**
     * possible object is
       * String 
     *
     * @param string query
     */
    setQuery(query) {
        this.query = query;
    }
    /**
     * Gets the value of the conf property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the conf property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getConf().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * MapType
     *
     * @return Org.Apache.Lens.Api.Scheduler.MapType[]
     */
    getConf() {
        return this.conf;
    }

    /**
     * Gets the value of the conf property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the conf property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getConf().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * MapType
     *
     * @param Org.Apache.Lens.Api.Scheduler.MapType[] conf
     */
    setConf(conf) {
        this.conf = conf;
    }

    /**
     * Returns a JSON object for this XJobQuery
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.query !== 'undefined') {
            json['query'] = this.query;
        }
        if (this.conf) {
            json['conf'] = [];
            this.conf.forEach(function(x, i){
                json['conf'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.Parameter = class {

    /**
     * Constructs a Parameter from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['displayName'] !== 'undefined') {
            this.displayName = o['displayName'];
        }
        this.defaultValue = [];
        if (o['defaultValue']) {
            o['defaultValue'].forEach(function(x, i){
                self.defaultValue[i] = x;
            });
        }
        if (typeof o['dataType'] !== 'undefined') {
            this.dataType = o['dataType'];
        }
        if (typeof o['collectionType'] !== 'undefined') {
            this.collectionType = o['collectionType'];
        }
    }

    /**
     * Name of the parameter used in the query.
       * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * Name of the parameter used in the query.
       * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @return string
     */
    getDisplayName() {
        return this.displayName;
    }

    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @param string displayName
     */
    setDisplayName(displayName) {
        this.displayName = displayName;
    }
    /**
     * The default value that will be used,
       * if the parameter is not supplied with any values while running the query.
     *
     * @return string[]
     */
    getDefaultValue() {
        return this.defaultValue;
    }

    /**
     * The default value that will be used,
       * if the parameter is not supplied with any values while running the query.
     *
     * @param string[] defaultValue
     */
    setDefaultValue(defaultValue) {
        this.defaultValue = defaultValue;
    }
    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
       * The value supplied will be parsed with the corresponding data type.
     *
     * @return string
     */
    getDataType() {
        return this.dataType;
    }

    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
       * The value supplied will be parsed with the corresponding data type.
     *
     * @param string dataType
     */
    setDataType(dataType) {
        this.dataType = dataType;
    }
    /**
     * Collection type of the parameter.
       * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @return string
     */
    getCollectionType() {
        return this.collectionType;
    }

    /**
     * Collection type of the parameter.
       * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @param string collectionType
     */
    setCollectionType(collectionType) {
        this.collectionType = collectionType;
    }

    /**
     * Returns a JSON object for this Parameter
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.displayName !== 'undefined') {
            json['displayName'] = this.displayName;
        }
        if (this.defaultValue) {
            json['defaultValue'] = [];
            this.defaultValue.forEach(function(x, i){
                json['defaultValue'][i] = x;
            });
        }
        if (typeof this.dataType !== 'undefined') {
            json['dataType'] = this.dataType;
        }
        if (typeof this.collectionType !== 'undefined') {
            json['collectionType'] = this.collectionType;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ListResponse = class {

    /**
     * Constructs a ListResponse from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['offsetAppplied'] !== 'undefined') {
            this.offsetAppplied = o['offsetAppplied'];
        }
        if (typeof o['totalCount'] !== 'undefined') {
            this.totalCount = o['totalCount'];
        }
        this.resoures = [];
        if (o['resoures']) {
            o['resoures'].forEach(function(x, i){
                self.resoures[i] = new exports.Org.Apache.Lens.Api.Query.Save.SavedQuery(x);
            });
        }
    }

    /**
     * The starting offset of the result set.
     *
     * @return integer
     */
    getOffsetAppplied() {
        return this.offsetAppplied;
    }

    /**
     * The starting offset of the result set.
     *
     * @param integer offsetAppplied
     */
    setOffsetAppplied(offsetAppplied) {
        this.offsetAppplied = offsetAppplied;
    }
    /**
     * The total number of queries returned in the current request.
     *
     * @return integer
     */
    getTotalCount() {
        return this.totalCount;
    }

    /**
     * The total number of queries returned in the current request.
     *
     * @param integer totalCount
     */
    setTotalCount(totalCount) {
        this.totalCount = totalCount;
    }
    /**
     * The queries.
     *
     * @return Org.Apache.Lens.Api.Query.Save.SavedQuery[]
     */
    getResoures() {
        return this.resoures;
    }

    /**
     * The queries.
     *
     * @param Org.Apache.Lens.Api.Query.Save.SavedQuery[] resoures
     */
    setResoures(resoures) {
        this.resoures = resoures;
    }

    /**
     * Returns a JSON object for this ListResponse
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.offsetAppplied !== 'undefined') {
            json['offsetAppplied'] = this.offsetAppplied;
        }
        if (typeof this.totalCount !== 'undefined') {
            json['totalCount'] = this.totalCount;
        }
        if (this.resoures) {
            json['resoures'] = [];
            this.resoures.forEach(function(x, i){
                json['resoures'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XFrequency = class {

    /**
     * Constructs a XFrequency from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['enum'] !== 'undefined') {
            this.enum = o['enum'];
        }
        if (typeof o['cronExpression'] !== 'undefined') {
            this.cronExpression = o['cronExpression'];
        }
        if (typeof o['timezone'] !== 'undefined') {
            this.timezone = o['timezone'];
        }
    }

    /**
     * possible object is
       * XFrequencyEnum 
     *
     * @return string
     */
    getEnum() {
        return this.enum;
    }

    /**
     * possible object is
       * XFrequencyEnum 
     *
     * @param string enum
     */
    setEnum(enum) {
        this.enum = enum;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getCronExpression() {
        return this.cronExpression;
    }

    /**
     * possible object is
       * String 
     *
     * @param string cronExpression
     */
    setCronExpression(cronExpression) {
        this.cronExpression = cronExpression;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getTimezone() {
        return this.timezone;
    }

    /**
     * possible object is
       * String 
     *
     * @param string timezone
     */
    setTimezone(timezone) {
        this.timezone = timezone;
    }

    /**
     * Returns a JSON object for this XFrequency
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.enum !== 'undefined') {
            json['enum'] = this.enum;
        }
        if (typeof this.cronExpression !== 'undefined') {
            json['cronExpression'] = this.cronExpression;
        }
        if (typeof this.timezone !== 'undefined') {
            json['timezone'] = this.timezone;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Session');
exports.Org.Apache.Lens.Api.Session.UserSessionInfo = class {

    /**
     * Constructs a UserSessionInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handle'] !== 'undefined') {
            this.handle = o['handle'];
        }
        if (typeof o['userName'] !== 'undefined') {
            this.userName = o['userName'];
        }
        this.activeQueries = [];
        if (o['activeQueries']) {
            o['activeQueries'].forEach(function(x, i){
                self.activeQueries[i] = new exports.Org.Apache.Lens.Api.Query.QueryHandle(x);
            });
        }
        if (typeof o['creationTime'] !== 'undefined') {
            this.creationTime = o['creationTime'];
        }
        if (typeof o['lastAccessTime'] !== 'undefined') {
            this.lastAccessTime = o['lastAccessTime'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getHandle() {
        return this.handle;
    }

    /**
     * (no documentation provided)
     *
     * @param string handle
     */
    setHandle(handle) {
        this.handle = handle;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getUserName() {
        return this.userName;
    }

    /**
     * (no documentation provided)
     *
     * @param string userName
     */
    setUserName(userName) {
        this.userName = userName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Query.QueryHandle[]
     */
    getActiveQueries() {
        return this.activeQueries;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Query.QueryHandle[] activeQueries
     */
    setActiveQueries(activeQueries) {
        this.activeQueries = activeQueries;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getCreationTime() {
        return this.creationTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer creationTime
     */
    setCreationTime(creationTime) {
        this.creationTime = creationTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getLastAccessTime() {
        return this.lastAccessTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer lastAccessTime
     */
    setLastAccessTime(lastAccessTime) {
        this.lastAccessTime = lastAccessTime;
    }

    /**
     * Returns a JSON object for this UserSessionInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handle !== 'undefined') {
            json['handle'] = this.handle;
        }
        if (typeof this.userName !== 'undefined') {
            json['userName'] = this.userName;
        }
        if (this.activeQueries) {
            json['activeQueries'] = [];
            this.activeQueries.forEach(function(x, i){
                json['activeQueries'][i] = x.toJSON();
            });
        }
        if (typeof this.creationTime !== 'undefined') {
            json['creationTime'] = this.creationTime;
        }
        if (typeof this.lastAccessTime !== 'undefined') {
            json['lastAccessTime'] = this.lastAccessTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XTrigger = class {

    /**
     * Constructs a XTrigger from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['frequency'] !== 'undefined') {
            this.frequency = new exports.Org.Apache.Lens.Api.Scheduler.XFrequency(o['frequency']);
        }
    }

    /**
     * possible object is
       * XFrequency 
     *
     * @return Org.Apache.Lens.Api.Scheduler.XFrequency
     */
    getFrequency() {
        return this.frequency;
    }

    /**
     * possible object is
       * XFrequency 
     *
     * @param Org.Apache.Lens.Api.Scheduler.XFrequency frequency
     */
    setFrequency(frequency) {
        this.frequency = frequency;
    }

    /**
     * Returns a JSON object for this XTrigger
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.frequency !== 'undefined') {
            json['frequency'] = this.frequency.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor = class {

    /**
     * Constructs a XUpdatePeriodTableDescriptor from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['updatePeriod'] !== 'undefined') {
            this.updatePeriod = o['updatePeriod'];
        }
        if (typeof o['tableDesc'] !== 'undefined') {
            this.tableDesc = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc(o['tableDesc']);
        }
    }

    /**
     * possible object is
       * XUpdatePeriod 
     *
     * @return string
     */
    getUpdatePeriod() {
        return this.updatePeriod;
    }

    /**
     * possible object is
       * XUpdatePeriod 
     *
     * @param string updatePeriod
     */
    setUpdatePeriod(updatePeriod) {
        this.updatePeriod = updatePeriod;
    }
    /**
     * possible object is
       * XStorageTableDesc 
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableDesc
     */
    getTableDesc() {
        return this.tableDesc;
    }

    /**
     * possible object is
       * XStorageTableDesc 
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableDesc tableDesc
     */
    setTableDesc(tableDesc) {
        this.tableDesc = tableDesc;
    }

    /**
     * Returns a JSON object for this XUpdatePeriodTableDescriptor
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.updatePeriod !== 'undefined') {
            json['updatePeriod'] = this.updatePeriod;
        }
        if (typeof this.tableDesc !== 'undefined') {
            json['tableDesc'] = this.tableDesc.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimAttributes = class {

    /**
     * Constructs a XDimAttributes from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.dimAttribute = [];
        if (o['dimAttribute']) {
            o['dimAttribute'].forEach(function(x, i){
                self.dimAttribute[i] = new exports.Org.Apache.Lens.Api.Metastore.XDimAttribute(x);
            });
        }
    }

    /**
     * Gets the value of the dimAttribute property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the dimAttribute property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getDimAttribute().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XDimAttribute
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttribute[]
     */
    getDimAttribute() {
        return this.dimAttribute;
    }

    /**
     * Gets the value of the dimAttribute property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the dimAttribute property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getDimAttribute().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XDimAttribute
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttribute[] dimAttribute
     */
    setDimAttribute(dimAttribute) {
        this.dimAttribute = dimAttribute;
    }

    /**
     * Returns a JSON object for this XDimAttributes
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.dimAttribute) {
            json['dimAttribute'] = [];
            this.dimAttribute.forEach(function(x, i){
                json['dimAttribute'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinChains = class {

    /**
     * Constructs a XJoinChains from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.joinChain = [];
        if (o['joinChain']) {
            o['joinChain'].forEach(function(x, i){
                self.joinChain[i] = new exports.Org.Apache.Lens.Api.Metastore.XJoinChain(x);
            });
        }
    }

    /**
     * Gets the value of the joinChain property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the joinChain property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getJoinChain().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XJoinChain
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinChain[]
     */
    getJoinChain() {
        return this.joinChain;
    }

    /**
     * Gets the value of the joinChain property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the joinChain property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getJoinChain().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XJoinChain
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinChain[] joinChain
     */
    setJoinChain(joinChain) {
        this.joinChain = joinChain;
    }

    /**
     * Returns a JSON object for this XJoinChains
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.joinChain) {
            json['joinChain'] = [];
            this.joinChain.forEach(function(x, i){
                json['joinChain'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.ResourcePath = class {

    /**
     * Constructs a ResourcePath from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['path'] !== 'undefined') {
            this.path = o['path'];
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getPath() {
        return this.path;
    }

    /**
     * possible object is
       * String 
     *
     * @param string path
     */
    setPath(path) {
        this.path = path;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * possible object is
       * String 
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }

    /**
     * Returns a JSON object for this ResourcePath
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.path !== 'undefined') {
            json['path'] = this.path;
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.SavedQuery = class {

    /**
     * Constructs a SavedQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
        if (typeof o['query'] !== 'undefined') {
            this.query = o['query'];
        }
        this.parameters = [];
        if (o['parameters']) {
            o['parameters'].forEach(function(x, i){
                self.parameters[i] = new exports.Org.Apache.Lens.Api.Query.Save.Parameter(x);
            });
        }
    }

    /**
     * ID of the saved query (unique)
     *
     * @return integer
     */
    getId() {
        return this.id;
    }

    /**
     * ID of the saved query (unique)
     *
     * @param integer id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * Name of the saved query
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * Name of the saved query
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * Description of the saved query
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * Description of the saved query
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }
    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @return string
     */
    getQuery() {
        return this.query;
    }

    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @param string query
     */
    setQuery(query) {
        this.query = query;
    }
    /**
     * Parameters that are used in the query
     *
     * @return Org.Apache.Lens.Api.Query.Save.Parameter[]
     */
    getParameters() {
        return this.parameters;
    }

    /**
     * Parameters that are used in the query
     *
     * @param Org.Apache.Lens.Api.Query.Save.Parameter[] parameters
     */
    setParameters(parameters) {
        this.parameters = parameters;
    }

    /**
     * Returns a JSON object for this SavedQuery
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        if (typeof this.query !== 'undefined') {
            json['query'] = this.query;
        }
        if (this.parameters) {
            json['parameters'] = [];
            this.parameters.forEach(function(x, i){
                json['parameters'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XExpressions = class {

    /**
     * Constructs a XExpressions from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.expression = [];
        if (o['expression']) {
            o['expression'].forEach(function(x, i){
                self.expression[i] = new exports.Org.Apache.Lens.Api.Metastore.XExprColumn(x);
            });
        }
    }

    /**
     * Gets the value of the expression property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the expression property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getExpression().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XExprColumn
     *
     * @return Org.Apache.Lens.Api.Metastore.XExprColumn[]
     */
    getExpression() {
        return this.expression;
    }

    /**
     * Gets the value of the expression property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the expression property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getExpression().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XExprColumn
     *
     * @param Org.Apache.Lens.Api.Metastore.XExprColumn[] expression
     */
    setExpression(expression) {
        this.expression = expression;
    }

    /**
     * Returns a JSON object for this XExpressions
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.expression) {
            json['expression'] = [];
            this.expression.forEach(function(x, i){
                json['expression'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartSpecElement = class {

    /**
     * Constructs a XPartSpecElement from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * possible object is
       * String 
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getValue() {
        return this.value;
    }

    /**
     * possible object is
       * String 
     *
     * @param string value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XPartSpecElement
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XProperties = class {

    /**
     * Constructs a XProperties from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.property = [];
        if (o['property']) {
            o['property'].forEach(function(x, i){
                self.property[i] = new exports.Org.Apache.Lens.Api.Metastore.XProperty(x);
            });
        }
    }

    /**
     * Gets the value of the property property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the property property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getProperty().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XProperty
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperty[]
     */
    getProperty() {
        return this.property;
    }

    /**
     * Gets the value of the property property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the property property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getProperty().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XProperty
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperty[] property
     */
    setProperty(property) {
        this.property = property;
    }

    /**
     * Returns a JSON object for this XProperties
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.property) {
            json['property'] = [];
            this.property.forEach(function(x, i){
                json['property'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSkewedInfo = class {

    /**
     * Constructs a XSkewedInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.colNames = [];
        if (o['colNames']) {
            o['colNames'].forEach(function(x, i){
                self.colNames[i] = x;
            });
        }
        this.colValues = [];
        if (o['colValues']) {
            o['colValues'].forEach(function(x, i){
                self.colValues[i] = new exports.Org.Apache.Lens.Api.Metastore.XSkewColList(x);
            });
        }
        this.valueLocationMap = [];
        if (o['valueLocationMap']) {
            o['valueLocationMap'].forEach(function(x, i){
                self.valueLocationMap[i] = new exports.Org.Apache.Lens.Api.Metastore.XSkewedValueLocation(x);
            });
        }
    }

    /**
     * Gets the value of the colNames property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the colNames property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getColNames().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @return string[]
     */
    getColNames() {
        return this.colNames;
    }

    /**
     * Gets the value of the colNames property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the colNames property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getColNames().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @param string[] colNames
     */
    setColNames(colNames) {
        this.colNames = colNames;
    }
    /**
     * Gets the value of the colValues property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the colValues property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getColValues().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSkewColList
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewColList[]
     */
    getColValues() {
        return this.colValues;
    }

    /**
     * Gets the value of the colValues property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the colValues property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getColValues().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSkewColList
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewColList[] colValues
     */
    setColValues(colValues) {
        this.colValues = colValues;
    }
    /**
     * Gets the value of the valueLocationMap property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the valueLocationMap property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getValueLocationMap().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSkewedValueLocation
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewedValueLocation[]
     */
    getValueLocationMap() {
        return this.valueLocationMap;
    }

    /**
     * Gets the value of the valueLocationMap property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the valueLocationMap property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getValueLocationMap().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XSkewedValueLocation
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewedValueLocation[] valueLocationMap
     */
    setValueLocationMap(valueLocationMap) {
        this.valueLocationMap = valueLocationMap;
    }

    /**
     * Returns a JSON object for this XSkewedInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.colNames) {
            json['colNames'] = [];
            this.colNames.forEach(function(x, i){
                json['colNames'][i] = x;
            });
        }
        if (this.colValues) {
            json['colValues'] = [];
            this.colValues.forEach(function(x, i){
                json['colValues'][i] = x.toJSON();
            });
        }
        if (this.valueLocationMap) {
            json['valueLocationMap'] = [];
            this.valueLocationMap.forEach(function(x, i){
                json['valueLocationMap'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriods = class {

    /**
     * Constructs a XUpdatePeriods from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.updatePeriodTableDescriptor = [];
        if (o['updatePeriodTableDescriptor']) {
            o['updatePeriodTableDescriptor'].forEach(function(x, i){
                self.updatePeriodTableDescriptor[i] = new exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor(x);
            });
        }
        this.updatePeriod = [];
        if (o['updatePeriod']) {
            o['updatePeriod'].forEach(function(x, i){
                self.updatePeriod[i] = x;
            });
        }
    }

    /**
     * Gets the value of the updatePeriodTableDescriptor property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the updatePeriodTableDescriptor property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getUpdatePeriodTableDescriptor().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XUpdatePeriodTableDescriptor
     *
     * @return Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor[]
     */
    getUpdatePeriodTableDescriptor() {
        return this.updatePeriodTableDescriptor;
    }

    /**
     * Gets the value of the updatePeriodTableDescriptor property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the updatePeriodTableDescriptor property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getUpdatePeriodTableDescriptor().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XUpdatePeriodTableDescriptor
     *
     * @param Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor[] updatePeriodTableDescriptor
     */
    setUpdatePeriodTableDescriptor(updatePeriodTableDescriptor) {
        this.updatePeriodTableDescriptor = updatePeriodTableDescriptor;
    }
    /**
     * Gets the value of the updatePeriod property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the updatePeriod property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getUpdatePeriod().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XUpdatePeriod
     *
     * @return string[]
     */
    getUpdatePeriod() {
        return this.updatePeriod;
    }

    /**
     * Gets the value of the updatePeriod property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the updatePeriod property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getUpdatePeriod().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XUpdatePeriod
     *
     * @param string[] updatePeriod
     */
    setUpdatePeriod(updatePeriod) {
        this.updatePeriod = updatePeriod;
    }

    /**
     * Returns a JSON object for this XUpdatePeriods
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.updatePeriodTableDescriptor) {
            json['updatePeriodTableDescriptor'] = [];
            this.updatePeriodTableDescriptor.forEach(function(x, i){
                json['updatePeriodTableDescriptor'][i] = x.toJSON();
            });
        }
        if (this.updatePeriod) {
            json['updatePeriod'] = [];
            this.updatePeriod.forEach(function(x, i){
                json['updatePeriod'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSegmentation = class {

    /**
     * Constructs a XSegmentation from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['segements'] !== 'undefined') {
            this.segements = new exports.Org.Apache.Lens.Api.Metastore.XSegments(o['segements']);
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['cubeName'] !== 'undefined') {
            this.cubeName = o['cubeName'];
        }
        if (typeof o['weight'] !== 'undefined') {
            this.weight = o['weight'];
        }
    }

    /**
     * possible object is
       * XProperties 
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * possible object is
       * XProperties 
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * possible object is
       * XSegments 
     *
     * @return Org.Apache.Lens.Api.Metastore.XSegments
     */
    getSegements() {
        return this.segements;
    }

    /**
     * possible object is
       * XSegments 
     *
     * @param Org.Apache.Lens.Api.Metastore.XSegments segements
     */
    setSegements(segements) {
        this.segements = segements;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * possible object is
       * String 
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getCubeName() {
        return this.cubeName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string cubeName
     */
    setCubeName(cubeName) {
        this.cubeName = cubeName;
    }
    /**
     * Gets the value of the weight property.
     *
     * @return double
     */
    getWeight() {
        return this.weight;
    }

    /**
     * Gets the value of the weight property.
     *
     * @param double weight
     */
    setWeight(weight) {
        this.weight = weight;
    }

    /**
     * Returns a JSON object for this XSegmentation
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.segements !== 'undefined') {
            json['segements'] = this.segements.toJSON();
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.cubeName !== 'undefined') {
            json['cubeName'] = this.cubeName;
        }
        if (typeof this.weight !== 'undefined') {
            json['weight'] = this.weight;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinPaths = class {

    /**
     * Constructs a XJoinPaths from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.path = [];
        if (o['path']) {
            o['path'].forEach(function(x, i){
                self.path[i] = new exports.Org.Apache.Lens.Api.Metastore.XJoinPath(x);
            });
        }
    }

    /**
     * Gets the value of the path property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the path property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPath().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XJoinPath
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinPath[]
     */
    getPath() {
        return this.path;
    }

    /**
     * Gets the value of the path property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the path property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPath().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XJoinPath
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinPath[] path
     */
    setPath(path) {
        this.path = path;
    }

    /**
     * Returns a JSON object for this XJoinPaths
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.path) {
            json['path'] = [];
            this.path.forEach(function(x, i){
                json['path'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorageTableElement = class {

    /**
     * Constructs a XStorageTableElement from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['updatePeriods'] !== 'undefined') {
            this.updatePeriods = new exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriods(o['updatePeriods']);
        }
        if (typeof o['storageName'] !== 'undefined') {
            this.storageName = o['storageName'];
        }
        if (typeof o['tableDesc'] !== 'undefined') {
            this.tableDesc = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc(o['tableDesc']);
        }
    }

    /**
     * possible object is
       * XUpdatePeriods 
     *
     * @return Org.Apache.Lens.Api.Metastore.XUpdatePeriods
     */
    getUpdatePeriods() {
        return this.updatePeriods;
    }

    /**
     * possible object is
       * XUpdatePeriods 
     *
     * @param Org.Apache.Lens.Api.Metastore.XUpdatePeriods updatePeriods
     */
    setUpdatePeriods(updatePeriods) {
        this.updatePeriods = updatePeriods;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getStorageName() {
        return this.storageName;
    }

    /**
     * possible object is
       * String 
     *
     * @param string storageName
     */
    setStorageName(storageName) {
        this.storageName = storageName;
    }
    /**
     * possible object is
       * XStorageTableDesc 
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableDesc
     */
    getTableDesc() {
        return this.tableDesc;
    }

    /**
     * possible object is
       * XStorageTableDesc 
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableDesc tableDesc
     */
    setTableDesc(tableDesc) {
        this.tableDesc = tableDesc;
    }

    /**
     * Returns a JSON object for this XStorageTableElement
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.updatePeriods !== 'undefined') {
            json['updatePeriods'] = this.updatePeriods.toJSON();
        }
        if (typeof this.storageName !== 'undefined') {
            json['storageName'] = this.storageName;
        }
        if (typeof this.tableDesc !== 'undefined') {
            json['tableDesc'] = this.tableDesc.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartSpec = class {

    /**
     * Constructs a XPartSpec from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.partSpecElement = [];
        if (o['partSpecElement']) {
            o['partSpecElement'].forEach(function(x, i){
                self.partSpecElement[i] = new exports.Org.Apache.Lens.Api.Metastore.XPartSpecElement(x);
            });
        }
    }

    /**
     * Gets the value of the partSpecElement property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the partSpecElement property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPartSpecElement().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XPartSpecElement
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartSpecElement[]
     */
    getPartSpecElement() {
        return this.partSpecElement;
    }

    /**
     * Gets the value of the partSpecElement property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the partSpecElement property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPartSpecElement().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XPartSpecElement
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartSpecElement[] partSpecElement
     */
    setPartSpecElement(partSpecElement) {
        this.partSpecElement = partSpecElement;
    }

    /**
     * Returns a JSON object for this XPartSpec
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.partSpecElement) {
            json['partSpecElement'] = [];
            this.partSpecElement.forEach(function(x, i){
                json['partSpecElement'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinEdges = class {

    /**
     * Constructs a XJoinEdges from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.edge = [];
        if (o['edge']) {
            o['edge'].forEach(function(x, i){
                self.edge[i] = new exports.Org.Apache.Lens.Api.Metastore.XJoinEdge(x);
            });
        }
    }

    /**
     * Gets the value of the edge property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the edge property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getEdge().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XJoinEdge
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinEdge[]
     */
    getEdge() {
        return this.edge;
    }

    /**
     * Gets the value of the edge property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the edge property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getEdge().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XJoinEdge
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinEdge[] edge
     */
    setEdge(edge) {
        this.edge = edge;
    }

    /**
     * Returns a JSON object for this XJoinEdges
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.edge) {
            json['edge'] = [];
            this.edge.forEach(function(x, i){
                json['edge'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.ToYAMLString = class {

    /**
     * Constructs a ToYAMLString from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.fieldsToAppend = [];
        if (o['fieldsToAppend']) {
            o['fieldsToAppend'].forEach(function(x, i){
                self.fieldsToAppend[i] = new exports.Org.Apache.Lens.Api.FieldNameAndValue(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.FieldNameAndValue[]
     */
    getFieldsToAppend() {
        return this.fieldsToAppend;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.FieldNameAndValue[] fieldsToAppend
     */
    setFieldsToAppend(fieldsToAppend) {
        this.fieldsToAppend = fieldsToAppend;
    }

    /**
     * Returns a JSON object for this ToYAMLString
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.fieldsToAppend) {
            json['fieldsToAppend'] = [];
            this.fieldsToAppend.forEach(function(x, i){
                json['fieldsToAppend'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.ResultColumn = class {

    /**
     * Constructs a ResultColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
    }

    /**
     * The name.
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * The name.
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * The type.
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * The type.
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }

    /**
     * Returns a JSON object for this ResultColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.StringList = class {

    /**
     * Constructs a StringList from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.elements = [];
        if (o['elements']) {
            o['elements'].forEach(function(x, i){
                self.elements[i] = x;
            });
        }
    }

    /**
     * The elements.
     *
     * @return string[]
     */
    getElements() {
        return this.elements;
    }

    /**
     * The elements.
     *
     * @param string[] elements
     */
    setElements(elements) {
        this.elements = elements;
    }

    /**
     * Returns a JSON object for this StringList
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.elements) {
            json['elements'] = [];
            this.elements.forEach(function(x, i){
                json['elements'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartitionList = class {

    /**
     * Constructs a XPartitionList from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.partition = [];
        if (o['partition']) {
            o['partition'].forEach(function(x, i){
                self.partition[i] = new exports.Org.Apache.Lens.Api.Metastore.XPartition(x);
            });
        }
    }

    /**
     * Gets the value of the partition property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the partition property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPartition().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XPartition
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartition[]
     */
    getPartition() {
        return this.partition;
    }

    /**
     * Gets the value of the partition property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the partition property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getPartition().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XPartition
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartition[] partition
     */
    setPartition(partition) {
        this.partition = partition;
    }

    /**
     * Returns a JSON object for this XPartitionList
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.partition) {
            json['partition'] = [];
            this.partition.forEach(function(x, i){
                json['partition'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XColumns = class {

    /**
     * Constructs a XColumns from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.column = [];
        if (o['column']) {
            o['column'].forEach(function(x, i){
                self.column[i] = new exports.Org.Apache.Lens.Api.Metastore.XColumn(x);
            });
        }
    }

    /**
     * Gets the value of the column property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the column property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getColumn().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XColumn
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumn[]
     */
    getColumn() {
        return this.column;
    }

    /**
     * Gets the value of the column property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the column property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getColumn().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XColumn
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumn[] column
     */
    setColumn(column) {
        this.column = column;
    }

    /**
     * Returns a JSON object for this XColumns
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.column) {
            json['column'] = [];
            this.column.forEach(function(x, i){
                json['column'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QuerySubmitResult = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QuerySubmitResult from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
    }


    /**
     * Returns a JSON object for this QuerySubmitResult
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XExprColumn = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XExprColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        this.exprSpec = [];
        if (o['exprSpec']) {
            o['exprSpec'].forEach(function(x, i){
                self.exprSpec[i] = new exports.Org.Apache.Lens.Api.Metastore.XExprSpec(x);
            });
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
    }

    /**
     * Gets the value of the exprSpec property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the exprSpec property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getExprSpec().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XExprSpec
     *
     * @return Org.Apache.Lens.Api.Metastore.XExprSpec[]
     */
    getExprSpec() {
        return this.exprSpec;
    }

    /**
     * Gets the value of the exprSpec property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the exprSpec property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getExprSpec().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XExprSpec
     *
     * @param Org.Apache.Lens.Api.Metastore.XExprSpec[] exprSpec
     */
    setExprSpec(exprSpec) {
        this.exprSpec = exprSpec;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * possible object is
       * String 
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }

    /**
     * Returns a JSON object for this XExprColumn
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (this.exprSpec) {
            json['exprSpec'] = [];
            this.exprSpec.forEach(function(x, i){
                json['exprSpec'][i] = x.toJSON();
            });
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobState = {

    /**
     * 
     */
    NEW: "NEW", 

    /**
     * 
     */
    SCHEDULED: "SCHEDULED", 

    /**
     * 
     */
    SUSPENDED: "SUSPENDED", 

    /**
     * 
     */
    EXPIRED: "EXPIRED", 

    /**
     * 
     */
    DELETED: "DELETED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ParameterDataType = {

    /**
     * String data type
     */
    STRING: "STRING", 

    /**
     * Number data type
     */
    NUMBER: "NUMBER", 

    /**
     * Decimal data type
     */
    DECIMAL: "DECIMAL", 

    /**
     * Boolean data type
     */
    BOOLEAN: "BOOLEAN"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XMeasure = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XMeasure from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
        if (typeof o['defaultAggr'] !== 'undefined') {
            this.defaultAggr = o['defaultAggr'];
        }
        if (typeof o['formatString'] !== 'undefined') {
            this.formatString = o['formatString'];
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
        if (typeof o['unit'] !== 'undefined') {
            this.unit = o['unit'];
        }
        if (typeof o['min'] !== 'undefined') {
            this.min = o['min'];
        }
        if (typeof o['max'] !== 'undefined') {
            this.max = o['max'];
        }
    }

    /**
     * possible object is
       * XMeasureType 
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * possible object is
       * XMeasureType 
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDefaultAggr() {
        return this.defaultAggr;
    }

    /**
     * possible object is
       * String 
     *
     * @param string defaultAggr
     */
    setDefaultAggr(defaultAggr) {
        this.defaultAggr = defaultAggr;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getFormatString() {
        return this.formatString;
    }

    /**
     * possible object is
       * String 
     *
     * @param string formatString
     */
    setFormatString(formatString) {
        this.formatString = formatString;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getUnit() {
        return this.unit;
    }

    /**
     * possible object is
       * String 
     *
     * @param string unit
     */
    setUnit(unit) {
        this.unit = unit;
    }
    /**
     * possible object is
       * Double 
     *
     * @return double
     */
    getMin() {
        return this.min;
    }

    /**
     * possible object is
       * Double 
     *
     * @param double min
     */
    setMin(min) {
        this.min = min;
    }
    /**
     * possible object is
       * Double 
     *
     * @return double
     */
    getMax() {
        return this.max;
    }

    /**
     * possible object is
       * Double 
     *
     * @param double max
     */
    setMax(max) {
        this.max = max;
    }

    /**
     * Returns a JSON object for this XMeasure
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        if (typeof this.defaultAggr !== 'undefined') {
            json['defaultAggr'] = this.defaultAggr;
        }
        if (typeof this.formatString !== 'undefined') {
            json['formatString'] = this.formatString;
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        if (typeof this.unit !== 'undefined') {
            json['unit'] = this.unit;
        }
        if (typeof this.min !== 'undefined') {
            json['min'] = this.min;
        }
        if (typeof this.max !== 'undefined') {
            json['max'] = this.max;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryResult = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QueryResult from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
    }


    /**
     * Returns a JSON object for this QueryResult
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.DateTime = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a DateTime from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['date'] !== 'undefined') {
            this.date = o['date'];
        }
    }

    /**
     * The Date.
     *
     * @return integer
     */
    getDate() {
        return this.date;
    }

    /**
     * The Date.
     *
     * @param integer date
     */
    setDate(date) {
        this.date = date;
    }

    /**
     * Returns a JSON object for this DateTime
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.date !== 'undefined') {
            json['date'] = this.date;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimAttribute = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XDimAttribute from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        this.chainRefColumn = [];
        if (o['chainRefColumn']) {
            o['chainRefColumn'].forEach(function(x, i){
                self.chainRefColumn[i] = new exports.Org.Apache.Lens.Api.Metastore.XChainColumn(x);
            });
        }
        if (typeof o['hierarchy'] !== 'undefined') {
            this.hierarchy = new exports.Org.Apache.Lens.Api.Metastore.XDimAttributes(o['hierarchy']);
        }
        this.values = [];
        if (o['values']) {
            o['values'].forEach(function(x, i){
                self.values[i] = x;
            });
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
        if (typeof o['numDistinctValues'] !== 'undefined') {
            this.numDistinctValues = o['numDistinctValues'];
        }
    }

    /**
     * Gets the value of the chainRefColumn property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the chainRefColumn property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getChainRefColumn().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XChainColumn
     *
     * @return Org.Apache.Lens.Api.Metastore.XChainColumn[]
     */
    getChainRefColumn() {
        return this.chainRefColumn;
    }

    /**
     * Gets the value of the chainRefColumn property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the chainRefColumn property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getChainRefColumn().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * XChainColumn
     *
     * @param Org.Apache.Lens.Api.Metastore.XChainColumn[] chainRefColumn
     */
    setChainRefColumn(chainRefColumn) {
        this.chainRefColumn = chainRefColumn;
    }
    /**
     * possible object is
       * XDimAttributes 
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttributes
     */
    getHierarchy() {
        return this.hierarchy;
    }

    /**
     * possible object is
       * XDimAttributes 
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttributes hierarchy
     */
    setHierarchy(hierarchy) {
        this.hierarchy = hierarchy;
    }
    /**
     * Gets the value of the values property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the values property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getValues().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @return string[]
     */
    getValues() {
        return this.values;
    }

    /**
     * Gets the value of the values property.
       * 
       * &lt;p&gt;
       * This accessor method returns a reference to the live list,
       * not a snapshot. Therefore any modification you make to the
       * returned list will be present inside the JAXB object.
       * This is why there is not a &lt;CODE&gt;set&lt;/CODE&gt; method for the values property.
       * 
       * &lt;p&gt;
       * For example, to add a new item, do as follows:
       * &lt;pre&gt;
       *     getValues().add(newItem);
       *  &lt;/pre&gt;
       * 
       * 
       * &lt;p&gt;
       * Objects of the following type(s) are allowed in the list
       * String
     *
     * @param string[] values
     */
    setValues(values) {
        this.values = values;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * possible object is
       * String 
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * possible object is
       * XMLGregorianCalendar 
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }
    /**
     * possible object is
       * Long 
     *
     * @return integer
     */
    getNumDistinctValues() {
        return this.numDistinctValues;
    }

    /**
     * possible object is
       * Long 
     *
     * @param integer numDistinctValues
     */
    setNumDistinctValues(numDistinctValues) {
        this.numDistinctValues = numDistinctValues;
    }

    /**
     * Returns a JSON object for this XDimAttribute
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (this.chainRefColumn) {
            json['chainRefColumn'] = [];
            this.chainRefColumn.forEach(function(x, i){
                json['chainRefColumn'][i] = x.toJSON();
            });
        }
        if (typeof this.hierarchy !== 'undefined') {
            json['hierarchy'] = this.hierarchy.toJSON();
        }
        if (this.values) {
            json['values'] = [];
            this.values.forEach(function(x, i){
                json['values'][i] = x;
            });
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        if (typeof this.numDistinctValues !== 'undefined') {
            json['numDistinctValues'] = this.numDistinctValues;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.Action = {

    /**
     * Resource is created
     */
    CREATED: "CREATED", 

    /**
     * Resource is updated
     */
    UPDATED: "UPDATED", 

    /**
     * Resource is updated
     */
    DELETED: "DELETED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.Priority = {

    /**
     * The very high.
     */
    VERY_HIGH: "VERY_HIGH", 

    /**
     * The high.
     */
    HIGH: "HIGH", 

    /**
     * The normal.
     */
    NORMAL: "NORMAL", 

    /**
     * The low.
     */
    LOW: "LOW", 

    /**
     * The very low.
     */
    VERY_LOW: "VERY_LOW"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.LensSessionHandle = class extends exports.Org.Apache.Lens.Api.ToXMLString {

    /**
     * Constructs a LensSessionHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['publicId'] !== 'undefined') {
            this.publicId = o['publicId'];
        }
        if (typeof o['secretId'] !== 'undefined') {
            this.secretId = o['secretId'];
        }
    }

    /**
     * The public id.
     *
     * @return string
     */
    getPublicId() {
        return this.publicId;
    }

    /**
     * The public id.
     *
     * @param string publicId
     */
    setPublicId(publicId) {
        this.publicId = publicId;
    }
    /**
     * The secret id.
     *
     * @return string
     */
    getSecretId() {
        return this.secretId;
    }

    /**
     * The secret id.
     *
     * @param string secretId
     */
    setSecretId(secretId) {
        this.secretId = secretId;
    }

    /**
     * Returns a JSON object for this LensSessionHandle
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.publicId !== 'undefined') {
            json['publicId'] = this.publicId;
        }
        if (typeof this.secretId !== 'undefined') {
            json['secretId'] = this.secretId;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.ResultColumnType = {

    /**
     * The boolean.
     */
    BOOLEAN: "BOOLEAN", 

    /**
     * The tinyint.
     */
    TINYINT: "TINYINT", 

    /**
     * The smallint.
     */
    SMALLINT: "SMALLINT", 

    /**
     * The int.
     */
    INT: "INT", 

    /**
     * The bigint.
     */
    BIGINT: "BIGINT", 

    /**
     * The float.
     */
    FLOAT: "FLOAT", 

    /**
     * The double.
     */
    DOUBLE: "DOUBLE", 

    /**
     * The string.
     */
    STRING: "STRING", 

    /**
     * The timestamp.
     */
    TIMESTAMP: "TIMESTAMP", 

    /**
     * The binary.
     */
    BINARY: "BINARY", 

    /**
     * The array.
     */
    ARRAY: "ARRAY", 

    /**
     * The map.
     */
    MAP: "MAP", 

    /**
     * The struct.
     */
    STRUCT: "STRUCT", 

    /**
     * The uniontype.
     */
    UNIONTYPE: "UNIONTYPE", 

    /**
     * The user defined.
     */
    USER_DEFINED: "USER_DEFINED", 

    /**
     * The decimal.
     */
    DECIMAL: "DECIMAL", 

    /**
     * The null.
     */
    NULL: "NULL", 

    /**
     * The date.
     */
    DATE: "DATE", 

    /**
     * The varchar.
     */
    VARCHAR: "VARCHAR", 

    /**
     * The char.
     */
    CHAR: "CHAR"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.Status = {

    /**
     * The new.
     */
    NEW: "NEW", 

    /**
     * The queued.
    * At this point the query is queued by the server and it waiting to be launched. The launch may be controlled by
    * multiple factors like query throttling, quota, etc
     */
    QUEUED: "QUEUED", 

    /**
     * The launched.
    * At this point the query is launched for execution.
     */
    LAUNCHED: "LAUNCHED", 

    /**
     * The running.
    * At this point the query starts running on chosen driver
     */
    RUNNING: "RUNNING", 

    /**
     * The executed.
    * At this point execution is finished by driver, but server may still have some more operations pending
    * like result persistence, if enabled.
     */
    EXECUTED: "EXECUTED", 

    /**
     * This state is when depending on retry policy, either the query moves to QUEUED (in case retries are to be done),
    * or to FAILED.
     */
    FAILING: "FAILING", 

    /**
     * The successful.
    * At this point all operations related to the query are finished successfully by driver and server.
     */
    SUCCESSFUL: "SUCCESSFUL", 

    /**
     * The failed.
     */
    FAILED: "FAILED", 

    /**
     * The canceled.
     */
    CANCELED: "CANCELED", 

    /**
     * The closed.
    * At this point the query is purged by the server. Persistent result will still be available to the user
     */
    CLOSED: "CLOSED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XMeasureType = {

    /**
     * 
     */
    TINYINT: "TINYINT", 

    /**
     * 
     */
    SMALLINT: "SMALLINT", 

    /**
     * 
     */
    INT: "INT", 

    /**
     * 
     */
    BIGINT: "BIGINT", 

    /**
     * 
     */
    FLOAT: "FLOAT", 

    /**
     * 
     */
    DOUBLE: "DOUBLE", 

    /**
     * 
     */
    DECIMAL: "DECIMAL"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.Status = {

    /**
     * The succeeded.
     */
    SUCCEEDED: "SUCCEEDED", 

    /**
     * The partial.
     */
    PARTIAL: "PARTIAL", 

    /**
     * The failed.
     */
    FAILED: "FAILED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.LensQuery = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a LensQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['errorCode'] !== 'undefined') {
            this.errorCode = o['errorCode'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['queryHandleString'] !== 'undefined') {
            this.queryHandleString = o['queryHandleString'];
        }
        if (typeof o['queryHandle'] !== 'undefined') {
            this.queryHandle = new exports.Org.Apache.Lens.Api.Query.QueryHandle(o['queryHandle']);
        }
        if (typeof o['userQuery'] !== 'undefined') {
            this.userQuery = o['userQuery'];
        }
        if (typeof o['submittedUser'] !== 'undefined') {
            this.submittedUser = o['submittedUser'];
        }
        if (typeof o['priority'] !== 'undefined') {
            this.priority = o['priority'];
        }
        if (typeof o['persistent'] !== 'undefined') {
            this.persistent = o['persistent'];
        }
        if (typeof o['selectedDriverName'] !== 'undefined') {
            this.selectedDriverName = o['selectedDriverName'];
        }
        if (typeof o['driverQuery'] !== 'undefined') {
            this.driverQuery = o['driverQuery'];
        }
        if (typeof o['status'] !== 'undefined') {
            this.status = new exports.Org.Apache.Lens.Api.Query.QueryStatus(o['status']);
        }
        if (typeof o['resultSetPath'] !== 'undefined') {
            this.resultSetPath = o['resultSetPath'];
        }
        if (typeof o['driverOpHandle'] !== 'undefined') {
            this.driverOpHandle = o['driverOpHandle'];
        }
        if (typeof o['queryConf'] !== 'undefined') {
            this.queryConf = new exports.Org.Apache.Lens.Api.LensConf(o['queryConf']);
        }
        if (typeof o['submissionTime'] !== 'undefined') {
            this.submissionTime = o['submissionTime'];
        }
        if (typeof o['launchTime'] !== 'undefined') {
            this.launchTime = o['launchTime'];
        }
        if (typeof o['driverStartTime'] !== 'undefined') {
            this.driverStartTime = o['driverStartTime'];
        }
        if (typeof o['driverFinishTime'] !== 'undefined') {
            this.driverFinishTime = o['driverFinishTime'];
        }
        if (typeof o['finishTime'] !== 'undefined') {
            this.finishTime = o['finishTime'];
        }
        if (typeof o['closedTime'] !== 'undefined') {
            this.closedTime = o['closedTime'];
        }
        if (typeof o['queryName'] !== 'undefined') {
            this.queryName = o['queryName'];
        }
        this.failedAttempts = [];
        if (o['failedAttempts']) {
            o['failedAttempts'].forEach(function(x, i){
                self.failedAttempts[i] = new exports.Org.Apache.Lens.Api.Query.FailedAttempt(x);
            });
        }
    }

    /**
     * error code in case of query failures
     *
     * @return integer
     */
    getErrorCode() {
        return this.errorCode;
    }

    /**
     * error code in case of query failures
     *
     * @param integer errorCode
     */
    setErrorCode(errorCode) {
        this.errorCode = errorCode;
    }
    /**
     * error message in case of query failures
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * error message in case of query failures
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * the query handle string
     *
     * @return string
     */
    getQueryHandleString() {
        return this.queryHandleString;
    }

    /**
     * the query handle string
     *
     * @param string queryHandleString
     */
    setQueryHandleString(queryHandleString) {
        this.queryHandleString = queryHandleString;
    }
    /**
     * The query handle that represents this query uniquely
     *
     * @return Org.Apache.Lens.Api.Query.QueryHandle
     */
    getQueryHandle() {
        return this.queryHandle;
    }

    /**
     * The query handle that represents this query uniquely
     *
     * @param Org.Apache.Lens.Api.Query.QueryHandle queryHandle
     */
    setQueryHandle(queryHandle) {
        this.queryHandle = queryHandle;
    }
    /**
     * The the query submitted by the user
     *
     * @return string
     */
    getUserQuery() {
        return this.userQuery;
    }

    /**
     * The the query submitted by the user
     *
     * @param string userQuery
     */
    setUserQuery(userQuery) {
        this.userQuery = userQuery;
    }
    /**
     * The user who submitted the query.
     *
     * @return string
     */
    getSubmittedUser() {
        return this.submittedUser;
    }

    /**
     * The user who submitted the query.
     *
     * @param string submittedUser
     */
    setSubmittedUser(submittedUser) {
        this.submittedUser = submittedUser;
    }
    /**
     * The priority of the query.
     *
     * @return string
     */
    getPriority() {
        return this.priority;
    }

    /**
     * The priority of the query.
     *
     * @param string priority
     */
    setPriority(priority) {
        this.priority = priority;
    }
    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @return boolean
     */
    getPersistent() {
        return this.persistent;
    }

    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @param boolean persistent
     */
    setPersistent(persistent) {
        this.persistent = persistent;
    }
    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @return string
     */
    getSelectedDriverName() {
        return this.selectedDriverName;
    }

    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @param string selectedDriverName
     */
    setSelectedDriverName(selectedDriverName) {
        this.selectedDriverName = selectedDriverName;
    }
    /**
     * The driver query.
       * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @return string
     */
    getDriverQuery() {
        return this.driverQuery;
    }

    /**
     * The driver query.
       * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @param string driverQuery
     */
    setDriverQuery(driverQuery) {
        this.driverQuery = driverQuery;
    }
    /**
     * The status of this query.
       * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
       * the current state of the query. Also other utility methods are available to check the status of the query like
       * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
       * QueryStatus#failed() and QueryStatus#running()
     *
     * @return Org.Apache.Lens.Api.Query.QueryStatus
     */
    getStatus() {
        return this.status;
    }

    /**
     * The status of this query.
       * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
       * the current state of the query. Also other utility methods are available to check the status of the query like
       * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
       * QueryStatus#failed() and QueryStatus#running()
     *
     * @param Org.Apache.Lens.Api.Query.QueryStatus status
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @return string
     */
    getResultSetPath() {
        return this.resultSetPath;
    }

    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @param string resultSetPath
     */
    setResultSetPath(resultSetPath) {
        this.resultSetPath = resultSetPath;
    }
    /**
     * The operation handle associated with the driver, if any.
     *
     * @return string
     */
    getDriverOpHandle() {
        return this.driverOpHandle;
    }

    /**
     * The operation handle associated with the driver, if any.
     *
     * @param string driverOpHandle
     */
    setDriverOpHandle(driverOpHandle) {
        this.driverOpHandle = driverOpHandle;
    }
    /**
     * The query conf that was used for executing this query.
     *
     * @return Org.Apache.Lens.Api.LensConf
     */
    getQueryConf() {
        return this.queryConf;
    }

    /**
     * The query conf that was used for executing this query.
     *
     * @param Org.Apache.Lens.Api.LensConf queryConf
     */
    setQueryConf(queryConf) {
        this.queryConf = queryConf;
    }
    /**
     * The submission time.
     *
     * @return integer
     */
    getSubmissionTime() {
        return this.submissionTime;
    }

    /**
     * The submission time.
     *
     * @param integer submissionTime
     */
    setSubmissionTime(submissionTime) {
        this.submissionTime = submissionTime;
    }
    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @return integer
     */
    getLaunchTime() {
        return this.launchTime;
    }

    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @param integer launchTime
     */
    setLaunchTime(launchTime) {
        this.launchTime = launchTime;
    }
    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @return integer
     */
    getDriverStartTime() {
        return this.driverStartTime;
    }

    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @param integer driverStartTime
     */
    setDriverStartTime(driverStartTime) {
        this.driverStartTime = driverStartTime;
    }
    /**
     * The the query execution end time on driver.
     *
     * @return integer
     */
    getDriverFinishTime() {
        return this.driverFinishTime;
    }

    /**
     * The the query execution end time on driver.
     *
     * @param integer driverFinishTime
     */
    setDriverFinishTime(driverFinishTime) {
        this.driverFinishTime = driverFinishTime;
    }
    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
       * formatting the result)
     *
     * @return integer
     */
    getFinishTime() {
        return this.finishTime;
    }

    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
       * formatting the result)
     *
     * @param integer finishTime
     */
    setFinishTime(finishTime) {
        this.finishTime = finishTime;
    }
    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
       * Note: not supported as of now.
     *
     * @return integer
     */
    getClosedTime() {
        return this.closedTime;
    }

    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
       * Note: not supported as of now.
     *
     * @param integer closedTime
     */
    setClosedTime(closedTime) {
        this.closedTime = closedTime;
    }
    /**
     * The query name, if any.
     *
     * @return string
     */
    getQueryName() {
        return this.queryName;
    }

    /**
     * The query name, if any.
     *
     * @param string queryName
     */
    setQueryName(queryName) {
        this.queryName = queryName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Query.FailedAttempt[]
     */
    getFailedAttempts() {
        return this.failedAttempts;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Query.FailedAttempt[] failedAttempts
     */
    setFailedAttempts(failedAttempts) {
        this.failedAttempts = failedAttempts;
    }

    /**
     * Returns a JSON object for this LensQuery
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.errorCode !== 'undefined') {
            json['errorCode'] = this.errorCode;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.queryHandleString !== 'undefined') {
            json['queryHandleString'] = this.queryHandleString;
        }
        if (typeof this.queryHandle !== 'undefined') {
            json['queryHandle'] = this.queryHandle.toJSON();
        }
        if (typeof this.userQuery !== 'undefined') {
            json['userQuery'] = this.userQuery;
        }
        if (typeof this.submittedUser !== 'undefined') {
            json['submittedUser'] = this.submittedUser;
        }
        if (typeof this.priority !== 'undefined') {
            json['priority'] = this.priority;
        }
        if (typeof this.persistent !== 'undefined') {
            json['persistent'] = this.persistent;
        }
        if (typeof this.selectedDriverName !== 'undefined') {
            json['selectedDriverName'] = this.selectedDriverName;
        }
        if (typeof this.driverQuery !== 'undefined') {
            json['driverQuery'] = this.driverQuery;
        }
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status.toJSON();
        }
        if (typeof this.resultSetPath !== 'undefined') {
            json['resultSetPath'] = this.resultSetPath;
        }
        if (typeof this.driverOpHandle !== 'undefined') {
            json['driverOpHandle'] = this.driverOpHandle;
        }
        if (typeof this.queryConf !== 'undefined') {
            json['queryConf'] = this.queryConf.toJSON();
        }
        if (typeof this.submissionTime !== 'undefined') {
            json['submissionTime'] = this.submissionTime;
        }
        if (typeof this.launchTime !== 'undefined') {
            json['launchTime'] = this.launchTime;
        }
        if (typeof this.driverStartTime !== 'undefined') {
            json['driverStartTime'] = this.driverStartTime;
        }
        if (typeof this.driverFinishTime !== 'undefined') {
            json['driverFinishTime'] = this.driverFinishTime;
        }
        if (typeof this.finishTime !== 'undefined') {
            json['finishTime'] = this.finishTime;
        }
        if (typeof this.closedTime !== 'undefined') {
            json['closedTime'] = this.closedTime;
        }
        if (typeof this.queryName !== 'undefined') {
            json['queryName'] = this.queryName;
        }
        if (this.failedAttempts) {
            json['failedAttempts'] = [];
            this.failedAttempts.forEach(function(x, i){
                json['failedAttempts'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceState = {

    /**
     * 
     */
    WAITING: "WAITING", 

    /**
     * 
     */
    LAUNCHING: "LAUNCHING", 

    /**
     * 
     */
    LAUNCHED: "LAUNCHED", 

    /**
     * 
     */
    RUNNING: "RUNNING", 

    /**
     * 
     */
    FAILED: "FAILED", 

    /**
     * 
     */
    SUCCEEDED: "SUCCEEDED", 

    /**
     * 
     */
    TIMED_OUT: "TIMED_OUT", 

    /**
     * 
     */
    KILLED: "KILLED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryStatus = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QueryStatus from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['errorCode'] !== 'undefined') {
            this.errorCode = o['errorCode'];
        }
        if (typeof o['lensErrorTOErrorMsg'] !== 'undefined') {
            this.lensErrorTOErrorMsg = o['lensErrorTOErrorMsg'];
        }
        if (typeof o['queuedStatus'] !== 'undefined') {
            this.queuedStatus = new exports.Org.Apache.Lens.Api.Query.QueryStatus(o['queuedStatus']);
        }
        if (typeof o['progress'] !== 'undefined') {
            this.progress = o['progress'];
        }
        if (typeof o['queueNumber'] !== 'undefined') {
            this.queueNumber = o['queueNumber'];
        }
        if (typeof o['status'] !== 'undefined') {
            this.status = o['status'];
        }
        if (typeof o['statusMessage'] !== 'undefined') {
            this.statusMessage = o['statusMessage'];
        }
        if (typeof o['resultSetAvailable'] !== 'undefined') {
            this.resultSetAvailable = o['resultSetAvailable'];
        }
        if (typeof o['progressMessage'] !== 'undefined') {
            this.progressMessage = o['progressMessage'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['lensErrorTO'] !== 'undefined') {
            this.lensErrorTO = new exports.Org.Apache.Lens.Api.Result.LensErrorTO(o['lensErrorTO']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getErrorCode() {
        return this.errorCode;
    }

    /**
     * (no documentation provided)
     *
     * @param integer errorCode
     */
    setErrorCode(errorCode) {
        this.errorCode = errorCode;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getLensErrorTOErrorMsg() {
        return this.lensErrorTOErrorMsg;
    }

    /**
     * (no documentation provided)
     *
     * @param string lensErrorTOErrorMsg
     */
    setLensErrorTOErrorMsg(lensErrorTOErrorMsg) {
        this.lensErrorTOErrorMsg = lensErrorTOErrorMsg;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Query.QueryStatus
     */
    getQueuedStatus() {
        return this.queuedStatus;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Query.QueryStatus queuedStatus
     */
    setQueuedStatus(queuedStatus) {
        this.queuedStatus = queuedStatus;
    }
    /**
     * The progress.
     *
     * @return double
     */
    getProgress() {
        return this.progress;
    }

    /**
     * The progress.
     *
     * @param double progress
     */
    setProgress(progress) {
        this.progress = progress;
    }
    /**
     * Queue number of a query when it is in waiting state.
     *
     * @return integer
     */
    getQueueNumber() {
        return this.queueNumber;
    }

    /**
     * Queue number of a query when it is in waiting state.
     *
     * @param integer queueNumber
     */
    setQueueNumber(queueNumber) {
        this.queueNumber = queueNumber;
    }
    /**
     * The status.
     *
     * @return string
     */
    getStatus() {
        return this.status;
    }

    /**
     * The status.
     *
     * @param string status
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * The status message.
     *
     * @return string
     */
    getStatusMessage() {
        return this.statusMessage;
    }

    /**
     * The status message.
     *
     * @param string statusMessage
     */
    setStatusMessage(statusMessage) {
        this.statusMessage = statusMessage;
    }
    /**
     * The is result set available.
     *
     * @return boolean
     */
    getResultSetAvailable() {
        return this.resultSetAvailable;
    }

    /**
     * The is result set available.
     *
     * @param boolean resultSetAvailable
     */
    setResultSetAvailable(resultSetAvailable) {
        this.resultSetAvailable = resultSetAvailable;
    }
    /**
     * The progress message.
     *
     * @return string
     */
    getProgressMessage() {
        return this.progressMessage;
    }

    /**
     * The progress message.
     *
     * @param string progressMessage
     */
    setProgressMessage(progressMessage) {
        this.progressMessage = progressMessage;
    }
    /**
     * The error message.
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * The error message.
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Result.LensErrorTO
     */
    getLensErrorTO() {
        return this.lensErrorTO;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Result.LensErrorTO lensErrorTO
     */
    setLensErrorTO(lensErrorTO) {
        this.lensErrorTO = lensErrorTO;
    }

    /**
     * Returns a JSON object for this QueryStatus
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.errorCode !== 'undefined') {
            json['errorCode'] = this.errorCode;
        }
        if (typeof this.lensErrorTOErrorMsg !== 'undefined') {
            json['lensErrorTOErrorMsg'] = this.lensErrorTOErrorMsg;
        }
        if (typeof this.queuedStatus !== 'undefined') {
            json['queuedStatus'] = this.queuedStatus.toJSON();
        }
        if (typeof this.progress !== 'undefined') {
            json['progress'] = this.progress;
        }
        if (typeof this.queueNumber !== 'undefined') {
            json['queueNumber'] = this.queueNumber;
        }
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status;
        }
        if (typeof this.statusMessage !== 'undefined') {
            json['statusMessage'] = this.statusMessage;
        }
        if (typeof this.resultSetAvailable !== 'undefined') {
            json['resultSetAvailable'] = this.resultSetAvailable;
        }
        if (typeof this.progressMessage !== 'undefined') {
            json['progressMessage'] = this.progressMessage;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.lensErrorTO !== 'undefined') {
            json['lensErrorTO'] = this.lensErrorTO.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryResultSetMetadata = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QueryResultSetMetadata from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        this.columns = [];
        if (o['columns']) {
            o['columns'].forEach(function(x, i){
                self.columns[i] = new exports.Org.Apache.Lens.Api.Query.ResultColumn(x);
            });
        }
    }

    /**
     * The columns.
     *
     * @return Org.Apache.Lens.Api.Query.ResultColumn[]
     */
    getColumns() {
        return this.columns;
    }

    /**
     * The columns.
     *
     * @param Org.Apache.Lens.Api.Query.ResultColumn[] columns
     */
    setColumns(columns) {
        this.columns = columns;
    }

    /**
     * Returns a JSON object for this QueryResultSetMetadata
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (this.columns) {
            json['columns'] = [];
            this.columns.forEach(function(x, i){
                json['columns'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriod = {

    /**
     * 
     */
    CONTINUOUS: "CONTINUOUS", 

    /**
     * 
     */
    SECONDLY: "SECONDLY", 

    /**
     * 
     */
    MINUTELY: "MINUTELY", 

    /**
     * 
     */
    HOURLY: "HOURLY", 

    /**
     * 
     */
    DAILY: "DAILY", 

    /**
     * 
     */
    WEEKLY: "WEEKLY", 

    /**
     * 
     */
    MONTHLY: "MONTHLY", 

    /**
     * 
     */
    QUARTERLY: "QUARTERLY", 

    /**
     * 
     */
    YEARLY: "YEARLY"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ParameterCollectionType = {

    /**
     * Single valued parameter.
     */
    SINGLE: "SINGLE", 

    /**
     * Multivalued parameter.
     */
    MULTIPLE: "MULTIPLE"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XFrequencyEnum = {

    /**
     * 
     */
    DAILY: "DAILY", 

    /**
     * 
     */
    WEEKLY: "WEEKLY", 

    /**
     * 
     */
    MONTHLY: "MONTHLY", 

    /**
     * 
     */
    QUARTERLY: "QUARTERLY", 

    /**
     * 
     */
    YEARLY: "YEARLY"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.LensConf = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a LensConf from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['properties'] !== 'undefined') {
            this.properties = o['properties'];
        }
    }

    /**
     * The properties.
     *
     * @return array
     */
    getProperties() {
        return this.properties;
    }

    /**
     * The properties.
     *
     * @param array properties
     */
    setProperties(properties) {
        this.properties = properties;
    }

    /**
     * Returns a JSON object for this LensConf
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.APIResult = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a APIResult from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['status'] !== 'undefined') {
            this.status = o['status'];
        }
        if (typeof o['message'] !== 'undefined') {
            this.message = o['message'];
        }
    }

    /**
     * The status.
     *
     * @return string
     */
    getStatus() {
        return this.status;
    }

    /**
     * The status.
     *
     * @param string status
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * The message.
     *
     * @return string
     */
    getMessage() {
        return this.message;
    }

    /**
     * The message.
     *
     * @param string message
     */
    setMessage(message) {
        this.message = message;
    }

    /**
     * Returns a JSON object for this APIResult
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status;
        }
        if (typeof this.message !== 'undefined') {
            json['message'] = this.message;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.LensPreparedQuery = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a LensPreparedQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['prepareHandle'] !== 'undefined') {
            this.prepareHandle = new exports.Org.Apache.Lens.Api.Query.QueryPrepareHandle(o['prepareHandle']);
        }
        if (typeof o['userQuery'] !== 'undefined') {
            this.userQuery = o['userQuery'];
        }
        if (typeof o['preparedTime'] !== 'undefined') {
            this.preparedTime = o['preparedTime'];
        }
        if (typeof o['preparedUser'] !== 'undefined') {
            this.preparedUser = o['preparedUser'];
        }
        if (typeof o['selectedDriverName'] !== 'undefined') {
            this.selectedDriverName = o['selectedDriverName'];
        }
        if (typeof o['driverQuery'] !== 'undefined') {
            this.driverQuery = o['driverQuery'];
        }
        if (typeof o['conf'] !== 'undefined') {
            this.conf = new exports.Org.Apache.Lens.Api.LensConf(o['conf']);
        }
    }

    /**
     * The prepare handle.
     *
     * @return Org.Apache.Lens.Api.Query.QueryPrepareHandle
     */
    getPrepareHandle() {
        return this.prepareHandle;
    }

    /**
     * The prepare handle.
     *
     * @param Org.Apache.Lens.Api.Query.QueryPrepareHandle prepareHandle
     */
    setPrepareHandle(prepareHandle) {
        this.prepareHandle = prepareHandle;
    }
    /**
     * The user query.
     *
     * @return string
     */
    getUserQuery() {
        return this.userQuery;
    }

    /**
     * The user query.
     *
     * @param string userQuery
     */
    setUserQuery(userQuery) {
        this.userQuery = userQuery;
    }
    /**
     * The prepared time.
     *
     * @return integer
     */
    getPreparedTime() {
        return this.preparedTime;
    }

    /**
     * The prepared time.
     *
     * @param integer preparedTime
     */
    setPreparedTime(preparedTime) {
        this.preparedTime = preparedTime;
    }
    /**
     * The prepared user.
     *
     * @return string
     */
    getPreparedUser() {
        return this.preparedUser;
    }

    /**
     * The prepared user.
     *
     * @param string preparedUser
     */
    setPreparedUser(preparedUser) {
        this.preparedUser = preparedUser;
    }
    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @return string
     */
    getSelectedDriverName() {
        return this.selectedDriverName;
    }

    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @param string selectedDriverName
     */
    setSelectedDriverName(selectedDriverName) {
        this.selectedDriverName = selectedDriverName;
    }
    /**
     * The driver query.
     *
     * @return string
     */
    getDriverQuery() {
        return this.driverQuery;
    }

    /**
     * The driver query.
     *
     * @param string driverQuery
     */
    setDriverQuery(driverQuery) {
        this.driverQuery = driverQuery;
    }
    /**
     * The conf.
     *
     * @return Org.Apache.Lens.Api.LensConf
     */
    getConf() {
        return this.conf;
    }

    /**
     * The conf.
     *
     * @param Org.Apache.Lens.Api.LensConf conf
     */
    setConf(conf) {
        this.conf = conf;
    }

    /**
     * Returns a JSON object for this LensPreparedQuery
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.prepareHandle !== 'undefined') {
            json['prepareHandle'] = this.prepareHandle.toJSON();
        }
        if (typeof this.userQuery !== 'undefined') {
            json['userQuery'] = this.userQuery;
        }
        if (typeof this.preparedTime !== 'undefined') {
            json['preparedTime'] = this.preparedTime;
        }
        if (typeof this.preparedUser !== 'undefined') {
            json['preparedUser'] = this.preparedUser;
        }
        if (typeof this.selectedDriverName !== 'undefined') {
            json['selectedDriverName'] = this.selectedDriverName;
        }
        if (typeof this.driverQuery !== 'undefined') {
            json['driverQuery'] = this.driverQuery;
        }
        if (typeof this.conf !== 'undefined') {
            json['conf'] = this.conf.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinChain = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XJoinChain from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['paths'] !== 'undefined') {
            this.paths = new exports.Org.Apache.Lens.Api.Metastore.XJoinPaths(o['paths']);
        }
        if (typeof o['destTable'] !== 'undefined') {
            this.destTable = o['destTable'];
        }
    }

    /**
     * possible object is
       * XJoinPaths 
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinPaths
     */
    getPaths() {
        return this.paths;
    }

    /**
     * possible object is
       * XJoinPaths 
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinPaths paths
     */
    setPaths(paths) {
        this.paths = paths;
    }
    /**
     * possible object is
       * String 
     *
     * @return string
     */
    getDestTable() {
        return this.destTable;
    }

    /**
     * possible object is
       * String 
     *
     * @param string destTable
     */
    setDestTable(destTable) {
        this.destTable = destTable;
    }

    /**
     * Returns a JSON object for this XJoinChain
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.paths !== 'undefined') {
            json['paths'] = this.paths.toJSON();
        }
        if (typeof this.destTable !== 'undefined') {
            json['destTable'] = this.destTable;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryHandle = class extends exports.Org.Apache.Lens.Api.Query.QuerySubmitResult {

    /**
     * Constructs a QueryHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['handleIdString'] !== 'undefined') {
            this.handleIdString = o['handleIdString'];
        }
        if (typeof o['handleId'] !== 'undefined') {
            this.handleId = o['handleId'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getHandleIdString() {
        return this.handleIdString;
    }

    /**
     * (no documentation provided)
     *
     * @param string handleIdString
     */
    setHandleIdString(handleIdString) {
        this.handleIdString = handleIdString;
    }
    /**
     * The handle id.
     *
     * @return string
     */
    getHandleId() {
        return this.handleId;
    }

    /**
     * The handle id.
     *
     * @param string handleId
     */
    setHandleId(handleId) {
        this.handleId = handleId;
    }

    /**
     * Returns a JSON object for this QueryHandle
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.handleIdString !== 'undefined') {
            json['handleIdString'] = this.handleIdString;
        }
        if (typeof this.handleId !== 'undefined') {
            json['handleId'] = this.handleId;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryPrepareHandle = class extends exports.Org.Apache.Lens.Api.Query.QuerySubmitResult {

    /**
     * Constructs a QueryPrepareHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['queryHandleString'] !== 'undefined') {
            this.queryHandleString = o['queryHandleString'];
        }
        if (typeof o['prepareHandleId'] !== 'undefined') {
            this.prepareHandleId = o['prepareHandleId'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getQueryHandleString() {
        return this.queryHandleString;
    }

    /**
     * (no documentation provided)
     *
     * @param string queryHandleString
     */
    setQueryHandleString(queryHandleString) {
        this.queryHandleString = queryHandleString;
    }
    /**
     * The prepare handle id.
     *
     * @return string
     */
    getPrepareHandleId() {
        return this.prepareHandleId;
    }

    /**
     * The prepare handle id.
     *
     * @param string prepareHandleId
     */
    setPrepareHandleId(prepareHandleId) {
        this.prepareHandleId = prepareHandleId;
    }

    /**
     * Returns a JSON object for this QueryPrepareHandle
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.queryHandleString !== 'undefined') {
            json['queryHandleString'] = this.queryHandleString;
        }
        if (typeof this.prepareHandleId !== 'undefined') {
            json['prepareHandleId'] = this.prepareHandleId;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XColumns = class {

    /**
     * Constructs a XColumns from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.column = [];
        if (o['column']) {
            o['column'].forEach(function(x, i){
                self.column[i] = new exports.Org.Apache.Lens.Api.Metastore.XColumn(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumn[]
     */
    getColumn() {
        return this.column;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumn[] column
     */
    setColumn(column) {
        this.column = column;
    }

    /**
     * Returns a JSON object for this XColumns
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.column) {
            json['column'] = [];
            this.column.forEach(function(x, i){
                json['column'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinChain = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XJoinChain from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['dest_table'] !== 'undefined') {
            this.destTable = o['dest_table'];
        }
        if (typeof o['paths'] !== 'undefined') {
            this.paths = new exports.Org.Apache.Lens.Api.Metastore.XJoinPaths(o['paths']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDestTable() {
        return this.destTable;
    }

    /**
     * (no documentation provided)
     *
     * @param string destTable
     */
    setDestTable(destTable) {
        this.destTable = destTable;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinPaths
     */
    getPaths() {
        return this.paths;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinPaths paths
     */
    setPaths(paths) {
        this.paths = paths;
    }

    /**
     * Returns a JSON object for this XJoinChain
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.destTable !== 'undefined') {
            json['dest_table'] = this.destTable;
        }
        if (typeof this.paths !== 'undefined') {
            json['paths'] = this.paths.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinPath = class {

    /**
     * Constructs a XJoinPath from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['edges'] !== 'undefined') {
            this.edges = new exports.Org.Apache.Lens.Api.Metastore.XJoinEdges(o['edges']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinEdges
     */
    getEdges() {
        return this.edges;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinEdges edges
     */
    setEdges(edges) {
        this.edges = edges;
    }

    /**
     * Returns a JSON object for this XJoinPath
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.edges !== 'undefined') {
            json['edges'] = this.edges.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartitionList = class {

    /**
     * Constructs a XPartitionList from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.partition = [];
        if (o['partition']) {
            o['partition'].forEach(function(x, i){
                self.partition[i] = new exports.Org.Apache.Lens.Api.Metastore.XPartition(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartition[]
     */
    getPartition() {
        return this.partition;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartition[] partition
     */
    setPartition(partition) {
        this.partition = partition;
    }

    /**
     * Returns a JSON object for this XPartitionList
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.partition) {
            json['partition'] = [];
            this.partition.forEach(function(x, i){
                json['partition'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XFlattenedColumns = class {

    /**
     * Constructs a XFlattenedColumns from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.flattenedColumn = [];
        if (o['flattened_column']) {
            o['flattened_column'].forEach(function(x, i){
                self.flattenedColumn[i] = new exports.Org.Apache.Lens.Api.Metastore.XFlattenedColumn(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XFlattenedColumn[]
     */
    getFlattenedColumn() {
        return this.flattenedColumn;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XFlattenedColumn[] flattenedColumn
     */
    setFlattenedColumn(flattenedColumn) {
        this.flattenedColumn = flattenedColumn;
    }

    /**
     * Returns a JSON object for this XFlattenedColumns
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.flattenedColumn) {
            json['flattened_column'] = [];
            this.flattenedColumn.forEach(function(x, i){
                json['flattened_column'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.StringList = class {

    /**
     * Constructs a StringList from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.elements = [];
        if (o['elements']) {
            o['elements'].forEach(function(x, i){
                self.elements[i] = x;
            });
        }
    }

    /**
     * The elements.
     *
     * @return string[]
     */
    getElements() {
        return this.elements;
    }

    /**
     * The elements.
     *
     * @param string[] elements
     */
    setElements(elements) {
        this.elements = elements;
    }

    /**
     * Returns a JSON object for this StringList
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.elements) {
            json['elements'] = [];
            this.elements.forEach(function(x, i){
                json['elements'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimensionTable = class {

    /**
     * Constructs a XDimensionTable from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['dimension_name'] !== 'undefined') {
            this.dimensionName = o['dimension_name'];
        }
        if (typeof o['columns'] !== 'undefined') {
            this.columns = new exports.Org.Apache.Lens.Api.Metastore.XColumns(o['columns']);
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['storage_tables'] !== 'undefined') {
            this.storageTables = new exports.Org.Apache.Lens.Api.Metastore.XStorageTables(o['storage_tables']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDimensionName() {
        return this.dimensionName;
    }

    /**
     * (no documentation provided)
     *
     * @param string dimensionName
     */
    setDimensionName(dimensionName) {
        this.dimensionName = dimensionName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumns
     */
    getColumns() {
        return this.columns;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumns columns
     */
    setColumns(columns) {
        this.columns = columns;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTables
     */
    getStorageTables() {
        return this.storageTables;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTables storageTables
     */
    setStorageTables(storageTables) {
        this.storageTables = storageTables;
    }

    /**
     * Returns a JSON object for this XDimensionTable
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.dimensionName !== 'undefined') {
            json['dimension_name'] = this.dimensionName;
        }
        if (typeof this.columns !== 'undefined') {
            json['columns'] = this.columns.toJSON();
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.storageTables !== 'undefined') {
            json['storage_tables'] = this.storageTables.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc = class {

    /**
     * Constructs a XStorageTableDesc from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['external'] !== 'undefined') {
            this.external = o['external'];
        }
        if (typeof o['part_cols'] !== 'undefined') {
            this.partCols = new exports.Org.Apache.Lens.Api.Metastore.XColumns(o['part_cols']);
        }
        if (typeof o['table_parameters'] !== 'undefined') {
            this.tableParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['table_parameters']);
        }
        if (typeof o['serde_parameters'] !== 'undefined') {
            this.serdeParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['serde_parameters']);
        }
        this.bucketCols = [];
        if (o['bucket_cols']) {
            o['bucket_cols'].forEach(function(x, i){
                self.bucketCols[i] = x;
            });
        }
        this.sortCols = [];
        if (o['sort_cols']) {
            o['sort_cols'].forEach(function(x, i){
                self.sortCols[i] = x;
            });
        }
        this.sortColOrder = [];
        if (o['sort_col_order']) {
            o['sort_col_order'].forEach(function(x, i){
                self.sortColOrder[i] = x;
            });
        }
        this.skewedInfo = [];
        if (o['skewed_info']) {
            o['skewed_info'].forEach(function(x, i){
                self.skewedInfo[i] = new exports.Org.Apache.Lens.Api.Metastore.XSkewedInfo(x);
            });
        }
        this.timePartCols = [];
        if (o['time_part_cols']) {
            o['time_part_cols'].forEach(function(x, i){
                self.timePartCols[i] = x;
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    getExternal() {
        return this.external;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean external
     */
    setExternal(external) {
        this.external = external;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumns
     */
    getPartCols() {
        return this.partCols;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumns partCols
     */
    setPartCols(partCols) {
        this.partCols = partCols;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getTableParameters() {
        return this.tableParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties tableParameters
     */
    setTableParameters(tableParameters) {
        this.tableParameters = tableParameters;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getSerdeParameters() {
        return this.serdeParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties serdeParameters
     */
    setSerdeParameters(serdeParameters) {
        this.serdeParameters = serdeParameters;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getBucketCols() {
        return this.bucketCols;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] bucketCols
     */
    setBucketCols(bucketCols) {
        this.bucketCols = bucketCols;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getSortCols() {
        return this.sortCols;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] sortCols
     */
    setSortCols(sortCols) {
        this.sortCols = sortCols;
    }
    /**
     * (no documentation provided)
     *
     * @return integer[]
     */
    getSortColOrder() {
        return this.sortColOrder;
    }

    /**
     * (no documentation provided)
     *
     * @param integer[] sortColOrder
     */
    setSortColOrder(sortColOrder) {
        this.sortColOrder = sortColOrder;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewedInfo[]
     */
    getSkewedInfo() {
        return this.skewedInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewedInfo[] skewedInfo
     */
    setSkewedInfo(skewedInfo) {
        this.skewedInfo = skewedInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getTimePartCols() {
        return this.timePartCols;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] timePartCols
     */
    setTimePartCols(timePartCols) {
        this.timePartCols = timePartCols;
    }

    /**
     * Returns a JSON object for this XStorageTableDesc
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.external !== 'undefined') {
            json['external'] = this.external;
        }
        if (typeof this.partCols !== 'undefined') {
            json['part_cols'] = this.partCols.toJSON();
        }
        if (typeof this.tableParameters !== 'undefined') {
            json['table_parameters'] = this.tableParameters.toJSON();
        }
        if (typeof this.serdeParameters !== 'undefined') {
            json['serde_parameters'] = this.serdeParameters.toJSON();
        }
        if (this.bucketCols) {
            json['bucket_cols'] = [];
            this.bucketCols.forEach(function(x, i){
                json['bucket_cols'][i] = x;
            });
        }
        if (this.sortCols) {
            json['sort_cols'] = [];
            this.sortCols.forEach(function(x, i){
                json['sort_cols'][i] = x;
            });
        }
        if (this.sortColOrder) {
            json['sort_col_order'] = [];
            this.sortColOrder.forEach(function(x, i){
                json['sort_col_order'][i] = x;
            });
        }
        if (this.skewedInfo) {
            json['skewed_info'] = [];
            this.skewedInfo.forEach(function(x, i){
                json['skewed_info'][i] = x.toJSON();
            });
        }
        if (this.timePartCols) {
            json['time_part_cols'] = [];
            this.timePartCols.forEach(function(x, i){
                json['time_part_cols'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryPrepareHandle = class extends exports.Org.Apache.Lens.Api.Query.QuerySubmitResult {

    /**
     * Constructs a QueryPrepareHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['prepareHandleId'] !== 'undefined') {
            this.prepareHandleId = o['prepareHandleId'];
        }
        if (typeof o['queryHandleString'] !== 'undefined') {
            this.queryHandleString = o['queryHandleString'];
        }
    }

    /**
     * The prepare handle id.
     *
     * @return string
     */
    getPrepareHandleId() {
        return this.prepareHandleId;
    }

    /**
     * The prepare handle id.
     *
     * @param string prepareHandleId
     */
    setPrepareHandleId(prepareHandleId) {
        this.prepareHandleId = prepareHandleId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getQueryHandleString() {
        return this.queryHandleString;
    }

    /**
     * (no documentation provided)
     *
     * @param string queryHandleString
     */
    setQueryHandleString(queryHandleString) {
        this.queryHandleString = queryHandleString;
    }

    /**
     * Returns a JSON object for this QueryPrepareHandle
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.prepareHandleId !== 'undefined') {
            json['prepareHandleId'] = this.prepareHandleId;
        }
        if (typeof this.queryHandleString !== 'undefined') {
            json['queryHandleString'] = this.queryHandleString;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.ResultColumn = class {

    /**
     * Constructs a ResultColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
    }

    /**
     * The name.
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * The name.
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * The type.
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * The type.
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }

    /**
     * Returns a JSON object for this ResultColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XExprSpec = class {

    /**
     * Constructs a XExprSpec from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['expr'] !== 'undefined') {
            this.expr = o['expr'];
        }
        if (typeof o['start_time'] !== 'undefined') {
            this.startTime = o['start_time'];
        }
        if (typeof o['end_time'] !== 'undefined') {
            this.endTime = o['end_time'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getExpr() {
        return this.expr;
    }

    /**
     * (no documentation provided)
     *
     * @param string expr
     */
    setExpr(expr) {
        this.expr = expr;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }

    /**
     * Returns a JSON object for this XExprSpec
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.expr !== 'undefined') {
            json['expr'] = this.expr;
        }
        if (typeof this.startTime !== 'undefined') {
            json['start_time'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['end_time'] = this.endTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.ToYAMLString = class {

    /**
     * Constructs a ToYAMLString from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.fieldsToAppend = [];
        if (o['fieldsToAppend']) {
            o['fieldsToAppend'].forEach(function(x, i){
                self.fieldsToAppend[i] = new exports.Org.Apache.Lens.Api.FieldNameAndValue(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.FieldNameAndValue[]
     */
    getFieldsToAppend() {
        return this.fieldsToAppend;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.FieldNameAndValue[] fieldsToAppend
     */
    setFieldsToAppend(fieldsToAppend) {
        this.fieldsToAppend = fieldsToAppend;
    }

    /**
     * Returns a JSON object for this ToYAMLString
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.fieldsToAppend) {
            json['fieldsToAppend'] = [];
            this.fieldsToAppend.forEach(function(x, i){
                json['fieldsToAppend'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XProperty = class {

    /**
     * Constructs a XProperty from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param string value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XProperty
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinEdges = class {

    /**
     * Constructs a XJoinEdges from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.edge = [];
        if (o['edge']) {
            o['edge'].forEach(function(x, i){
                self.edge[i] = new exports.Org.Apache.Lens.Api.Metastore.XJoinEdge(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinEdge[]
     */
    getEdge() {
        return this.edge;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinEdge[] edge
     */
    setEdge(edge) {
        this.edge = edge;
    }

    /**
     * Returns a JSON object for this XJoinEdges
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.edge) {
            json['edge'] = [];
            this.edge.forEach(function(x, i){
                json['edge'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartition = class {

    /**
     * Constructs a XPartition from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['fact_or_dimension_table_name'] !== 'undefined') {
            this.factOrDimensionTableName = o['fact_or_dimension_table_name'];
        }
        if (typeof o['non_time_partition_spec'] !== 'undefined') {
            this.nonTimePartitionSpec = new exports.Org.Apache.Lens.Api.Metastore.XPartSpec(o['non_time_partition_spec']);
        }
        if (typeof o['time_partition_spec'] !== 'undefined') {
            this.timePartitionSpec = new exports.Org.Apache.Lens.Api.Metastore.XTimePartSpec(o['time_partition_spec']);
        }
        if (typeof o['full_partition_spec'] !== 'undefined') {
            this.fullPartitionSpec = new exports.Org.Apache.Lens.Api.Metastore.XPartSpec(o['full_partition_spec']);
        }
        if (typeof o['partition_parameters'] !== 'undefined') {
            this.partitionParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['partition_parameters']);
        }
        if (typeof o['serde_parameters'] !== 'undefined') {
            this.serdeParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['serde_parameters']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getFactOrDimensionTableName() {
        return this.factOrDimensionTableName;
    }

    /**
     * (no documentation provided)
     *
     * @param string factOrDimensionTableName
     */
    setFactOrDimensionTableName(factOrDimensionTableName) {
        this.factOrDimensionTableName = factOrDimensionTableName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartSpec
     */
    getNonTimePartitionSpec() {
        return this.nonTimePartitionSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartSpec nonTimePartitionSpec
     */
    setNonTimePartitionSpec(nonTimePartitionSpec) {
        this.nonTimePartitionSpec = nonTimePartitionSpec;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XTimePartSpec
     */
    getTimePartitionSpec() {
        return this.timePartitionSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XTimePartSpec timePartitionSpec
     */
    setTimePartitionSpec(timePartitionSpec) {
        this.timePartitionSpec = timePartitionSpec;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartSpec
     */
    getFullPartitionSpec() {
        return this.fullPartitionSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartSpec fullPartitionSpec
     */
    setFullPartitionSpec(fullPartitionSpec) {
        this.fullPartitionSpec = fullPartitionSpec;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getPartitionParameters() {
        return this.partitionParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties partitionParameters
     */
    setPartitionParameters(partitionParameters) {
        this.partitionParameters = partitionParameters;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getSerdeParameters() {
        return this.serdeParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties serdeParameters
     */
    setSerdeParameters(serdeParameters) {
        this.serdeParameters = serdeParameters;
    }

    /**
     * Returns a JSON object for this XPartition
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.factOrDimensionTableName !== 'undefined') {
            json['fact_or_dimension_table_name'] = this.factOrDimensionTableName;
        }
        if (typeof this.nonTimePartitionSpec !== 'undefined') {
            json['non_time_partition_spec'] = this.nonTimePartitionSpec.toJSON();
        }
        if (typeof this.timePartitionSpec !== 'undefined') {
            json['time_partition_spec'] = this.timePartitionSpec.toJSON();
        }
        if (typeof this.fullPartitionSpec !== 'undefined') {
            json['full_partition_spec'] = this.fullPartitionSpec.toJSON();
        }
        if (typeof this.partitionParameters !== 'undefined') {
            json['partition_parameters'] = this.partitionParameters.toJSON();
        }
        if (typeof this.serdeParameters !== 'undefined') {
            json['serde_parameters'] = this.serdeParameters.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartSpec = class {

    /**
     * Constructs a XPartSpec from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.partSpecElement = [];
        if (o['part_spec_element']) {
            o['part_spec_element'].forEach(function(x, i){
                self.partSpecElement[i] = new exports.Org.Apache.Lens.Api.Metastore.XPartSpecElement(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XPartSpecElement[]
     */
    getPartSpecElement() {
        return this.partSpecElement;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XPartSpecElement[] partSpecElement
     */
    setPartSpecElement(partSpecElement) {
        this.partSpecElement = partSpecElement;
    }

    /**
     * Returns a JSON object for this XPartSpec
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.partSpecElement) {
            json['part_spec_element'] = [];
            this.partSpecElement.forEach(function(x, i){
                json['part_spec_element'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XChainColumn = class {

    /**
     * Constructs a XChainColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['chain_name'] !== 'undefined') {
            this.chainName = o['chain_name'];
        }
        if (typeof o['ref_col'] !== 'undefined') {
            this.refCol = o['ref_col'];
        }
        if (typeof o['dest_table'] !== 'undefined') {
            this.destTable = o['dest_table'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getChainName() {
        return this.chainName;
    }

    /**
     * (no documentation provided)
     *
     * @param string chainName
     */
    setChainName(chainName) {
        this.chainName = chainName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getRefCol() {
        return this.refCol;
    }

    /**
     * (no documentation provided)
     *
     * @param string refCol
     */
    setRefCol(refCol) {
        this.refCol = refCol;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDestTable() {
        return this.destTable;
    }

    /**
     * (no documentation provided)
     *
     * @param string destTable
     */
    setDestTable(destTable) {
        this.destTable = destTable;
    }

    /**
     * Returns a JSON object for this XChainColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.chainName !== 'undefined') {
            json['chain_name'] = this.chainName;
        }
        if (typeof this.refCol !== 'undefined') {
            json['ref_col'] = this.refCol;
        }
        if (typeof this.destTable !== 'undefined') {
            json['dest_table'] = this.destTable;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.LensPreparedQuery = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a LensPreparedQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['prepareHandle'] !== 'undefined') {
            this.prepareHandle = new exports.Org.Apache.Lens.Api.Query.QueryPrepareHandle(o['prepareHandle']);
        }
        if (typeof o['userQuery'] !== 'undefined') {
            this.userQuery = o['userQuery'];
        }
        if (typeof o['preparedTime'] !== 'undefined') {
            this.preparedTime = o['preparedTime'];
        }
        if (typeof o['preparedUser'] !== 'undefined') {
            this.preparedUser = o['preparedUser'];
        }
        if (typeof o['selectedDriverName'] !== 'undefined') {
            this.selectedDriverName = o['selectedDriverName'];
        }
        if (typeof o['driverQuery'] !== 'undefined') {
            this.driverQuery = o['driverQuery'];
        }
        if (typeof o['conf'] !== 'undefined') {
            this.conf = new exports.Org.Apache.Lens.Api.LensConf(o['conf']);
        }
    }

    /**
     * The prepare handle.
     *
     * @return Org.Apache.Lens.Api.Query.QueryPrepareHandle
     */
    getPrepareHandle() {
        return this.prepareHandle;
    }

    /**
     * The prepare handle.
     *
     * @param Org.Apache.Lens.Api.Query.QueryPrepareHandle prepareHandle
     */
    setPrepareHandle(prepareHandle) {
        this.prepareHandle = prepareHandle;
    }
    /**
     * The user query.
     *
     * @return string
     */
    getUserQuery() {
        return this.userQuery;
    }

    /**
     * The user query.
     *
     * @param string userQuery
     */
    setUserQuery(userQuery) {
        this.userQuery = userQuery;
    }
    /**
     * The prepared time.
     *
     * @return integer
     */
    getPreparedTime() {
        return this.preparedTime;
    }

    /**
     * The prepared time.
     *
     * @param integer preparedTime
     */
    setPreparedTime(preparedTime) {
        this.preparedTime = preparedTime;
    }
    /**
     * The prepared user.
     *
     * @return string
     */
    getPreparedUser() {
        return this.preparedUser;
    }

    /**
     * The prepared user.
     *
     * @param string preparedUser
     */
    setPreparedUser(preparedUser) {
        this.preparedUser = preparedUser;
    }
    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @return string
     */
    getSelectedDriverName() {
        return this.selectedDriverName;
    }

    /**
     * The selected driver&#39;s fully qualified name.
     *
     * @param string selectedDriverName
     */
    setSelectedDriverName(selectedDriverName) {
        this.selectedDriverName = selectedDriverName;
    }
    /**
     * The driver query.
     *
     * @return string
     */
    getDriverQuery() {
        return this.driverQuery;
    }

    /**
     * The driver query.
     *
     * @param string driverQuery
     */
    setDriverQuery(driverQuery) {
        this.driverQuery = driverQuery;
    }
    /**
     * The conf.
     *
     * @return Org.Apache.Lens.Api.LensConf
     */
    getConf() {
        return this.conf;
    }

    /**
     * The conf.
     *
     * @param Org.Apache.Lens.Api.LensConf conf
     */
    setConf(conf) {
        this.conf = conf;
    }

    /**
     * Returns a JSON object for this LensPreparedQuery
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.prepareHandle !== 'undefined') {
            json['prepareHandle'] = this.prepareHandle.toJSON();
        }
        if (typeof this.userQuery !== 'undefined') {
            json['userQuery'] = this.userQuery;
        }
        if (typeof this.preparedTime !== 'undefined') {
            json['preparedTime'] = this.preparedTime;
        }
        if (typeof this.preparedUser !== 'undefined') {
            json['preparedUser'] = this.preparedUser;
        }
        if (typeof this.selectedDriverName !== 'undefined') {
            json['selectedDriverName'] = this.selectedDriverName;
        }
        if (typeof this.driverQuery !== 'undefined') {
            json['driverQuery'] = this.driverQuery;
        }
        if (typeof this.conf !== 'undefined') {
            json['conf'] = this.conf.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimension = class {

    /**
     * Constructs a XDimension from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['attributes'] !== 'undefined') {
            this.attributes = new exports.Org.Apache.Lens.Api.Metastore.XDimAttributes(o['attributes']);
        }
        if (typeof o['expressions'] !== 'undefined') {
            this.expressions = new exports.Org.Apache.Lens.Api.Metastore.XExpressions(o['expressions']);
        }
        if (typeof o['join_chains'] !== 'undefined') {
            this.joinChains = new exports.Org.Apache.Lens.Api.Metastore.XJoinChains(o['join_chains']);
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttributes
     */
    getAttributes() {
        return this.attributes;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttributes attributes
     */
    setAttributes(attributes) {
        this.attributes = attributes;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XExpressions
     */
    getExpressions() {
        return this.expressions;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XExpressions expressions
     */
    setExpressions(expressions) {
        this.expressions = expressions;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinChains
     */
    getJoinChains() {
        return this.joinChains;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinChains joinChains
     */
    setJoinChains(joinChains) {
        this.joinChains = joinChains;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }

    /**
     * Returns a JSON object for this XDimension
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.attributes !== 'undefined') {
            json['attributes'] = this.attributes.toJSON();
        }
        if (typeof this.expressions !== 'undefined') {
            json['expressions'] = this.expressions.toJSON();
        }
        if (typeof this.joinChains !== 'undefined') {
            json['join_chains'] = this.joinChains.toJSON();
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.FieldNameAndValue = class {

    /**
     * Constructs a FieldNameAndValue from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this FieldNameAndValue
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.APIResult = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a APIResult from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['status'] !== 'undefined') {
            this.status = o['status'];
        }
        if (typeof o['message'] !== 'undefined') {
            this.message = o['message'];
        }
    }

    /**
     * The status.
     *
     * @return string
     */
    getStatus() {
        return this.status;
    }

    /**
     * The status.
     *
     * @param string status
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * The message.
     *
     * @return string
     */
    getMessage() {
        return this.message;
    }

    /**
     * The message.
     *
     * @param string message
     */
    setMessage(message) {
        this.message = message;
    }

    /**
     * Returns a JSON object for this APIResult
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status;
        }
        if (typeof this.message !== 'undefined') {
            json['message'] = this.message;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorageTableElement = class {

    /**
     * Constructs a XStorageTableElement from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['update_periods'] !== 'undefined') {
            this.updatePeriods = new exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriods(o['update_periods']);
        }
        if (typeof o['storage_name'] !== 'undefined') {
            this.storageName = o['storage_name'];
        }
        if (typeof o['table_desc'] !== 'undefined') {
            this.tableDesc = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc(o['table_desc']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XUpdatePeriods
     */
    getUpdatePeriods() {
        return this.updatePeriods;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XUpdatePeriods updatePeriods
     */
    setUpdatePeriods(updatePeriods) {
        this.updatePeriods = updatePeriods;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getStorageName() {
        return this.storageName;
    }

    /**
     * (no documentation provided)
     *
     * @param string storageName
     */
    setStorageName(storageName) {
        this.storageName = storageName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableDesc
     */
    getTableDesc() {
        return this.tableDesc;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableDesc tableDesc
     */
    setTableDesc(tableDesc) {
        this.tableDesc = tableDesc;
    }

    /**
     * Returns a JSON object for this XStorageTableElement
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.updatePeriods !== 'undefined') {
            json['update_periods'] = this.updatePeriods.toJSON();
        }
        if (typeof this.storageName !== 'undefined') {
            json['storage_name'] = this.storageName;
        }
        if (typeof this.tableDesc !== 'undefined') {
            json['table_desc'] = this.tableDesc.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XExecution = class {

    /**
     * Constructs a XExecution from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['session'] !== 'undefined') {
            this.session = new exports.Org.Apache.Lens.Api.Scheduler.XSessionType(o['session']);
        }
        if (typeof o['query'] !== 'undefined') {
            this.query = new exports.Org.Apache.Lens.Api.Scheduler.XJobQuery(o['query']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.XSessionType
     */
    getSession() {
        return this.session;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.XSessionType session
     */
    setSession(session) {
        this.session = session;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.XJobQuery
     */
    getQuery() {
        return this.query;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.XJobQuery query
     */
    setQuery(query) {
        this.query = query;
    }

    /**
     * Returns a JSON object for this XExecution
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.session !== 'undefined') {
            json['session'] = this.session.toJSON();
        }
        if (typeof this.query !== 'undefined') {
            json['query'] = this.query.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinPaths = class {

    /**
     * Constructs a XJoinPaths from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.path = [];
        if (o['path']) {
            o['path'].forEach(function(x, i){
                self.path[i] = new exports.Org.Apache.Lens.Api.Metastore.XJoinPath(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinPath[]
     */
    getPath() {
        return this.path;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinPath[] path
     */
    setPath(path) {
        this.path = path;
    }

    /**
     * Returns a JSON object for this XJoinPaths
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.path) {
            json['path'] = [];
            this.path.forEach(function(x, i){
                json['path'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInfo = class {

    /**
     * Constructs a SchedulerJobInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle(o['id']);
        }
        if (typeof o['job'] !== 'undefined') {
            this.job = new exports.Org.Apache.Lens.Api.Scheduler.XJob(o['job']);
        }
        if (typeof o['userName'] !== 'undefined') {
            this.userName = o['userName'];
        }
        if (typeof o['jobState'] !== 'undefined') {
            this.jobState = o['jobState'];
        }
        if (typeof o['createdOn'] !== 'undefined') {
            this.createdOn = o['createdOn'];
        }
        if (typeof o['modifiedOn'] !== 'undefined') {
            this.modifiedOn = o['modifiedOn'];
        }
    }

    /**
     * ID for the current job.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle
     */
    getId() {
        return this.id;
    }

    /**
     * ID for the current job.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * Definition of the job scheduled.
     *
     * @return Org.Apache.Lens.Api.Scheduler.XJob
     */
    getJob() {
        return this.job;
    }

    /**
     * Definition of the job scheduled.
     *
     * @param Org.Apache.Lens.Api.Scheduler.XJob job
     */
    setJob(job) {
        this.job = job;
    }
    /**
     * name of the user who scheduled this job.
     *
     * @return string
     */
    getUserName() {
        return this.userName;
    }

    /**
     * name of the user who scheduled this job.
     *
     * @param string userName
     */
    setUserName(userName) {
        this.userName = userName;
    }
    /**
     * current status of this job
     *
     * @return string
     */
    getJobState() {
        return this.jobState;
    }

    /**
     * current status of this job
     *
     * @param string jobState
     */
    setJobState(jobState) {
        this.jobState = jobState;
    }
    /**
     * time when this job was submitted.
     *
     * @return integer
     */
    getCreatedOn() {
        return this.createdOn;
    }

    /**
     * time when this job was submitted.
     *
     * @param integer createdOn
     */
    setCreatedOn(createdOn) {
        this.createdOn = createdOn;
    }
    /**
     * last modified time for this job
     *
     * @return integer
     */
    getModifiedOn() {
        return this.modifiedOn;
    }

    /**
     * last modified time for this job
     *
     * @param integer modifiedOn
     */
    setModifiedOn(modifiedOn) {
        this.modifiedOn = modifiedOn;
    }

    /**
     * Returns a JSON object for this SchedulerJobInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id.toJSON();
        }
        if (typeof this.job !== 'undefined') {
            json['job'] = this.job.toJSON();
        }
        if (typeof this.userName !== 'undefined') {
            json['userName'] = this.userName;
        }
        if (typeof this.jobState !== 'undefined') {
            json['jobState'] = this.jobState;
        }
        if (typeof this.createdOn !== 'undefined') {
            json['createdOn'] = this.createdOn;
        }
        if (typeof this.modifiedOn !== 'undefined') {
            json['modifiedOn'] = this.modifiedOn;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSegmentation = class {

    /**
     * Constructs a XSegmentation from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
        if (typeof o['segements'] !== 'undefined') {
            this.segements = new exports.Org.Apache.Lens.Api.Metastore.XSegments(o['segements']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XSegments
     */
    getSegements() {
        return this.segements;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XSegments segements
     */
    setSegements(segements) {
        this.segements = segements;
    }

    /**
     * Returns a JSON object for this XSegmentation
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        if (typeof this.segements !== 'undefined') {
            json['segements'] = this.segements.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XSessionType = class {

    /**
     * Constructs a XSessionType from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['db'] !== 'undefined') {
            this.db = o['db'];
        }
        this.conf = [];
        if (o['conf']) {
            o['conf'].forEach(function(x, i){
                self.conf[i] = new exports.Org.Apache.Lens.Api.Scheduler.MapType(x);
            });
        }
        this.resourcePath = [];
        if (o['resource_path']) {
            o['resource_path'].forEach(function(x, i){
                self.resourcePath[i] = new exports.Org.Apache.Lens.Api.Scheduler.ResourcePath(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDb() {
        return this.db;
    }

    /**
     * (no documentation provided)
     *
     * @param string db
     */
    setDb(db) {
        this.db = db;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.MapType[]
     */
    getConf() {
        return this.conf;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.MapType[] conf
     */
    setConf(conf) {
        this.conf = conf;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.ResourcePath[]
     */
    getResourcePath() {
        return this.resourcePath;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.ResourcePath[] resourcePath
     */
    setResourcePath(resourcePath) {
        this.resourcePath = resourcePath;
    }

    /**
     * Returns a JSON object for this XSessionType
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.db !== 'undefined') {
            json['db'] = this.db;
        }
        if (this.conf) {
            json['conf'] = [];
            this.conf.forEach(function(x, i){
                json['conf'][i] = x.toJSON();
            });
        }
        if (this.resourcePath) {
            json['resource_path'] = [];
            this.resourcePath.forEach(function(x, i){
                json['resource_path'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceState = {

    /**
     * 
     */
    WAITING: "WAITING", 

    /**
     * 
     */
    LAUNCHING: "LAUNCHING", 

    /**
     * 
     */
    LAUNCHED: "LAUNCHED", 

    /**
     * 
     */
    RUNNING: "RUNNING", 

    /**
     * 
     */
    FAILED: "FAILED", 

    /**
     * 
     */
    SUCCEEDED: "SUCCEEDED", 

    /**
     * 
     */
    TIMED_OUT: "TIMED_OUT", 

    /**
     * 
     */
    KILLED: "KILLED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinEdge = class {

    /**
     * Constructs a XJoinEdge from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['from'] !== 'undefined') {
            this.from = new exports.Org.Apache.Lens.Api.Metastore.XTableReference(o['from']);
        }
        if (typeof o['to'] !== 'undefined') {
            this.to = new exports.Org.Apache.Lens.Api.Metastore.XTableReference(o['to']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XTableReference
     */
    getFrom() {
        return this.from;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XTableReference from
     */
    setFrom(from) {
        this.from = from;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XTableReference
     */
    getTo() {
        return this.to;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XTableReference to
     */
    setTo(to) {
        this.to = to;
    }

    /**
     * Returns a JSON object for this XJoinEdge
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.from !== 'undefined') {
            json['from'] = this.from.toJSON();
        }
        if (typeof this.to !== 'undefined') {
            json['to'] = this.to.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.ToXMLString = class {

    /**
     * Constructs a ToXMLString from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
    }


    /**
     * Returns a JSON object for this ToXMLString
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryStatus = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QueryStatus from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['progress'] !== 'undefined') {
            this.progress = o['progress'];
        }
        if (typeof o['status'] !== 'undefined') {
            this.status = o['status'];
        }
        if (typeof o['statusMessage'] !== 'undefined') {
            this.statusMessage = o['statusMessage'];
        }
        if (typeof o['isResultSetAvailable'] !== 'undefined') {
            this.isResultSetAvailable = o['isResultSetAvailable'];
        }
        if (typeof o['errorCode'] !== 'undefined') {
            this.errorCode = o['errorCode'];
        }
        if (typeof o['lensErrorTOErrorMsg'] !== 'undefined') {
            this.lensErrorTOErrorMsg = o['lensErrorTOErrorMsg'];
        }
        if (typeof o['queuedStatus'] !== 'undefined') {
            this.queuedStatus = new exports.Org.Apache.Lens.Api.Query.QueryStatus(o['queuedStatus']);
        }
        if (typeof o['queueNumber'] !== 'undefined') {
            this.queueNumber = o['queueNumber'];
        }
        if (typeof o['resultSetAvailable'] !== 'undefined') {
            this.resultSetAvailable = o['resultSetAvailable'];
        }
        if (typeof o['progressMessage'] !== 'undefined') {
            this.progressMessage = o['progressMessage'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['lensErrorTO'] !== 'undefined') {
            this.lensErrorTO = new exports.Org.Apache.Lens.Api.Result.LensErrorTO(o['lensErrorTO']);
        }
    }

    /**
     * The progress.
     *
     * @return double
     */
    getProgress() {
        return this.progress;
    }

    /**
     * The progress.
     *
     * @param double progress
     */
    setProgress(progress) {
        this.progress = progress;
    }
    /**
     * The status.
     *
     * @return string
     */
    getStatus() {
        return this.status;
    }

    /**
     * The status.
     *
     * @param string status
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * The status message.
     *
     * @return string
     */
    getStatusMessage() {
        return this.statusMessage;
    }

    /**
     * The status message.
     *
     * @param string statusMessage
     */
    setStatusMessage(statusMessage) {
        this.statusMessage = statusMessage;
    }
    /**
     * The is result set available.
     *
     * @return boolean
     */
    getIsResultSetAvailable() {
        return this.isResultSetAvailable;
    }

    /**
     * The is result set available.
     *
     * @param boolean isResultSetAvailable
     */
    setIsResultSetAvailable(isResultSetAvailable) {
        this.isResultSetAvailable = isResultSetAvailable;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getErrorCode() {
        return this.errorCode;
    }

    /**
     * (no documentation provided)
     *
     * @param integer errorCode
     */
    setErrorCode(errorCode) {
        this.errorCode = errorCode;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getLensErrorTOErrorMsg() {
        return this.lensErrorTOErrorMsg;
    }

    /**
     * (no documentation provided)
     *
     * @param string lensErrorTOErrorMsg
     */
    setLensErrorTOErrorMsg(lensErrorTOErrorMsg) {
        this.lensErrorTOErrorMsg = lensErrorTOErrorMsg;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Query.QueryStatus
     */
    getQueuedStatus() {
        return this.queuedStatus;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Query.QueryStatus queuedStatus
     */
    setQueuedStatus(queuedStatus) {
        this.queuedStatus = queuedStatus;
    }
    /**
     * Queue number of a query when it is in waiting state.
     *
     * @return integer
     */
    getQueueNumber() {
        return this.queueNumber;
    }

    /**
     * Queue number of a query when it is in waiting state.
     *
     * @param integer queueNumber
     */
    setQueueNumber(queueNumber) {
        this.queueNumber = queueNumber;
    }
    /**
     * The is result set available.
     *
     * @return boolean
     */
    getResultSetAvailable() {
        return this.resultSetAvailable;
    }

    /**
     * The is result set available.
     *
     * @param boolean resultSetAvailable
     */
    setResultSetAvailable(resultSetAvailable) {
        this.resultSetAvailable = resultSetAvailable;
    }
    /**
     * The progress message.
     *
     * @return string
     */
    getProgressMessage() {
        return this.progressMessage;
    }

    /**
     * The progress message.
     *
     * @param string progressMessage
     */
    setProgressMessage(progressMessage) {
        this.progressMessage = progressMessage;
    }
    /**
     * The error message.
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * The error message.
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Result.LensErrorTO
     */
    getLensErrorTO() {
        return this.lensErrorTO;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Result.LensErrorTO lensErrorTO
     */
    setLensErrorTO(lensErrorTO) {
        this.lensErrorTO = lensErrorTO;
    }

    /**
     * Returns a JSON object for this QueryStatus
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.progress !== 'undefined') {
            json['progress'] = this.progress;
        }
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status;
        }
        if (typeof this.statusMessage !== 'undefined') {
            json['statusMessage'] = this.statusMessage;
        }
        if (typeof this.isResultSetAvailable !== 'undefined') {
            json['isResultSetAvailable'] = this.isResultSetAvailable;
        }
        if (typeof this.errorCode !== 'undefined') {
            json['errorCode'] = this.errorCode;
        }
        if (typeof this.lensErrorTOErrorMsg !== 'undefined') {
            json['lensErrorTOErrorMsg'] = this.lensErrorTOErrorMsg;
        }
        if (typeof this.queuedStatus !== 'undefined') {
            json['queuedStatus'] = this.queuedStatus.toJSON();
        }
        if (typeof this.queueNumber !== 'undefined') {
            json['queueNumber'] = this.queueNumber;
        }
        if (typeof this.resultSetAvailable !== 'undefined') {
            json['resultSetAvailable'] = this.resultSetAvailable;
        }
        if (typeof this.progressMessage !== 'undefined') {
            json['progressMessage'] = this.progressMessage;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.lensErrorTO !== 'undefined') {
            json['lensErrorTO'] = this.lensErrorTO.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.LensConf = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a LensConf from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['properties'] !== 'undefined') {
            this.properties = o['properties'];
        }
    }

    /**
     * The properties.
     *
     * @return array
     */
    getProperties() {
        return this.properties;
    }

    /**
     * The properties.
     *
     * @param array properties
     */
    setProperties(properties) {
        this.properties = properties;
    }

    /**
     * Returns a JSON object for this LensConf
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Result');
exports.Org.Apache.Lens.Api.Result.LensAPIResult<DATA extends Object> = class {

    /**
     * Constructs a LensAPIResult<DATA extends Object> from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['apiVersion'] !== 'undefined') {
            this.apiVersion = o['apiVersion'];
        }
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['data'] !== 'undefined') {
            this.data = o['data'];
        }
        if (typeof o['error'] !== 'undefined') {
            this.lensErrorTO = new exports.Org.Apache.Lens.Api.Result.LensErrorTO(o['error']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getApiVersion() {
        return this.apiVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param string apiVersion
     */
    setApiVersion(apiVersion) {
        this.apiVersion = apiVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getId() {
        return this.id;
    }

    /**
     * (no documentation provided)
     *
     * @param string id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    getData() {
        return this.data;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed data
     */
    setData(data) {
        this.data = data;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Result.LensErrorTO
     */
    getLensErrorTO() {
        return this.lensErrorTO;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Result.LensErrorTO lensErrorTO
     */
    setLensErrorTO(lensErrorTO) {
        this.lensErrorTO = lensErrorTO;
    }

    /**
     * Returns a JSON object for this LensAPIResult<DATA extends Object>
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.apiVersion !== 'undefined') {
            json['apiVersion'] = this.apiVersion;
        }
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.data !== 'undefined') {
            json['data'] = this.data;
        }
        if (typeof this.lensErrorTO !== 'undefined') {
            json['error'] = this.lensErrorTO.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XColumn = class {

    /**
     * Constructs a XColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['_type'] !== 'undefined') {
            this.type = o['_type'];
        }
        if (typeof o['comment'] !== 'undefined') {
            this.comment = o['comment'];
        }
        if (typeof o['start_time'] !== 'undefined') {
            this.startTime = o['start_time'];
        }
        if (typeof o['end_time'] !== 'undefined') {
            this.endTime = o['end_time'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * (no documentation provided)
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getComment() {
        return this.comment;
    }

    /**
     * (no documentation provided)
     *
     * @param string comment
     */
    setComment(comment) {
        this.comment = comment;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }

    /**
     * Returns a JSON object for this XColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.type !== 'undefined') {
            json['_type'] = this.type;
        }
        if (typeof this.comment !== 'undefined') {
            json['comment'] = this.comment;
        }
        if (typeof this.startTime !== 'undefined') {
            json['start_time'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['end_time'] = this.endTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.FailedAttempt = class {

    /**
     * Constructs a FailedAttempt from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['driverName'] !== 'undefined') {
            this.driverName = o['driverName'];
        }
        if (typeof o['progress'] !== 'undefined') {
            this.progress = o['progress'];
        }
        if (typeof o['progressMessage'] !== 'undefined') {
            this.progressMessage = o['progressMessage'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['driverStartTime'] !== 'undefined') {
            this.driverStartTime = o['driverStartTime'];
        }
        if (typeof o['driverFinishTime'] !== 'undefined') {
            this.driverFinishTime = o['driverFinishTime'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDriverName() {
        return this.driverName;
    }

    /**
     * (no documentation provided)
     *
     * @param string driverName
     */
    setDriverName(driverName) {
        this.driverName = driverName;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    getProgress() {
        return this.progress;
    }

    /**
     * (no documentation provided)
     *
     * @param double progress
     */
    setProgress(progress) {
        this.progress = progress;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getProgressMessage() {
        return this.progressMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string progressMessage
     */
    setProgressMessage(progressMessage) {
        this.progressMessage = progressMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getDriverStartTime() {
        return this.driverStartTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer driverStartTime
     */
    setDriverStartTime(driverStartTime) {
        this.driverStartTime = driverStartTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getDriverFinishTime() {
        return this.driverFinishTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer driverFinishTime
     */
    setDriverFinishTime(driverFinishTime) {
        this.driverFinishTime = driverFinishTime;
    }

    /**
     * Returns a JSON object for this FailedAttempt
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.driverName !== 'undefined') {
            json['driverName'] = this.driverName;
        }
        if (typeof this.progress !== 'undefined') {
            json['progress'] = this.progress;
        }
        if (typeof this.progressMessage !== 'undefined') {
            json['progressMessage'] = this.progressMessage;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.driverStartTime !== 'undefined') {
            json['driverStartTime'] = this.driverStartTime;
        }
        if (typeof this.driverFinishTime !== 'undefined') {
            json['driverFinishTime'] = this.driverFinishTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryResultSetMetadata = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QueryResultSetMetadata from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        this.columns = [];
        if (o['columns']) {
            o['columns'].forEach(function(x, i){
                self.columns[i] = new exports.Org.Apache.Lens.Api.Query.ResultColumn(x);
            });
        }
    }

    /**
     * The columns.
     *
     * @return Org.Apache.Lens.Api.Query.ResultColumn[]
     */
    getColumns() {
        return this.columns;
    }

    /**
     * The columns.
     *
     * @param Org.Apache.Lens.Api.Query.ResultColumn[] columns
     */
    setColumns(columns) {
        this.columns = columns;
    }

    /**
     * Returns a JSON object for this QueryResultSetMetadata
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (this.columns) {
            json['columns'] = [];
            this.columns.forEach(function(x, i){
                json['columns'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ParameterParserResponse = class {

    /**
     * Constructs a ParameterParserResponse from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['valid'] !== 'undefined') {
            this.valid = o['valid'];
        }
        if (typeof o['message'] !== 'undefined') {
            this.message = o['message'];
        }
        this.parameters = [];
        if (o['parameters']) {
            o['parameters'].forEach(function(x, i){
                self.parameters[i] = new exports.Org.Apache.Lens.Api.Query.Save.Parameter(x);
            });
        }
    }

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @return boolean
     */
    getValid() {
        return this.valid;
    }

    /**
     * Flag that denotes if the query and the parameters are valid
     *
     * @param boolean valid
     */
    setValid(valid) {
        this.valid = valid;
    }
    /**
     * The message
     *
     * @return string
     */
    getMessage() {
        return this.message;
    }

    /**
     * The message
     *
     * @param string message
     */
    setMessage(message) {
        this.message = message;
    }
    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @return Org.Apache.Lens.Api.Query.Save.Parameter[]
     */
    getParameters() {
        return this.parameters;
    }

    /**
     * The immutable set of parameters parsed from a parameterised HQL query
     *
     * @param Org.Apache.Lens.Api.Query.Save.Parameter[] parameters
     */
    setParameters(parameters) {
        this.parameters = parameters;
    }

    /**
     * Returns a JSON object for this ParameterParserResponse
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.valid !== 'undefined') {
            json['valid'] = this.valid;
        }
        if (typeof this.message !== 'undefined') {
            json['message'] = this.message;
        }
        if (this.parameters) {
            json['parameters'] = [];
            this.parameters.forEach(function(x, i){
                json['parameters'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriod = {

    /**
     * 
     */
    CONTINUOUS: "CONTINUOUS", 

    /**
     * 
     */
    SECONDLY: "SECONDLY", 

    /**
     * 
     */
    MINUTELY: "MINUTELY", 

    /**
     * 
     */
    HOURLY: "HOURLY", 

    /**
     * 
     */
    DAILY: "DAILY", 

    /**
     * 
     */
    WEEKLY: "WEEKLY", 

    /**
     * 
     */
    MONTHLY: "MONTHLY", 

    /**
     * 
     */
    QUARTERLY: "QUARTERLY", 

    /**
     * 
     */
    YEARLY: "YEARLY"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XFrequencyEnum = {

    /**
     * 
     */
    DAILY: "DAILY", 

    /**
     * 
     */
    WEEKLY: "WEEKLY", 

    /**
     * 
     */
    MONTHLY: "MONTHLY", 

    /**
     * 
     */
    QUARTERLY: "QUARTERLY", 

    /**
     * 
     */
    YEARLY: "YEARLY"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobStats = class {

    /**
     * Constructs a SchedulerJobStats from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
    }


    /**
     * Returns a JSON object for this SchedulerJobStats
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSkewedValueLocation = class {

    /**
     * Constructs a XSkewedValueLocation from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['location'] !== 'undefined') {
            this.location = o['location'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = new exports.Org.Apache.Lens.Api.Metastore.XSkewColList(o['value']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getLocation() {
        return this.location;
    }

    /**
     * (no documentation provided)
     *
     * @param string location
     */
    setLocation(location) {
        this.location = location;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewColList
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewColList value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XSkewedValueLocation
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.location !== 'undefined') {
            json['location'] = this.location;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ParameterCollectionType = {

    /**
     * Single valued parameter.
     */
    SINGLE: "SINGLE", 

    /**
     * Multivalued parameter.
     */
    MULTIPLE: "MULTIPLE"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XFact = class {

    /**
     * Constructs a XFact from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
        if (typeof o['cube_name'] !== 'undefined') {
            this.cubeName = o['cube_name'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * (no documentation provided)
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getCubeName() {
        return this.cubeName;
    }

    /**
     * (no documentation provided)
     *
     * @param string cubeName
     */
    setCubeName(cubeName) {
        this.cubeName = cubeName;
    }

    /**
     * Returns a JSON object for this XFact
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        if (typeof this.cubeName !== 'undefined') {
            json['cube_name'] = this.cubeName;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.LensQuery = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a LensQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['queryHandle'] !== 'undefined') {
            this.queryHandle = new exports.Org.Apache.Lens.Api.Query.QueryHandle(o['queryHandle']);
        }
        if (typeof o['userQuery'] !== 'undefined') {
            this.userQuery = o['userQuery'];
        }
        if (typeof o['submittedUser'] !== 'undefined') {
            this.submittedUser = o['submittedUser'];
        }
        if (typeof o['priority'] !== 'undefined') {
            this.priority = o['priority'];
        }
        if (typeof o['isPersistent'] !== 'undefined') {
            this.isPersistent = o['isPersistent'];
        }
        if (typeof o['selectedDriverName'] !== 'undefined') {
            this.selectedDriverName = o['selectedDriverName'];
        }
        if (typeof o['driverQuery'] !== 'undefined') {
            this.driverQuery = o['driverQuery'];
        }
        if (typeof o['status'] !== 'undefined') {
            this.status = new exports.Org.Apache.Lens.Api.Query.QueryStatus(o['status']);
        }
        if (typeof o['resultSetPath'] !== 'undefined') {
            this.resultSetPath = o['resultSetPath'];
        }
        if (typeof o['driverOpHandle'] !== 'undefined') {
            this.driverOpHandle = o['driverOpHandle'];
        }
        if (typeof o['queryConf'] !== 'undefined') {
            this.queryConf = new exports.Org.Apache.Lens.Api.LensConf(o['queryConf']);
        }
        if (typeof o['submissionTime'] !== 'undefined') {
            this.submissionTime = o['submissionTime'];
        }
        if (typeof o['launchTime'] !== 'undefined') {
            this.launchTime = o['launchTime'];
        }
        if (typeof o['driverStartTime'] !== 'undefined') {
            this.driverStartTime = o['driverStartTime'];
        }
        if (typeof o['driverFinishTime'] !== 'undefined') {
            this.driverFinishTime = o['driverFinishTime'];
        }
        if (typeof o['finishTime'] !== 'undefined') {
            this.finishTime = o['finishTime'];
        }
        if (typeof o['closedTime'] !== 'undefined') {
            this.closedTime = o['closedTime'];
        }
        if (typeof o['queryName'] !== 'undefined') {
            this.queryName = o['queryName'];
        }
        this.failedAttempts = [];
        if (o['failedAttempts']) {
            o['failedAttempts'].forEach(function(x, i){
                self.failedAttempts[i] = new exports.Org.Apache.Lens.Api.Query.FailedAttempt(x);
            });
        }
        if (typeof o['errorCode'] !== 'undefined') {
            this.errorCode = o['errorCode'];
        }
        if (typeof o['errorMessage'] !== 'undefined') {
            this.errorMessage = o['errorMessage'];
        }
        if (typeof o['queryHandleString'] !== 'undefined') {
            this.queryHandleString = o['queryHandleString'];
        }
        if (typeof o['persistent'] !== 'undefined') {
            this.persistent = o['persistent'];
        }
    }

    /**
     * The query handle that represents this query uniquely
     *
     * @return Org.Apache.Lens.Api.Query.QueryHandle
     */
    getQueryHandle() {
        return this.queryHandle;
    }

    /**
     * The query handle that represents this query uniquely
     *
     * @param Org.Apache.Lens.Api.Query.QueryHandle queryHandle
     */
    setQueryHandle(queryHandle) {
        this.queryHandle = queryHandle;
    }
    /**
     * The the query submitted by the user
     *
     * @return string
     */
    getUserQuery() {
        return this.userQuery;
    }

    /**
     * The the query submitted by the user
     *
     * @param string userQuery
     */
    setUserQuery(userQuery) {
        this.userQuery = userQuery;
    }
    /**
     * The user who submitted the query.
     *
     * @return string
     */
    getSubmittedUser() {
        return this.submittedUser;
    }

    /**
     * The user who submitted the query.
     *
     * @param string submittedUser
     */
    setSubmittedUser(submittedUser) {
        this.submittedUser = submittedUser;
    }
    /**
     * The priority of the query.
     *
     * @return string
     */
    getPriority() {
        return this.priority;
    }

    /**
     * The priority of the query.
     *
     * @param string priority
     */
    setPriority(priority) {
        this.priority = priority;
    }
    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @return boolean
     */
    getIsPersistent() {
        return this.isPersistent;
    }

    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @param boolean isPersistent
     */
    setIsPersistent(isPersistent) {
        this.isPersistent = isPersistent;
    }
    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @return string
     */
    getSelectedDriverName() {
        return this.selectedDriverName;
    }

    /**
     * Name of the driver which executed the query (Example: hive/testDriver, jdbc/prodDriver etc)
     *
     * @param string selectedDriverName
     */
    setSelectedDriverName(selectedDriverName) {
        this.selectedDriverName = selectedDriverName;
    }
    /**
     * The driver query.
       * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @return string
     */
    getDriverQuery() {
        return this.driverQuery;
    }

    /**
     * The driver query.
       * It is the final query (derived form user query) that was submitted by the driver for execution.
     *
     * @param string driverQuery
     */
    setDriverQuery(driverQuery) {
        this.driverQuery = driverQuery;
    }
    /**
     * The status of this query.
       * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
       * the current state of the query. Also other utility methods are available to check the status of the query like
       * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
       * QueryStatus#failed() and QueryStatus#running()
     *
     * @return Org.Apache.Lens.Api.Query.QueryStatus
     */
    getStatus() {
        return this.status;
    }

    /**
     * The status of this query.
       * Note: QueryStatus#getStatus() method can be used to get the QueryStatus.Status enum that defines
       * the current state of the query. Also other utility methods are available to check the status of the query like
       * QueryStatus#queued(), QueryStatus#successful(), QueryStatus#finished(),
       * QueryStatus#failed() and QueryStatus#running()
     *
     * @param Org.Apache.Lens.Api.Query.QueryStatus status
     */
    setStatus(status) {
        this.status = status;
    }
    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @return string
     */
    getResultSetPath() {
        return this.resultSetPath;
    }

    /**
     * The result set path for this query if the query output was persisted by the server.
     *
     * @param string resultSetPath
     */
    setResultSetPath(resultSetPath) {
        this.resultSetPath = resultSetPath;
    }
    /**
     * The operation handle associated with the driver, if any.
     *
     * @return string
     */
    getDriverOpHandle() {
        return this.driverOpHandle;
    }

    /**
     * The operation handle associated with the driver, if any.
     *
     * @param string driverOpHandle
     */
    setDriverOpHandle(driverOpHandle) {
        this.driverOpHandle = driverOpHandle;
    }
    /**
     * The query conf that was used for executing this query.
     *
     * @return Org.Apache.Lens.Api.LensConf
     */
    getQueryConf() {
        return this.queryConf;
    }

    /**
     * The query conf that was used for executing this query.
     *
     * @param Org.Apache.Lens.Api.LensConf queryConf
     */
    setQueryConf(queryConf) {
        this.queryConf = queryConf;
    }
    /**
     * The submission time.
     *
     * @return integer
     */
    getSubmissionTime() {
        return this.submissionTime;
    }

    /**
     * The submission time.
     *
     * @param integer submissionTime
     */
    setSubmissionTime(submissionTime) {
        this.submissionTime = submissionTime;
    }
    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @return integer
     */
    getLaunchTime() {
        return this.launchTime;
    }

    /**
     * The query launch time. This will be submission time + time spent by query waiting in the queue
     *
     * @param integer launchTime
     */
    setLaunchTime(launchTime) {
        this.launchTime = launchTime;
    }
    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @return integer
     */
    getDriverStartTime() {
        return this.driverStartTime;
    }

    /**
     * The query execution start time on driver. This will &gt;= launch time.
     *
     * @param integer driverStartTime
     */
    setDriverStartTime(driverStartTime) {
        this.driverStartTime = driverStartTime;
    }
    /**
     * The the query execution end time on driver.
     *
     * @return integer
     */
    getDriverFinishTime() {
        return this.driverFinishTime;
    }

    /**
     * The the query execution end time on driver.
     *
     * @param integer driverFinishTime
     */
    setDriverFinishTime(driverFinishTime) {
        this.driverFinishTime = driverFinishTime;
    }
    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
       * formatting the result)
     *
     * @return integer
     */
    getFinishTime() {
        return this.finishTime;
    }

    /**
     * The query finish time on server. This will be driver finish time + any extra time spent by server (like
       * formatting the result)
     *
     * @param integer finishTime
     */
    setFinishTime(finishTime) {
        this.finishTime = finishTime;
    }
    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
       * Note: not supported as of now.
     *
     * @return integer
     */
    getClosedTime() {
        return this.closedTime;
    }

    /**
     * The the query close time when the query is purged by the server and no more operations are pending for it.
       * Note: not supported as of now.
     *
     * @param integer closedTime
     */
    setClosedTime(closedTime) {
        this.closedTime = closedTime;
    }
    /**
     * The query name, if any.
     *
     * @return string
     */
    getQueryName() {
        return this.queryName;
    }

    /**
     * The query name, if any.
     *
     * @param string queryName
     */
    setQueryName(queryName) {
        this.queryName = queryName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Query.FailedAttempt[]
     */
    getFailedAttempts() {
        return this.failedAttempts;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Query.FailedAttempt[] failedAttempts
     */
    setFailedAttempts(failedAttempts) {
        this.failedAttempts = failedAttempts;
    }
    /**
     * error code in case of query failures
     *
     * @return integer
     */
    getErrorCode() {
        return this.errorCode;
    }

    /**
     * error code in case of query failures
     *
     * @param integer errorCode
     */
    setErrorCode(errorCode) {
        this.errorCode = errorCode;
    }
    /**
     * error message in case of query failures
     *
     * @return string
     */
    getErrorMessage() {
        return this.errorMessage;
    }

    /**
     * error message in case of query failures
     *
     * @param string errorMessage
     */
    setErrorMessage(errorMessage) {
        this.errorMessage = errorMessage;
    }
    /**
     * the query handle string
     *
     * @return string
     */
    getQueryHandleString() {
        return this.queryHandleString;
    }

    /**
     * the query handle string
     *
     * @param string queryHandleString
     */
    setQueryHandleString(queryHandleString) {
        this.queryHandleString = queryHandleString;
    }
    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @return boolean
     */
    getPersistent() {
        return this.persistent;
    }

    /**
     * Is true if query&#39;s result would be persisted by server.
     *
     * @param boolean persistent
     */
    setPersistent(persistent) {
        this.persistent = persistent;
    }

    /**
     * Returns a JSON object for this LensQuery
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.queryHandle !== 'undefined') {
            json['queryHandle'] = this.queryHandle.toJSON();
        }
        if (typeof this.userQuery !== 'undefined') {
            json['userQuery'] = this.userQuery;
        }
        if (typeof this.submittedUser !== 'undefined') {
            json['submittedUser'] = this.submittedUser;
        }
        if (typeof this.priority !== 'undefined') {
            json['priority'] = this.priority;
        }
        if (typeof this.isPersistent !== 'undefined') {
            json['isPersistent'] = this.isPersistent;
        }
        if (typeof this.selectedDriverName !== 'undefined') {
            json['selectedDriverName'] = this.selectedDriverName;
        }
        if (typeof this.driverQuery !== 'undefined') {
            json['driverQuery'] = this.driverQuery;
        }
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status.toJSON();
        }
        if (typeof this.resultSetPath !== 'undefined') {
            json['resultSetPath'] = this.resultSetPath;
        }
        if (typeof this.driverOpHandle !== 'undefined') {
            json['driverOpHandle'] = this.driverOpHandle;
        }
        if (typeof this.queryConf !== 'undefined') {
            json['queryConf'] = this.queryConf.toJSON();
        }
        if (typeof this.submissionTime !== 'undefined') {
            json['submissionTime'] = this.submissionTime;
        }
        if (typeof this.launchTime !== 'undefined') {
            json['launchTime'] = this.launchTime;
        }
        if (typeof this.driverStartTime !== 'undefined') {
            json['driverStartTime'] = this.driverStartTime;
        }
        if (typeof this.driverFinishTime !== 'undefined') {
            json['driverFinishTime'] = this.driverFinishTime;
        }
        if (typeof this.finishTime !== 'undefined') {
            json['finishTime'] = this.finishTime;
        }
        if (typeof this.closedTime !== 'undefined') {
            json['closedTime'] = this.closedTime;
        }
        if (typeof this.queryName !== 'undefined') {
            json['queryName'] = this.queryName;
        }
        if (this.failedAttempts) {
            json['failedAttempts'] = [];
            this.failedAttempts.forEach(function(x, i){
                json['failedAttempts'][i] = x.toJSON();
            });
        }
        if (typeof this.errorCode !== 'undefined') {
            json['errorCode'] = this.errorCode;
        }
        if (typeof this.errorMessage !== 'undefined') {
            json['errorMessage'] = this.errorMessage;
        }
        if (typeof this.queryHandleString !== 'undefined') {
            json['queryHandleString'] = this.queryHandleString;
        }
        if (typeof this.persistent !== 'undefined') {
            json['persistent'] = this.persistent;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QuerySubmitResult = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QuerySubmitResult from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
    }


    /**
     * Returns a JSON object for this QuerySubmitResult
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XNativeTable = class {

    /**
     * Constructs a XNativeTable from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['columns'] !== 'undefined') {
            this.columns = new exports.Org.Apache.Lens.Api.Metastore.XColumns(o['columns']);
        }
        if (typeof o['storage_descriptor'] !== 'undefined') {
            this.storageDescriptor = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc(o['storage_descriptor']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XColumns
     */
    getColumns() {
        return this.columns;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XColumns columns
     */
    setColumns(columns) {
        this.columns = columns;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableDesc
     */
    getStorageDescriptor() {
        return this.storageDescriptor;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableDesc storageDescriptor
     */
    setStorageDescriptor(storageDescriptor) {
        this.storageDescriptor = storageDescriptor;
    }

    /**
     * Returns a JSON object for this XNativeTable
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.columns !== 'undefined') {
            json['columns'] = this.columns.toJSON();
        }
        if (typeof this.storageDescriptor !== 'undefined') {
            json['storage_descriptor'] = this.storageDescriptor.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.Status = {

    /**
     * The succeeded.
     */
    SUCCEEDED: "SUCCEEDED", 

    /**
     * The partial.
     */
    PARTIAL: "PARTIAL", 

    /**
     * The failed.
     */
    FAILED: "FAILED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSkewColList = class {

    /**
     * Constructs a XSkewColList from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.elements = [];
        if (o['elements']) {
            o['elements'].forEach(function(x, i){
                self.elements[i] = x;
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getElements() {
        return this.elements;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] elements
     */
    setElements(elements) {
        this.elements = elements;
    }

    /**
     * Returns a JSON object for this XSkewColList
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.elements) {
            json['elements'] = [];
            this.elements.forEach(function(x, i){
                json['elements'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorageTables = class {

    /**
     * Constructs a XStorageTables from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.storageTable = [];
        if (o['storage_table']) {
            o['storage_table'].forEach(function(x, i){
                self.storageTable[i] = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableElement(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableElement[]
     */
    getStorageTable() {
        return this.storageTable;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableElement[] storageTable
     */
    setStorageTable(storageTable) {
        this.storageTable = storageTable;
    }

    /**
     * Returns a JSON object for this XStorageTables
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.storageTable) {
            json['storage_table'] = [];
            this.storageTable.forEach(function(x, i){
                json['storage_table'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XMeasureType = {

    /**
     * 
     */
    TINYINT: "TINYINT", 

    /**
     * 
     */
    SMALLINT: "SMALLINT", 

    /**
     * 
     */
    INT: "INT", 

    /**
     * 
     */
    BIGINT: "BIGINT", 

    /**
     * 
     */
    FLOAT: "FLOAT", 

    /**
     * 
     */
    DOUBLE: "DOUBLE", 

    /**
     * 
     */
    DECIMAL: "DECIMAL"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XTimePartSpec = class {

    /**
     * Constructs a XTimePartSpec from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.partSpecElement = [];
        if (o['part_spec_element']) {
            o['part_spec_element'].forEach(function(x, i){
                self.partSpecElement[i] = new exports.Org.Apache.Lens.Api.Metastore.XTimePartSpecElement(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XTimePartSpecElement[]
     */
    getPartSpecElement() {
        return this.partSpecElement;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XTimePartSpecElement[] partSpecElement
     */
    setPartSpecElement(partSpecElement) {
        this.partSpecElement = partSpecElement;
    }

    /**
     * Returns a JSON object for this XTimePartSpec
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.partSpecElement) {
            json['part_spec_element'] = [];
            this.partSpecElement.forEach(function(x, i){
                json['part_spec_element'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XStorage = class {

    /**
     * Constructs a XStorage from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }

    /**
     * Returns a JSON object for this XStorage
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XExprColumn = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XExprColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['_type'] !== 'undefined') {
            this.type = o['_type'];
        }
        this.exprSpec = [];
        if (o['expr_spec']) {
            o['expr_spec'].forEach(function(x, i){
                self.exprSpec[i] = new exports.Org.Apache.Lens.Api.Metastore.XExprSpec(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * (no documentation provided)
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XExprSpec[]
     */
    getExprSpec() {
        return this.exprSpec;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XExprSpec[] exprSpec
     */
    setExprSpec(exprSpec) {
        this.exprSpec = exprSpec;
    }

    /**
     * Returns a JSON object for this XExprColumn
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.type !== 'undefined') {
            json['_type'] = this.type;
        }
        if (this.exprSpec) {
            json['expr_spec'] = [];
            this.exprSpec.forEach(function(x, i){
                json['expr_spec'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle = class {

    /**
     * Constructs a SchedulerJobHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handleId'] !== 'undefined') {
            this.handleId = o['handleId'];
        }
        if (typeof o['handleIdString'] !== 'undefined') {
            this.handleIdString = o['handleIdString'];
        }
    }

    /**
     * The handle id.
     *
     * @return string
     */
    getHandleId() {
        return this.handleId;
    }

    /**
     * The handle id.
     *
     * @param string handleId
     */
    setHandleId(handleId) {
        this.handleId = handleId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getHandleIdString() {
        return this.handleIdString;
    }

    /**
     * (no documentation provided)
     *
     * @param string handleIdString
     */
    setHandleIdString(handleIdString) {
        this.handleIdString = handleIdString;
    }

    /**
     * Returns a JSON object for this SchedulerJobHandle
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handleId !== 'undefined') {
            json['handleId'] = this.handleId;
        }
        if (typeof this.handleIdString !== 'undefined') {
            json['handleIdString'] = this.handleIdString;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobState = {

    /**
     * 
     */
    NEW: "NEW", 

    /**
     * 
     */
    SCHEDULED: "SCHEDULED", 

    /**
     * 
     */
    SUSPENDED: "SUSPENDED", 

    /**
     * 
     */
    EXPIRED: "EXPIRED", 

    /**
     * 
     */
    DELETED: "DELETED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.Status = {

    /**
     * The new.
     */
    NEW: "NEW", 

    /**
     * The queued.
    * At this point the query is queued by the server and it waiting to be launched. The launch may be controlled by
    * multiple factors like query throttling, quota, etc
     */
    QUEUED: "QUEUED", 

    /**
     * The launched.
    * At this point the query is launched for execution.
     */
    LAUNCHED: "LAUNCHED", 

    /**
     * The running.
    * At this point the query starts running on chosen driver
     */
    RUNNING: "RUNNING", 

    /**
     * The executed.
    * At this point execution is finished by driver, but server may still have some more operations pending
    * like result persistence, if enabled.
     */
    EXECUTED: "EXECUTED", 

    /**
     * This state is when depending on retry policy, either the query moves to QUEUED (in case retries are to be done),
    * or to FAILED.
     */
    FAILING: "FAILING", 

    /**
     * The successful.
    * At this point all operations related to the query are finished successfully by driver and server.
     */
    SUCCESSFUL: "SUCCESSFUL", 

    /**
     * The failed.
     */
    FAILED: "FAILED", 

    /**
     * The canceled.
     */
    CANCELED: "CANCELED", 

    /**
     * The closed.
    * At this point the query is purged by the server. Persistent result will still be available to the user
     */
    CLOSED: "CLOSED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.ResultColumnType = {

    /**
     * The boolean.
     */
    BOOLEAN: "BOOLEAN", 

    /**
     * The tinyint.
     */
    TINYINT: "TINYINT", 

    /**
     * The smallint.
     */
    SMALLINT: "SMALLINT", 

    /**
     * The int.
     */
    INT: "INT", 

    /**
     * The bigint.
     */
    BIGINT: "BIGINT", 

    /**
     * The float.
     */
    FLOAT: "FLOAT", 

    /**
     * The double.
     */
    DOUBLE: "DOUBLE", 

    /**
     * The string.
     */
    STRING: "STRING", 

    /**
     * The timestamp.
     */
    TIMESTAMP: "TIMESTAMP", 

    /**
     * The binary.
     */
    BINARY: "BINARY", 

    /**
     * The array.
     */
    ARRAY: "ARRAY", 

    /**
     * The map.
     */
    MAP: "MAP", 

    /**
     * The struct.
     */
    STRUCT: "STRUCT", 

    /**
     * The uniontype.
     */
    UNIONTYPE: "UNIONTYPE", 

    /**
     * The user defined.
     */
    USER_DEFINED: "USER_DEFINED", 

    /**
     * The decimal.
     */
    DECIMAL: "DECIMAL", 

    /**
     * The null.
     */
    NULL: "NULL", 

    /**
     * The date.
     */
    DATE: "DATE", 

    /**
     * The varchar.
     */
    VARCHAR: "VARCHAR", 

    /**
     * The char.
     */
    CHAR: "CHAR"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriods = class {

    /**
     * Constructs a XUpdatePeriods from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.updatePeriodTableDescriptor = [];
        if (o['update_period_table_descriptor']) {
            o['update_period_table_descriptor'].forEach(function(x, i){
                self.updatePeriodTableDescriptor[i] = new exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor(x);
            });
        }
        this.updatePeriod = [];
        if (o['update_period']) {
            o['update_period'].forEach(function(x, i){
                self.updatePeriod[i] = x;
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor[]
     */
    getUpdatePeriodTableDescriptor() {
        return this.updatePeriodTableDescriptor;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor[] updatePeriodTableDescriptor
     */
    setUpdatePeriodTableDescriptor(updatePeriodTableDescriptor) {
        this.updatePeriodTableDescriptor = updatePeriodTableDescriptor;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getUpdatePeriod() {
        return this.updatePeriod;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] updatePeriod
     */
    setUpdatePeriod(updatePeriod) {
        this.updatePeriod = updatePeriod;
    }

    /**
     * Returns a JSON object for this XUpdatePeriods
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.updatePeriodTableDescriptor) {
            json['update_period_table_descriptor'] = [];
            this.updatePeriodTableDescriptor.forEach(function(x, i){
                json['update_period_table_descriptor'][i] = x.toJSON();
            });
        }
        if (this.updatePeriod) {
            json['update_period'] = [];
            this.updatePeriod.forEach(function(x, i){
                json['update_period'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSegments = class {

    /**
     * Constructs a XSegments from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.segment = [];
        if (o['segment']) {
            o['segment'].forEach(function(x, i){
                self.segment[i] = new exports.Org.Apache.Lens.Api.Metastore.XSegment(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XSegment[]
     */
    getSegment() {
        return this.segment;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XSegment[] segment
     */
    setSegment(segment) {
        this.segment = segment;
    }

    /**
     * Returns a JSON object for this XSegments
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.segment) {
            json['segment'] = [];
            this.segment.forEach(function(x, i){
                json['segment'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSkewedInfo = class {

    /**
     * Constructs a XSkewedInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.colNames = [];
        if (o['col_names']) {
            o['col_names'].forEach(function(x, i){
                self.colNames[i] = x;
            });
        }
        this.colValues = [];
        if (o['col_values']) {
            o['col_values'].forEach(function(x, i){
                self.colValues[i] = new exports.Org.Apache.Lens.Api.Metastore.XSkewColList(x);
            });
        }
        this.valueLocationMap = [];
        if (o['value_location_map']) {
            o['value_location_map'].forEach(function(x, i){
                self.valueLocationMap[i] = new exports.Org.Apache.Lens.Api.Metastore.XSkewedValueLocation(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getColNames() {
        return this.colNames;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] colNames
     */
    setColNames(colNames) {
        this.colNames = colNames;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewColList[]
     */
    getColValues() {
        return this.colValues;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewColList[] colValues
     */
    setColValues(colValues) {
        this.colValues = colValues;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XSkewedValueLocation[]
     */
    getValueLocationMap() {
        return this.valueLocationMap;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XSkewedValueLocation[] valueLocationMap
     */
    setValueLocationMap(valueLocationMap) {
        this.valueLocationMap = valueLocationMap;
    }

    /**
     * Returns a JSON object for this XSkewedInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.colNames) {
            json['col_names'] = [];
            this.colNames.forEach(function(x, i){
                json['col_names'][i] = x;
            });
        }
        if (this.colValues) {
            json['col_values'] = [];
            this.colValues.forEach(function(x, i){
                json['col_values'][i] = x.toJSON();
            });
        }
        if (this.valueLocationMap) {
            json['value_location_map'] = [];
            this.valueLocationMap.forEach(function(x, i){
                json['value_location_map'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XTimePartSpecElement = class {

    /**
     * Constructs a XTimePartSpecElement from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * (no documentation provided)
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param integer value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XTimePartSpecElement
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.LensSessionHandle = class extends exports.Org.Apache.Lens.Api.ToXMLString {

    /**
     * Constructs a LensSessionHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['publicId'] !== 'undefined') {
            this.publicId = o['publicId'];
        }
        if (typeof o['secretId'] !== 'undefined') {
            this.secretId = o['secretId'];
        }
    }

    /**
     * The public id.
     *
     * @return string
     */
    getPublicId() {
        return this.publicId;
    }

    /**
     * The public id.
     *
     * @param string publicId
     */
    setPublicId(publicId) {
        this.publicId = publicId;
    }
    /**
     * The secret id.
     *
     * @return string
     */
    getSecretId() {
        return this.secretId;
    }

    /**
     * The secret id.
     *
     * @param string secretId
     */
    setSecretId(secretId) {
        this.secretId = secretId;
    }

    /**
     * Returns a JSON object for this LensSessionHandle
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.publicId !== 'undefined') {
            json['publicId'] = this.publicId;
        }
        if (typeof this.secretId !== 'undefined') {
            json['secretId'] = this.secretId;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.MapType = class {

    /**
     * Constructs a MapType from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * (no documentation provided)
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param string value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this MapType
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XProperties = class {

    /**
     * Constructs a XProperties from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.property = [];
        if (o['property']) {
            o['property'].forEach(function(x, i){
                self.property[i] = new exports.Org.Apache.Lens.Api.Metastore.XProperty(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperty[]
     */
    getProperty() {
        return this.property;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperty[] property
     */
    setProperty(property) {
        this.property = property;
    }

    /**
     * Returns a JSON object for this XProperties
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.property) {
            json['property'] = [];
            this.property.forEach(function(x, i){
                json['property'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Result');
exports.Org.Apache.Lens.Api.Result.LensErrorTO<PAYLOAD extends Object> = class {

    /**
     * Constructs a LensErrorTO<PAYLOAD extends Object> from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['payload'] !== 'undefined') {
            this.payload = o['payload'];
        }
        if (typeof o['code'] !== 'undefined') {
            this.code = o['code'];
        }
        this.childErrors = [];
        if (o['childErrors']) {
            o['childErrors'].forEach(function(x, i){
                self.childErrors[i] = new exports.Org.Apache.Lens.Api.Result.LensErrorTO(x);
            });
        }
        if (typeof o['message'] !== 'undefined') {
            this.message = o['message'];
        }
        if (typeof o['stackTrace'] !== 'undefined') {
            this.stackTrace = o['stackTrace'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return mixed
     */
    getPayload() {
        return this.payload;
    }

    /**
     * (no documentation provided)
     *
     * @param mixed payload
     */
    setPayload(payload) {
        this.payload = payload;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getCode() {
        return this.code;
    }

    /**
     * (no documentation provided)
     *
     * @param integer code
     */
    setCode(code) {
        this.code = code;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Result.LensErrorTO[]
     */
    getChildErrors() {
        return this.childErrors;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Result.LensErrorTO[] childErrors
     */
    setChildErrors(childErrors) {
        this.childErrors = childErrors;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getMessage() {
        return this.message;
    }

    /**
     * (no documentation provided)
     *
     * @param string message
     */
    setMessage(message) {
        this.message = message;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getStackTrace() {
        return this.stackTrace;
    }

    /**
     * (no documentation provided)
     *
     * @param string stackTrace
     */
    setStackTrace(stackTrace) {
        this.stackTrace = stackTrace;
    }

    /**
     * Returns a JSON object for this LensErrorTO<PAYLOAD extends Object>
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.payload !== 'undefined') {
            json['payload'] = this.payload;
        }
        if (typeof this.code !== 'undefined') {
            json['code'] = this.code;
        }
        if (this.childErrors) {
            json['childErrors'] = [];
            this.childErrors.forEach(function(x, i){
                json['childErrors'][i] = x.toJSON();
            });
        }
        if (typeof this.message !== 'undefined') {
            json['message'] = this.message;
        }
        if (typeof this.stackTrace !== 'undefined') {
            json['stackTrace'] = this.stackTrace;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.Priority = {

    /**
     * The very high.
     */
    VERY_HIGH: "VERY_HIGH", 

    /**
     * The high.
     */
    HIGH: "HIGH", 

    /**
     * The normal.
     */
    NORMAL: "NORMAL", 

    /**
     * The low.
     */
    LOW: "LOW", 

    /**
     * The very low.
     */
    VERY_LOW: "VERY_LOW"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XFlattenedColumn = class {

    /**
     * Constructs a XFlattenedColumn from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['table_name'] !== 'undefined') {
            this.tableName = o['table_name'];
        }
        if (typeof o['measure'] !== 'undefined') {
            this.measure = new exports.Org.Apache.Lens.Api.Metastore.XMeasure(o['measure']);
        }
        if (typeof o['expression'] !== 'undefined') {
            this.expression = new exports.Org.Apache.Lens.Api.Metastore.XExprColumn(o['expression']);
        }
        if (typeof o['dim_attribute'] !== 'undefined') {
            this.dimAttribute = new exports.Org.Apache.Lens.Api.Metastore.XDimAttribute(o['dim_attribute']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getTableName() {
        return this.tableName;
    }

    /**
     * (no documentation provided)
     *
     * @param string tableName
     */
    setTableName(tableName) {
        this.tableName = tableName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XMeasure
     */
    getMeasure() {
        return this.measure;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XMeasure measure
     */
    setMeasure(measure) {
        this.measure = measure;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XExprColumn
     */
    getExpression() {
        return this.expression;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XExprColumn expression
     */
    setExpression(expression) {
        this.expression = expression;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttribute
     */
    getDimAttribute() {
        return this.dimAttribute;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttribute dimAttribute
     */
    setDimAttribute(dimAttribute) {
        this.dimAttribute = dimAttribute;
    }

    /**
     * Returns a JSON object for this XFlattenedColumn
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.tableName !== 'undefined') {
            json['table_name'] = this.tableName;
        }
        if (typeof this.measure !== 'undefined') {
            json['measure'] = this.measure.toJSON();
        }
        if (typeof this.expression !== 'undefined') {
            json['expression'] = this.expression.toJSON();
        }
        if (typeof this.dimAttribute !== 'undefined') {
            json['dim_attribute'] = this.dimAttribute.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ResourceModifiedResponse = class {

    /**
     * Constructs a ResourceModifiedResponse from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['resource'] !== 'undefined') {
            this.resource = o['resource'];
        }
        if (typeof o['status'] !== 'undefined') {
            this.status = o['status'];
        }
    }

    /**
     * ID of the affected resource
     *
     * @return integer
     */
    getId() {
        return this.id;
    }

    /**
     * ID of the affected resource
     *
     * @param integer id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * The resource type
     *
     * @return string
     */
    getResource() {
        return this.resource;
    }

    /**
     * The resource type
     *
     * @param string resource
     */
    setResource(resource) {
        this.resource = resource;
    }
    /**
     * The action performed on the reource
     *
     * @return string
     */
    getStatus() {
        return this.status;
    }

    /**
     * The action performed on the reource
     *
     * @param string status
     */
    setStatus(status) {
        this.status = status;
    }

    /**
     * Returns a JSON object for this ResourceModifiedResponse
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.resource !== 'undefined') {
            json['resource'] = this.resource;
        }
        if (typeof this.status !== 'undefined') {
            json['status'] = this.status;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun = class {

    /**
     * Constructs a SchedulerJobInstanceRun from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handle'] !== 'undefined') {
            this.handle = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle(o['handle']);
        }
        if (typeof o['runId'] !== 'undefined') {
            this.runId = o['runId'];
        }
        if (typeof o['sessionHandle'] !== 'undefined') {
            this.sessionHandle = new exports.Org.Apache.Lens.Api.LensSessionHandle(o['sessionHandle']);
        }
        if (typeof o['startTime'] !== 'undefined') {
            this.startTime = o['startTime'];
        }
        if (typeof o['endTime'] !== 'undefined') {
            this.endTime = o['endTime'];
        }
        if (typeof o['resultPath'] !== 'undefined') {
            this.resultPath = o['resultPath'];
        }
        if (typeof o['queryHandle'] !== 'undefined') {
            this.queryHandle = new exports.Org.Apache.Lens.Api.Query.QueryHandle(o['queryHandle']);
        }
        if (typeof o['instanceState'] !== 'undefined') {
            this.instanceState = o['instanceState'];
        }
    }

    /**
     * the handle
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle
     */
    getHandle() {
        return this.handle;
    }

    /**
     * the handle
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle handle
     */
    setHandle(handle) {
        this.handle = handle;
    }
    /**
     * the runId
     *
     * @return integer
     */
    getRunId() {
        return this.runId;
    }

    /**
     * the runId
     *
     * @param integer runId
     */
    setRunId(runId) {
        this.runId = runId;
    }
    /**
     * session handle for this instance run.
     *
     * @return Org.Apache.Lens.Api.LensSessionHandle
     */
    getSessionHandle() {
        return this.sessionHandle;
    }

    /**
     * session handle for this instance run.
     *
     * @param Org.Apache.Lens.Api.LensSessionHandle sessionHandle
     */
    setSessionHandle(sessionHandle) {
        this.sessionHandle = sessionHandle;
    }
    /**
     * actual start time of this instance run .
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * actual start time of this instance run .
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * actual finish time of this instance run.
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * actual finish time of this instance run.
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }
    /**
     * result path of this instance run.
     *
     * @return string
     */
    getResultPath() {
        return this.resultPath;
    }

    /**
     * result path of this instance run.
     *
     * @param string resultPath
     */
    setResultPath(resultPath) {
        this.resultPath = resultPath;
    }
    /**
     * queryHandle of this instance run.
     *
     * @return Org.Apache.Lens.Api.Query.QueryHandle
     */
    getQueryHandle() {
        return this.queryHandle;
    }

    /**
     * queryHandle of this instance run.
     *
     * @param Org.Apache.Lens.Api.Query.QueryHandle queryHandle
     */
    setQueryHandle(queryHandle) {
        this.queryHandle = queryHandle;
    }
    /**
     * status of this instance.
     *
     * @return string
     */
    getInstanceState() {
        return this.instanceState;
    }

    /**
     * status of this instance.
     *
     * @param string instanceState
     */
    setInstanceState(instanceState) {
        this.instanceState = instanceState;
    }

    /**
     * Returns a JSON object for this SchedulerJobInstanceRun
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handle !== 'undefined') {
            json['handle'] = this.handle.toJSON();
        }
        if (typeof this.runId !== 'undefined') {
            json['runId'] = this.runId;
        }
        if (typeof this.sessionHandle !== 'undefined') {
            json['sessionHandle'] = this.sessionHandle.toJSON();
        }
        if (typeof this.startTime !== 'undefined') {
            json['startTime'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['endTime'] = this.endTime;
        }
        if (typeof this.resultPath !== 'undefined') {
            json['resultPath'] = this.resultPath;
        }
        if (typeof this.queryHandle !== 'undefined') {
            json['queryHandle'] = this.queryHandle.toJSON();
        }
        if (typeof this.instanceState !== 'undefined') {
            json['instanceState'] = this.instanceState;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XField = class {

    /**
     * Constructs a XField from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['tags'] !== 'undefined') {
            this.tags = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['tags']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getTags() {
        return this.tags;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties tags
     */
    setTags(tags) {
        this.tags = tags;
    }

    /**
     * Returns a JSON object for this XField
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.tags !== 'undefined') {
            json['tags'] = this.tags.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XMeasure = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XMeasure from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['_type'] !== 'undefined') {
            this.type = o['_type'];
        }
        if (typeof o['default_aggr'] !== 'undefined') {
            this.defaultAggr = o['default_aggr'];
        }
        if (typeof o['format_string'] !== 'undefined') {
            this.formatString = o['format_string'];
        }
        if (typeof o['start_time'] !== 'undefined') {
            this.startTime = o['start_time'];
        }
        if (typeof o['end_time'] !== 'undefined') {
            this.endTime = o['end_time'];
        }
        if (typeof o['unit'] !== 'undefined') {
            this.unit = o['unit'];
        }
        if (typeof o['min'] !== 'undefined') {
            this.min = o['min'];
        }
        if (typeof o['max'] !== 'undefined') {
            this.max = o['max'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * (no documentation provided)
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getDefaultAggr() {
        return this.defaultAggr;
    }

    /**
     * (no documentation provided)
     *
     * @param string defaultAggr
     */
    setDefaultAggr(defaultAggr) {
        this.defaultAggr = defaultAggr;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getFormatString() {
        return this.formatString;
    }

    /**
     * (no documentation provided)
     *
     * @param string formatString
     */
    setFormatString(formatString) {
        this.formatString = formatString;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getUnit() {
        return this.unit;
    }

    /**
     * (no documentation provided)
     *
     * @param string unit
     */
    setUnit(unit) {
        this.unit = unit;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    getMin() {
        return this.min;
    }

    /**
     * (no documentation provided)
     *
     * @param double min
     */
    setMin(min) {
        this.min = min;
    }
    /**
     * (no documentation provided)
     *
     * @return double
     */
    getMax() {
        return this.max;
    }

    /**
     * (no documentation provided)
     *
     * @param double max
     */
    setMax(max) {
        this.max = max;
    }

    /**
     * Returns a JSON object for this XMeasure
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.type !== 'undefined') {
            json['_type'] = this.type;
        }
        if (typeof this.defaultAggr !== 'undefined') {
            json['default_aggr'] = this.defaultAggr;
        }
        if (typeof this.formatString !== 'undefined') {
            json['format_string'] = this.formatString;
        }
        if (typeof this.startTime !== 'undefined') {
            json['start_time'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['end_time'] = this.endTime;
        }
        if (typeof this.unit !== 'undefined') {
            json['unit'] = this.unit;
        }
        if (typeof this.min !== 'undefined') {
            json['min'] = this.min;
        }
        if (typeof this.max !== 'undefined') {
            json['max'] = this.max;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.Action = {

    /**
     * Resource is created
     */
    CREATED: "CREATED", 

    /**
     * Resource is updated
     */
    UPDATED: "UPDATED", 

    /**
     * Resource is updated
     */
    DELETED: "DELETED"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle = class {

    /**
     * Constructs a SchedulerJobInstanceHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handleId'] !== 'undefined') {
            this.handleId = o['handleId'];
        }
        if (typeof o['handleIdString'] !== 'undefined') {
            this.handleIdString = o['handleIdString'];
        }
    }

    /**
     * The handle id.
     *
     * @return string
     */
    getHandleId() {
        return this.handleId;
    }

    /**
     * The handle id.
     *
     * @param string handleId
     */
    setHandleId(handleId) {
        this.handleId = handleId;
    }
    /**
     * handleId as a string.
     *
     * @return string
     */
    getHandleIdString() {
        return this.handleIdString;
    }

    /**
     * handleId as a string.
     *
     * @param string handleIdString
     */
    setHandleIdString(handleIdString) {
        this.handleIdString = handleIdString;
    }

    /**
     * Returns a JSON object for this SchedulerJobInstanceHandle
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handleId !== 'undefined') {
            json['handleId'] = this.handleId;
        }
        if (typeof this.handleIdString !== 'undefined') {
            json['handleIdString'] = this.handleIdString;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XSegment = class {

    /**
     * Constructs a XSegment from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['cube_name'] !== 'undefined') {
            this.cubeName = o['cube_name'];
        }
        if (typeof o['segment_parameters'] !== 'undefined') {
            this.segmentParameters = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['segment_parameters']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getCubeName() {
        return this.cubeName;
    }

    /**
     * (no documentation provided)
     *
     * @param string cubeName
     */
    setCubeName(cubeName) {
        this.cubeName = cubeName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getSegmentParameters() {
        return this.segmentParameters;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties segmentParameters
     */
    setSegmentParameters(segmentParameters) {
        this.segmentParameters = segmentParameters;
    }

    /**
     * Returns a JSON object for this XSegment
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.cubeName !== 'undefined') {
            json['cube_name'] = this.cubeName;
        }
        if (typeof this.segmentParameters !== 'undefined') {
            json['segment_parameters'] = this.segmentParameters.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryResult = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a QueryResult from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
    }


    /**
     * Returns a JSON object for this QueryResult
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimAttribute = class extends exports.Org.Apache.Lens.Api.Metastore.XField {

    /**
     * Constructs a XDimAttribute from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['_type'] !== 'undefined') {
            this.type = o['_type'];
        }
        this.chainRefColumn = [];
        if (o['chain_ref_column']) {
            o['chain_ref_column'].forEach(function(x, i){
                self.chainRefColumn[i] = new exports.Org.Apache.Lens.Api.Metastore.XChainColumn(x);
            });
        }
        if (typeof o['hierarchy'] !== 'undefined') {
            this.hierarchy = new exports.Org.Apache.Lens.Api.Metastore.XDimAttributes(o['hierarchy']);
        }
        this.values = [];
        if (o['values']) {
            o['values'].forEach(function(x, i){
                self.values[i] = x;
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * (no documentation provided)
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XChainColumn[]
     */
    getChainRefColumn() {
        return this.chainRefColumn;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XChainColumn[] chainRefColumn
     */
    setChainRefColumn(chainRefColumn) {
        this.chainRefColumn = chainRefColumn;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttributes
     */
    getHierarchy() {
        return this.hierarchy;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttributes hierarchy
     */
    setHierarchy(hierarchy) {
        this.hierarchy = hierarchy;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    getValues() {
        return this.values;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] values
     */
    setValues(values) {
        this.values = values;
    }

    /**
     * Returns a JSON object for this XDimAttribute
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.type !== 'undefined') {
            json['_type'] = this.type;
        }
        if (this.chainRefColumn) {
            json['chain_ref_column'] = [];
            this.chainRefColumn.forEach(function(x, i){
                json['chain_ref_column'][i] = x.toJSON();
            });
        }
        if (typeof this.hierarchy !== 'undefined') {
            json['hierarchy'] = this.hierarchy.toJSON();
        }
        if (this.values) {
            json['values'] = [];
            this.values.forEach(function(x, i){
                json['values'][i] = x;
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query');
exports.Org.Apache.Lens.Api.Query.QueryHandle = class extends exports.Org.Apache.Lens.Api.Query.QuerySubmitResult {

    /**
     * Constructs a QueryHandle from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['handleId'] !== 'undefined') {
            this.handleId = o['handleId'];
        }
        if (typeof o['handleIdString'] !== 'undefined') {
            this.handleIdString = o['handleIdString'];
        }
    }

    /**
     * The handle id.
     *
     * @return string
     */
    getHandleId() {
        return this.handleId;
    }

    /**
     * The handle id.
     *
     * @param string handleId
     */
    setHandleId(handleId) {
        this.handleId = handleId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getHandleIdString() {
        return this.handleIdString;
    }

    /**
     * (no documentation provided)
     *
     * @param string handleIdString
     */
    setHandleIdString(handleIdString) {
        this.handleIdString = handleIdString;
    }

    /**
     * Returns a JSON object for this QueryHandle
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.handleId !== 'undefined') {
            json['handleId'] = this.handleId;
        }
        if (typeof this.handleIdString !== 'undefined') {
            json['handleIdString'] = this.handleIdString;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XPartSpecElement = class {

    /**
     * Constructs a XPartSpecElement from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['key'] !== 'undefined') {
            this.key = o['key'];
        }
        if (typeof o['value'] !== 'undefined') {
            this.value = o['value'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getKey() {
        return this.key;
    }

    /**
     * (no documentation provided)
     *
     * @param string key
     */
    setKey(key) {
        this.key = key;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getValue() {
        return this.value;
    }

    /**
     * (no documentation provided)
     *
     * @param string value
     */
    setValue(value) {
        this.value = value;
    }

    /**
     * Returns a JSON object for this XPartSpecElement
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.key !== 'undefined') {
            json['key'] = this.key;
        }
        if (typeof this.value !== 'undefined') {
            json['value'] = this.value;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XCube = class {

    /**
     * Constructs a XCube from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['properties'] !== 'undefined') {
            this.properties = new exports.Org.Apache.Lens.Api.Metastore.XProperties(o['properties']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XProperties
     */
    getProperties() {
        return this.properties;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XProperties properties
     */
    setProperties(properties) {
        this.properties = properties;
    }

    /**
     * Returns a JSON object for this XCube
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.properties !== 'undefined') {
            json['properties'] = this.properties.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XExpressions = class {

    /**
     * Constructs a XExpressions from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.expression = [];
        if (o['expression']) {
            o['expression'].forEach(function(x, i){
                self.expression[i] = new exports.Org.Apache.Lens.Api.Metastore.XExprColumn(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XExprColumn[]
     */
    getExpression() {
        return this.expression;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XExprColumn[] expression
     */
    setExpression(expression) {
        this.expression = expression;
    }

    /**
     * Returns a JSON object for this XExpressions
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.expression) {
            json['expression'] = [];
            this.expression.forEach(function(x, i){
                json['expression'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XTableReference = class {

    /**
     * Constructs a XTableReference from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['table'] !== 'undefined') {
            this.table = o['table'];
        }
        if (typeof o['column'] !== 'undefined') {
            this.column = o['column'];
        }
        if (typeof o['maps_to_many'] !== 'undefined') {
            this.mapsToMany = o['maps_to_many'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getTable() {
        return this.table;
    }

    /**
     * (no documentation provided)
     *
     * @param string table
     */
    setTable(table) {
        this.table = table;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getColumn() {
        return this.column;
    }

    /**
     * (no documentation provided)
     *
     * @param string column
     */
    setColumn(column) {
        this.column = column;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    getMapsToMany() {
        return this.mapsToMany;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean mapsToMany
     */
    setMapsToMany(mapsToMany) {
        this.mapsToMany = mapsToMany;
    }

    /**
     * Returns a JSON object for this XTableReference
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.table !== 'undefined') {
            json['table'] = this.table;
        }
        if (typeof this.column !== 'undefined') {
            json['column'] = this.column;
        }
        if (typeof this.mapsToMany !== 'undefined') {
            json['maps_to_many'] = this.mapsToMany;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api');
exports.Org.Apache.Lens.Api.DateTime = class extends exports.Org.Apache.Lens.Api.ToYAMLString {

    /**
     * Constructs a DateTime from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        super(o);
        var self = this;
        if (typeof o['date'] !== 'undefined') {
            this.date = o['date'];
        }
    }

    /**
     * The Date.
     *
     * @return integer
     */
    getDate() {
        return this.date;
    }

    /**
     * The Date.
     *
     * @param integer date
     */
    setDate(date) {
        this.date = date;
    }

    /**
     * Returns a JSON object for this DateTime
     *
     * @return object
     */
    toJSON() {
        var json = super.toJSON();
        var self = this;
        if (typeof this.date !== 'undefined') {
            json['date'] = this.date;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceInfo = class {

    /**
     * Constructs a SchedulerJobInstanceInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle(o['id']);
        }
        if (typeof o['jobId'] !== 'undefined') {
            this.jobId = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle(o['jobId']);
        }
        if (typeof o['scheduleTime'] !== 'undefined') {
            this.scheduleTime = o['scheduleTime'];
        }
        this.instanceRunList = [];
        if (o['instanceRunList']) {
            o['instanceRunList'].forEach(function(x, i){
                self.instanceRunList[i] = new exports.Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun(x);
            });
        }
    }

    /**
     * unique id for this instance of scheduler job.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle
     */
    getId() {
        return this.id;
    }

    /**
     * unique id for this instance of scheduler job.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceHandle id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle
     */
    getJobId() {
        return this.jobId;
    }

    /**
     * id for the scheduler job to which this instance belongs.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobHandle jobId
     */
    setJobId(jobId) {
        this.jobId = jobId;
    }
    /**
     * scheduled time of this instance.
     *
     * @return integer
     */
    getScheduleTime() {
        return this.scheduleTime;
    }

    /**
     * scheduled time of this instance.
     *
     * @param integer scheduleTime
     */
    setScheduleTime(scheduleTime) {
        this.scheduleTime = scheduleTime;
    }
    /**
     * A list of instance-run for this instance.
     *
     * @return Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun[]
     */
    getInstanceRunList() {
        return this.instanceRunList;
    }

    /**
     * A list of instance-run for this instance.
     *
     * @param Org.Apache.Lens.Api.Scheduler.SchedulerJobInstanceRun[] instanceRunList
     */
    setInstanceRunList(instanceRunList) {
        this.instanceRunList = instanceRunList;
    }

    /**
     * Returns a JSON object for this SchedulerJobInstanceInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id.toJSON();
        }
        if (typeof this.jobId !== 'undefined') {
            json['jobId'] = this.jobId.toJSON();
        }
        if (typeof this.scheduleTime !== 'undefined') {
            json['scheduleTime'] = this.scheduleTime;
        }
        if (this.instanceRunList) {
            json['instanceRunList'] = [];
            this.instanceRunList.forEach(function(x, i){
                json['instanceRunList'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.SavedQuery = class {

    /**
     * Constructs a SavedQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['id'] !== 'undefined') {
            this.id = o['id'];
        }
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['description'] !== 'undefined') {
            this.description = o['description'];
        }
        if (typeof o['query'] !== 'undefined') {
            this.query = o['query'];
        }
        this.parameters = [];
        if (o['parameters']) {
            o['parameters'].forEach(function(x, i){
                self.parameters[i] = new exports.Org.Apache.Lens.Api.Query.Save.Parameter(x);
            });
        }
    }

    /**
     * ID of the saved query (unique)
     *
     * @return integer
     */
    getId() {
        return this.id;
    }

    /**
     * ID of the saved query (unique)
     *
     * @param integer id
     */
    setId(id) {
        this.id = id;
    }
    /**
     * Name of the saved query
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * Name of the saved query
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * Description of the saved query
     *
     * @return string
     */
    getDescription() {
        return this.description;
    }

    /**
     * Description of the saved query
     *
     * @param string description
     */
    setDescription(description) {
        this.description = description;
    }
    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @return string
     */
    getQuery() {
        return this.query;
    }

    /**
     * The actual query. Should adhere to HQL syntax
     *
     * @param string query
     */
    setQuery(query) {
        this.query = query;
    }
    /**
     * Parameters that are used in the query
     *
     * @return Org.Apache.Lens.Api.Query.Save.Parameter[]
     */
    getParameters() {
        return this.parameters;
    }

    /**
     * Parameters that are used in the query
     *
     * @param Org.Apache.Lens.Api.Query.Save.Parameter[] parameters
     */
    setParameters(parameters) {
        this.parameters = parameters;
    }

    /**
     * Returns a JSON object for this SavedQuery
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.id !== 'undefined') {
            json['id'] = this.id;
        }
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.description !== 'undefined') {
            json['description'] = this.description;
        }
        if (typeof this.query !== 'undefined') {
            json['query'] = this.query;
        }
        if (this.parameters) {
            json['parameters'] = [];
            this.parameters.forEach(function(x, i){
                json['parameters'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XJob = class {

    /**
     * Constructs a XJob from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['execution'] !== 'undefined') {
            this.execution = new exports.Org.Apache.Lens.Api.Scheduler.XExecution(o['execution']);
        }
        if (typeof o['trigger'] !== 'undefined') {
            this.trigger = new exports.Org.Apache.Lens.Api.Scheduler.XTrigger(o['trigger']);
        }
        this.jobConf = [];
        if (o['job_conf']) {
            o['job_conf'].forEach(function(x, i){
                self.jobConf[i] = new exports.Org.Apache.Lens.Api.Scheduler.MapType(x);
            });
        }
        if (typeof o['start_time'] !== 'undefined') {
            this.startTime = o['start_time'];
        }
        if (typeof o['end_time'] !== 'undefined') {
            this.endTime = o['end_time'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * (no documentation provided)
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.XExecution
     */
    getExecution() {
        return this.execution;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.XExecution execution
     */
    setExecution(execution) {
        this.execution = execution;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.XTrigger
     */
    getTrigger() {
        return this.trigger;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.XTrigger trigger
     */
    setTrigger(trigger) {
        this.trigger = trigger;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.MapType[]
     */
    getJobConf() {
        return this.jobConf;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.MapType[] jobConf
     */
    setJobConf(jobConf) {
        this.jobConf = jobConf;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getStartTime() {
        return this.startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer startTime
     */
    setStartTime(startTime) {
        this.startTime = startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getEndTime() {
        return this.endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer endTime
     */
    setEndTime(endTime) {
        this.endTime = endTime;
    }

    /**
     * Returns a JSON object for this XJob
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.execution !== 'undefined') {
            json['execution'] = this.execution.toJSON();
        }
        if (typeof this.trigger !== 'undefined') {
            json['trigger'] = this.trigger.toJSON();
        }
        if (this.jobConf) {
            json['job_conf'] = [];
            this.jobConf.forEach(function(x, i){
                json['job_conf'][i] = x.toJSON();
            });
        }
        if (typeof this.startTime !== 'undefined') {
            json['start_time'] = this.startTime;
        }
        if (typeof this.endTime !== 'undefined') {
            json['end_time'] = this.endTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.ResourcePath = class {

    /**
     * Constructs a ResourcePath from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['path'] !== 'undefined') {
            this.path = o['path'];
        }
        if (typeof o['type'] !== 'undefined') {
            this.type = o['type'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getPath() {
        return this.path;
    }

    /**
     * (no documentation provided)
     *
     * @param string path
     */
    setPath(path) {
        this.path = path;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getType() {
        return this.type;
    }

    /**
     * (no documentation provided)
     *
     * @param string type
     */
    setType(type) {
        this.type = type;
    }

    /**
     * Returns a JSON object for this ResourcePath
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.path !== 'undefined') {
            json['path'] = this.path;
        }
        if (typeof this.type !== 'undefined') {
            json['type'] = this.type;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XJobQuery = class {

    /**
     * Constructs a XJobQuery from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['query'] !== 'undefined') {
            this.query = o['query'];
        }
        this.conf = [];
        if (o['conf']) {
            o['conf'].forEach(function(x, i){
                self.conf[i] = new exports.Org.Apache.Lens.Api.Scheduler.MapType(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getQuery() {
        return this.query;
    }

    /**
     * (no documentation provided)
     *
     * @param string query
     */
    setQuery(query) {
        this.query = query;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.MapType[]
     */
    getConf() {
        return this.conf;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.MapType[] conf
     */
    setConf(conf) {
        this.conf = conf;
    }

    /**
     * Returns a JSON object for this XJobQuery
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.query !== 'undefined') {
            json['query'] = this.query;
        }
        if (this.conf) {
            json['conf'] = [];
            this.conf.forEach(function(x, i){
                json['conf'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XJoinChains = class {

    /**
     * Constructs a XJoinChains from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.joinChain = [];
        if (o['join_chain']) {
            o['join_chain'].forEach(function(x, i){
                self.joinChain[i] = new exports.Org.Apache.Lens.Api.Metastore.XJoinChain(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XJoinChain[]
     */
    getJoinChain() {
        return this.joinChain;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XJoinChain[] joinChain
     */
    setJoinChain(joinChain) {
        this.joinChain = joinChain;
    }

    /**
     * Returns a JSON object for this XJoinChains
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.joinChain) {
            json['join_chain'] = [];
            this.joinChain.forEach(function(x, i){
                json['join_chain'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.Parameter = class {

    /**
     * Constructs a Parameter from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['name'] !== 'undefined') {
            this.name = o['name'];
        }
        if (typeof o['displayName'] !== 'undefined') {
            this.displayName = o['displayName'];
        }
        this.defaultValue = [];
        if (o['defaultValue']) {
            o['defaultValue'].forEach(function(x, i){
                self.defaultValue[i] = x;
            });
        }
        if (typeof o['dataType'] !== 'undefined') {
            this.dataType = o['dataType'];
        }
        if (typeof o['collectionType'] !== 'undefined') {
            this.collectionType = o['collectionType'];
        }
    }

    /**
     * Name of the parameter used in the query.
       * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @return string
     */
    getName() {
        return this.name;
    }

    /**
     * Name of the parameter used in the query.
       * It should match the following regex pattern &quot;:[a-zA-Z][a-zA-Z_0-9]&quot;.
     *
     * @param string name
     */
    setName(name) {
        this.name = name;
    }
    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @return string
     */
    getDisplayName() {
        return this.displayName;
    }

    /**
     * Display name of the parameter. Should be used by the UI apps for resolution.
     *
     * @param string displayName
     */
    setDisplayName(displayName) {
        this.displayName = displayName;
    }
    /**
     * The default value that will be used,
       * if the parameter is not supplied with any values while running the query.
     *
     * @return string[]
     */
    getDefaultValue() {
        return this.defaultValue;
    }

    /**
     * The default value that will be used,
       * if the parameter is not supplied with any values while running the query.
     *
     * @param string[] defaultValue
     */
    setDefaultValue(defaultValue) {
        this.defaultValue = defaultValue;
    }
    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
       * The value supplied will be parsed with the corresponding data type.
     *
     * @return string
     */
    getDataType() {
        return this.dataType;
    }

    /**
     * Data type of the parameter. Could be number, decimal, string or boolean.
       * The value supplied will be parsed with the corresponding data type.
     *
     * @param string dataType
     */
    setDataType(dataType) {
        this.dataType = dataType;
    }
    /**
     * Collection type of the parameter.
       * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @return string
     */
    getCollectionType() {
        return this.collectionType;
    }

    /**
     * Collection type of the parameter.
       * Depending on the type of expression IN/EQ, it could be a single/multiple collection.
     *
     * @param string collectionType
     */
    setCollectionType(collectionType) {
        this.collectionType = collectionType;
    }

    /**
     * Returns a JSON object for this Parameter
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.name !== 'undefined') {
            json['name'] = this.name;
        }
        if (typeof this.displayName !== 'undefined') {
            json['displayName'] = this.displayName;
        }
        if (this.defaultValue) {
            json['defaultValue'] = [];
            this.defaultValue.forEach(function(x, i){
                json['defaultValue'][i] = x;
            });
        }
        if (typeof this.dataType !== 'undefined') {
            json['dataType'] = this.dataType;
        }
        if (typeof this.collectionType !== 'undefined') {
            json['collectionType'] = this.collectionType;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XDimAttributes = class {

    /**
     * Constructs a XDimAttributes from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        this.dimAttribute = [];
        if (o['dim_attribute']) {
            o['dim_attribute'].forEach(function(x, i){
                self.dimAttribute[i] = new exports.Org.Apache.Lens.Api.Metastore.XDimAttribute(x);
            });
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XDimAttribute[]
     */
    getDimAttribute() {
        return this.dimAttribute;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XDimAttribute[] dimAttribute
     */
    setDimAttribute(dimAttribute) {
        this.dimAttribute = dimAttribute;
    }

    /**
     * Returns a JSON object for this XDimAttributes
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (this.dimAttribute) {
            json['dim_attribute'] = [];
            this.dimAttribute.forEach(function(x, i){
                json['dim_attribute'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ListResponse = class {

    /**
     * Constructs a ListResponse from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['offsetAppplied'] !== 'undefined') {
            this.offsetAppplied = o['offsetAppplied'];
        }
        if (typeof o['totalCount'] !== 'undefined') {
            this.totalCount = o['totalCount'];
        }
        this.resoures = [];
        if (o['resoures']) {
            o['resoures'].forEach(function(x, i){
                self.resoures[i] = new exports.Org.Apache.Lens.Api.Query.Save.SavedQuery(x);
            });
        }
    }

    /**
     * The starting offset of the result set.
     *
     * @return integer
     */
    getOffsetAppplied() {
        return this.offsetAppplied;
    }

    /**
     * The starting offset of the result set.
     *
     * @param integer offsetAppplied
     */
    setOffsetAppplied(offsetAppplied) {
        this.offsetAppplied = offsetAppplied;
    }
    /**
     * The total number of queries returned in the current request.
     *
     * @return integer
     */
    getTotalCount() {
        return this.totalCount;
    }

    /**
     * The total number of queries returned in the current request.
     *
     * @param integer totalCount
     */
    setTotalCount(totalCount) {
        this.totalCount = totalCount;
    }
    /**
     * The queries.
     *
     * @return Org.Apache.Lens.Api.Query.Save.SavedQuery[]
     */
    getResoures() {
        return this.resoures;
    }

    /**
     * The queries.
     *
     * @param Org.Apache.Lens.Api.Query.Save.SavedQuery[] resoures
     */
    setResoures(resoures) {
        this.resoures = resoures;
    }

    /**
     * Returns a JSON object for this ListResponse
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.offsetAppplied !== 'undefined') {
            json['offsetAppplied'] = this.offsetAppplied;
        }
        if (typeof this.totalCount !== 'undefined') {
            json['totalCount'] = this.totalCount;
        }
        if (this.resoures) {
            json['resoures'] = [];
            this.resoures.forEach(function(x, i){
                json['resoures'][i] = x.toJSON();
            });
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Metastore');
exports.Org.Apache.Lens.Api.Metastore.XUpdatePeriodTableDescriptor = class {

    /**
     * Constructs a XUpdatePeriodTableDescriptor from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['update_period'] !== 'undefined') {
            this.updatePeriod = o['update_period'];
        }
        if (typeof o['table_desc'] !== 'undefined') {
            this.tableDesc = new exports.Org.Apache.Lens.Api.Metastore.XStorageTableDesc(o['table_desc']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getUpdatePeriod() {
        return this.updatePeriod;
    }

    /**
     * (no documentation provided)
     *
     * @param string updatePeriod
     */
    setUpdatePeriod(updatePeriod) {
        this.updatePeriod = updatePeriod;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Metastore.XStorageTableDesc
     */
    getTableDesc() {
        return this.tableDesc;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Metastore.XStorageTableDesc tableDesc
     */
    setTableDesc(tableDesc) {
        this.tableDesc = tableDesc;
    }

    /**
     * Returns a JSON object for this XUpdatePeriodTableDescriptor
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.updatePeriod !== 'undefined') {
            json['update_period'] = this.updatePeriod;
        }
        if (typeof this.tableDesc !== 'undefined') {
            json['table_desc'] = this.tableDesc.toJSON();
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XFrequency = class {

    /**
     * Constructs a XFrequency from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['timezone'] !== 'undefined') {
            this.timezone = o['timezone'];
        }
        if (typeof o['enum'] !== 'undefined') {
            this._enum = o['enum'];
        }
        if (typeof o['cron_expression'] !== 'undefined') {
            this.cronExpression = o['cron_expression'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getTimezone() {
        return this.timezone;
    }

    /**
     * (no documentation provided)
     *
     * @param string timezone
     */
    setTimezone(timezone) {
        this.timezone = timezone;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    get_enum() {
        return this._enum;
    }

    /**
     * (no documentation provided)
     *
     * @param string _enum
     */
    set_enum(_enum) {
        this._enum = _enum;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getCronExpression() {
        return this.cronExpression;
    }

    /**
     * (no documentation provided)
     *
     * @param string cronExpression
     */
    setCronExpression(cronExpression) {
        this.cronExpression = cronExpression;
    }

    /**
     * Returns a JSON object for this XFrequency
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.timezone !== 'undefined') {
            json['timezone'] = this.timezone;
        }
        if (typeof this._enum !== 'undefined') {
            json['enum'] = this._enum;
        }
        if (typeof this.cronExpression !== 'undefined') {
            json['cron_expression'] = this.cronExpression;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Session');
exports.Org.Apache.Lens.Api.Session.UserSessionInfo = class {

    /**
     * Constructs a UserSessionInfo from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['handle'] !== 'undefined') {
            this.handle = o['handle'];
        }
        if (typeof o['userName'] !== 'undefined') {
            this.userName = o['userName'];
        }
        this.activeQueries = [];
        if (o['activeQueries']) {
            o['activeQueries'].forEach(function(x, i){
                self.activeQueries[i] = new exports.Org.Apache.Lens.Api.Query.QueryHandle(x);
            });
        }
        if (typeof o['creationTime'] !== 'undefined') {
            this.creationTime = o['creationTime'];
        }
        if (typeof o['lastAccessTime'] !== 'undefined') {
            this.lastAccessTime = o['lastAccessTime'];
        }
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    getHandle() {
        return this.handle;
    }

    /**
     * (no documentation provided)
     *
     * @param string handle
     */
    setHandle(handle) {
        this.handle = handle;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    getUserName() {
        return this.userName;
    }

    /**
     * (no documentation provided)
     *
     * @param string userName
     */
    setUserName(userName) {
        this.userName = userName;
    }
    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Query.QueryHandle[]
     */
    getActiveQueries() {
        return this.activeQueries;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Query.QueryHandle[] activeQueries
     */
    setActiveQueries(activeQueries) {
        this.activeQueries = activeQueries;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getCreationTime() {
        return this.creationTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer creationTime
     */
    setCreationTime(creationTime) {
        this.creationTime = creationTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    getLastAccessTime() {
        return this.lastAccessTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer lastAccessTime
     */
    setLastAccessTime(lastAccessTime) {
        this.lastAccessTime = lastAccessTime;
    }

    /**
     * Returns a JSON object for this UserSessionInfo
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.handle !== 'undefined') {
            json['handle'] = this.handle;
        }
        if (typeof this.userName !== 'undefined') {
            json['userName'] = this.userName;
        }
        if (this.activeQueries) {
            json['activeQueries'] = [];
            this.activeQueries.forEach(function(x, i){
                json['activeQueries'][i] = x.toJSON();
            });
        }
        if (typeof this.creationTime !== 'undefined') {
            json['creationTime'] = this.creationTime;
        }
        if (typeof this.lastAccessTime !== 'undefined') {
            json['lastAccessTime'] = this.lastAccessTime;
        }
        return json;
    }

}

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Query.Save');
exports.Org.Apache.Lens.Api.Query.Save.ParameterDataType = {

    /**
     * String data type
     */
    STRING: "STRING", 

    /**
     * Number data type
     */
    NUMBER: "NUMBER", 

    /**
     * Decimal data type
     */
    DECIMAL: "DECIMAL", 

    /**
     * Boolean data type
     */
    BOOLEAN: "BOOLEAN"
};

/**
 * (no documentation provided)
 */
ensureNamespace('Org.Apache.Lens.Api.Scheduler');
exports.Org.Apache.Lens.Api.Scheduler.XTrigger = class {

    /**
     * Constructs a XTrigger from a JSON object
     *
     * @param Object o JSON object.
     */
    constructor(o) {
        var self = this;
        if (typeof o['frequency'] !== 'undefined') {
            this.frequency = new exports.Org.Apache.Lens.Api.Scheduler.XFrequency(o['frequency']);
        }
    }

    /**
     * (no documentation provided)
     *
     * @return Org.Apache.Lens.Api.Scheduler.XFrequency
     */
    getFrequency() {
        return this.frequency;
    }

    /**
     * (no documentation provided)
     *
     * @param Org.Apache.Lens.Api.Scheduler.XFrequency frequency
     */
    setFrequency(frequency) {
        this.frequency = frequency;
    }

    /**
     * Returns a JSON object for this XTrigger
     *
     * @return object
     */
    toJSON() {
        var json = {};
        var self = this;
        if (typeof this.frequency !== 'undefined') {
            json['frequency'] = this.frequency.toJSON();
        }
        return json;
    }

}
  
  /**
   * Ensures that a namespace exists.
   */
  function ensureNamespace(namespace){
    var current = exports;
    namespace.split('.').forEach(function(name){
      if(typeof current[name] === 'undefined'){
        current[name] = {};
      }
      current = current[name];
    });
  }

}));

